package PBXSComponents;

import ihm04.actions.Translate;
import interfaces.OriginGettable;
import interfaces.Positionable;
import interfaces.Translatable;

import org.w3c.dom.Element;

import queries.GetOrigin;
import test.interfaces.Locatable;
import test.queries.Location;
import actions.Position;
import dopidom.svg.SVGComponent;

/*
 * Created on 31 mars 2005
 *
 *  * Copyright 2004-2008 Frdric FONDEMENT
 */

/**
 * @author Fabrice H
 * 
 *  * Copyright 2004-2008 Frdric FONDEMENT
 */
public class ContainedGraphic extends SVGComponent {
	public ContainedGraphic(Element wrappedElement) {
		super(wrappedElement);
		new Translatable(this);
		new Positionable(this);
		new OriginGettable(this);
		new Locatable(this);
		checkInterfaces();
	}
	private void checkInterfaces() {
		if (!this.canDoQuery(Location.class))
			throw new RuntimeException("A ContainedGraphic must be Locatable");
		if (!this.canDoQuery(GetOrigin.class))
			throw new RuntimeException("A ContainedGraphic must be OriginGettable");
		if (!this.canDoAction(Translate.class))
			throw new RuntimeException("A ContainedGraphic must be Translatable");
		if (!this.canDoAction(Position.class))
			throw new RuntimeException("A ContainedGraphic must be Positionable");
	}
}