/*
 * Created on Apr 22, 2005
 *
 *  * Copyright 2004-2008 Frdric FONDEMENT
 */
package PBXSComponents;

import interfaces.Handlable;
import interfaces.Stickable;
import interfaces.Translatable;

import org.apache.batik.util.CSSConstants;
import org.apache.batik.util.SVGConstants;
import org.w3c.dom.Element;

import test.actions.SelectAction;
import test.interfaces.Containable;
import test.interfaces.ContainedHandlable;
import test.interfaces.ContainedTranslatable;
import test.interfaces.Hiligthtable;
import test.interfaces.Locatable;
import test.interfaces.Selectable;
import test.listeners.SVGActionInterfaceListener;
import test.listeners.SVGListenableActionInterface;
import utils.ComponentVarPersistant;
import utils.IntVarPersistant;
import dopidom.Action;
import dopidom.ActionEvent;
import dopidom.ActionInterface;
import dopidom.svg.SVGComponent;
import dopidom.svg.SVGScene;

/**
 * @author hong
 * 
 *  * Copyright 2004-2008 Frdric FONDEMENT
 */
public class LineHandle extends SVGComponent {
	
	protected class HandleSelectionListener implements SVGActionInterfaceListener {		
		public HandleSelectionListener() {
			LineHandle.this.getWrappedElement().setAttribute(CSSConstants.CSS_VISIBILITY_PROPERTY, CSSConstants.CSS_HIDDEN_VALUE);
		}

		public void handleEvent(String eventType, ActionInterface target, Action action) {
			if (target == LineHandle.this.getAttachedLine().getActionInterface(SelectAction.class) && (action instanceof SelectAction)) {
				LineHandle.this.getWrappedElement().setAttribute(CSSConstants.CSS_VISIBILITY_PROPERTY, eventType == ActionEvent.DO_ACTION_EVENT ? CSSConstants.CSS_VISIBLE_VALUE : CSSConstants.CSS_HIDDEN_VALUE);
			}
		}

		public boolean isValid() {
			return !LineHandle.this.isDeleted();
		}
		
	};
	
	protected final HandleSelectionListener selectionListener = new HandleSelectionListener(); 

	/**
	 * @param wrappedElement
	 */
	protected ComponentVarPersistant attachedLine = new ComponentVarPersistant(
			this.getWrappedElement(), "LineHandle", "attachedLine");

	protected IntVarPersistant hIndex = new IntVarPersistant(this
			.getWrappedElement(), "LineHandle", "hIndex");

	public LineHandle(Element wrappedElement) {
		super(wrappedElement);
		new Locatable(this);
		//new Handlable(this);
		new Stickable(this);
		//new Selectable(this);
		new Hiligthtable(this);
		//new OriginGettable(this);
		
		new Containable(this);
		new ContainedHandlable(this);

		if (hIndex.isSet()) {
			System.out.println("hIndex set, launching invokeLater");
			SVGScene.getInstance().invokeLater(new Runnable() {

				public synchronized void run() {
					//					while (hIndex.isFilling())
					//						try {
					//							wait(10);
					//						} catch (InterruptedException e) {
					//							// TODO Auto-generated catch block
					//							e.printStackTrace();
					//						}
					System.out.println("invokeLater setting ");
					ComponentVarPersistant lineP = LineHandle.this.attachedLine;
					if (lineP.isSet()) {
						((CurvedLine) lineP.get()).getLineDescription()
								.setLineHandle(LineHandle.this.getHIndex(),
										LineHandle.this);
						LineHandle.this.setAttachedLine((CurvedLine) lineP.get());
					} else
						throw new RuntimeException(
								"problem when loading the handle : wrong assignement in path (invoke latter)");
				}
			});
		} else
			System.out.println("hIndex not set");

	}

	/**
	 * @return Returns the hIndex.
	 */
	public int getHIndex() {
		if (!this.hIndex.isSet())
			throw new RuntimeException(
					"you are trying to get the index of the LineHandle since it has not been set (maybe you tried to add the lineHandle with non standard methods. try with lineDescription.addPoint (pt, hn, lineHandle), or with LineDescription.setLineHandle(index, lineHandle))");
		return hIndex.get();
	}

	/**
	 * @param index
	 *            The hIndex to set.
	 */
	public void setHIndex(int index) {
		hIndex.set(index);
	}

	public CurvedLine getAttachedLine() {
		return (CurvedLine) attachedLine.get();
	}

	public void setAttachedLine(CurvedLine attachedLine) {
		CurvedLine line = this.getAttachedLine();
		if (line != null)
			((SVGListenableActionInterface)line.getActionInterface(SelectAction.class)).removeListener(this.selectionListener);
		
		this.attachedLine.set(attachedLine);
		line = this.getAttachedLine();
		if (line != null)
			((SVGListenableActionInterface)line.getActionInterface(SelectAction.class)).addListener(this.selectionListener);
	}
}