/*
 * Created on 26 fvr. 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package actions;

import java.awt.geom.Line2D;
import java.awt.geom.Point2D;
import java.util.ArrayList;

import dopidom.svg.SVGAction;


/**
 * @author Olivier Beaudoux
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class GetBorderPoint extends SVGAction
{
	ArrayList points = new ArrayList();
	
	public GetBorderPoint () {
		super();
		fillListPoints();
	}
	
	private int getNearestPointIndex (int px, int py){
		double dstMin = Double.MAX_VALUE;
		double dst;
		int iMin = 0;
		for (int x = 0; x < points.size(); x++) {
			dst = ((Point2D)points.get(x)).distance (px, py);
			if (dst < dstMin)
			{
				dstMin = dst;
				iMin = x;
			}
		}
		return iMin;
	}
	
	private ArrayList getLinePairFromIndex (int i) {
		int nextPoint;
		ArrayList list = new ArrayList();
		Line2D l1 = new Line2D.Double();
		Line2D l2 = new Line2D.Double();
		if ( points.size() < 2)
			return list;
		else
		{
			if (i==points.size()-1)
				nextPoint = 0;
			else 
				nextPoint = i+1;
			l1.setLine( ((Point2D)points.get(i)).getX(), ((Point2D)points.get(i)).getY(),((Point2D)points.get(nextPoint)).getX(), ((Point2D)points.get(nextPoint)).getY());
			if (i==0)
				nextPoint = points.size()-1;
			else 
				nextPoint = i-1;
			l2.setLine( ((Point2D)points.get(nextPoint)).getX(), ((Point2D)points.get(nextPoint)).getY(),((Point2D)points.get(i)).getX(), ((Point2D)points.get(i)).getY());
		}
		list.add(l1);
		list.add(l2);
		return list;
	}
	
	public Point2D getNearestPointFromLinePair (ArrayList pair, double px, double py) {
		Line2D theLine1 = (Line2D)pair.get(0);
		Line2D theLine2 = new Line2D.Double();
		//if there is 2 line2 
		if(pair.size() > 1) {
			theLine2 = (Line2D)pair.get(1);
		}
		// if there is 2 lines
		if (pair.size() > 1) {
			if (theLine1.ptSegDist((double)px, (double)py) > theLine1.ptSegDist((double)px, (double)py))
				theLine1 = theLine2;
		}
		// if the point is not in range of the Line the nearest point will be the intersection of the two lines
		if (theLine1.ptLineDist((double)px, (double)py) < theLine1.ptSegDist((double)px, (double)py))
			return (Point2D)theLine1.getP2();
		else {
			double px1 = (double)(theLine1.getP1().getX());
			double px2 = (double)(theLine1.getP2().getX());
			double py1 = (double)(theLine1.getP1().getY());
			double py2 = (double)(theLine1.getP2().getY());
			double newX;
			double newY;
			if (px2 == px1) {
				newX = px1;
				newY = py;
			} else if (py2 == py1) {
				newX = px;
				newY = py1;
			}else {
				double pente = (py2 - py1)/(px2 - px1);
				double b = py1 - pente * px1;
				newX = (((double)px)/pente + py - b)/(pente + 1/pente);
				newY = pente * newX + b;
			}
			return new Point2D.Double (newX, newY);
		}
	}
	
	private void fillListPoints () {
		points.add (new Point2D.Double(23, 34));
		points.add (new Point2D.Double(13, 46));
		points.add (new Point2D.Double(26, 64));
		points.add (new Point2D.Double(34, 56));
		points.add (new Point2D.Double(1, 1));
	}
	
	public Point2D getBorderPoint (int x, int y) {
		return getNearestPointFromLinePair(getLinePairFromIndex(getNearestPointIndex(x,y)), x, y);
	}
	public String[] toStrings() {
		return new String[]{"1", "2"};
	}
}
