/*
 * Created on 11 fvr. 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package dopidom;

import org.w3c.dom.events.Event;

/**
 * We merge in this single class all events related to the production of actions, in a similar way
 * found in DOM-Events (such as in the DOM MutationEvent class).
 * @author Olivier Beaudoux
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public interface ActionEvent extends Event
{
	static final String BEGIN_INTERACTION_EVENT = "DoPIdom-BeginInteractionEvent";
	static final String END_INTERACTION_EVENT = "DoPIdom-EndInteractionEvent";
	static final String DO_ACTION_EVENT = "DoPIdom-DoActionEvent";
	static final String UNDO_ACTIONS_EVENT = "DoPIdom-UndoActionsEvent";
	static final String REDO_ACTIONS_EVENT = "DoPIdom-RedoActionsEvent";
	static final String ECHO_ACTIONS_EVENT = "DoPIdom-EchoActionsEvent";
	static final String REPLICATION_EVENT = "DoPIdom-ReplicationEvent";

	/**
	 * For BEGIN_INTERACTION_EVENT and END_INTERACTION_EVENT events
	 * @param type
	 * @param producer
	 * @param consumer
	 * @param actionClass
	 */
	void initActionEvent(String type, ActionProducer producer, ActionConsumer consumer, Class actionClass);

	/**
	 * For DO_ACTION_EVENT event
	 * @param type must be equal to DO_ACTION_EVENT
	 * @param producer
	 * @param consumer
	 * @param action
	 */
	void initActionEvent(String type, ActionProducer producer, ActionConsumer consumer, Action action);

	/**
	 * For UNDO_ACTIONS_EVENT, REDO_ACTIONS_EVENT and ECHO_ACTIONS_EVENT
	 * @param type
	 * @param producer
	 * @param consumer
	 * @param actions
	 */
	void initActionEvent(String type, ActionProducer producer, ActionConsumer consumer, Action[] actions);

	/** 
	 * For REPLICATION_EVENT
	 * @param type
	 * @param replicatedEvent
	 */
	void initActionEvent(String type, ActionEvent replicatedEvent);

	/**
	 * 
	 * @return
	 */
	ActionProducer getProducer();

	/**
	 * 
	 * @return
	 */
	ActionConsumer getConsumer();

	/**
	 * 
	 * @return
	 */
	Class getActionClass();

	/**
	 * 
	 * @return
	 */
	Action getAction();

	/**
	 * 
	 * @return
	 */
	Action[] getActions();

	/**
	 * 
	 * @return
	 */
	ActionEvent getReplicatedEvent();

	/**
	 * Stop propagation refined here (overloading) in order to take into account the "event-group" 
	 * which is a DOM Events 3 feature, while our implementation (I mean Batik...) is based on DOM Events 2.
	 */
	void stopPropagation(Object eventGroup);
}
