/*
 * Created on 11 fvr. 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package dopidom;

import org.w3c.dom.Element;

/**
 * @author Olivier Beaudoux
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public interface Markable
{
	Element getWrappedElement();

	Mark addMark(String xpath, boolean write);
	
	/**
	 * A data may be used to refine the marking grain.
	 * You can add a same mark to more than one node
	 * @param xpath the xpath expression that can result on a node-set
	 * @param write
	 * @param data
	 * @return
	 */
	Mark addMark(String xpath, boolean write, Object data);
	
	/**
	 * You can remove a mark to more than one node
	 * @param xpath
	 * @param write
	 * @return
	 */
	Mark removeMark(String xpath, boolean write); 
	
	/**
	 * Returns a mark array since a node-set may have multiple read-marks...
	 * You mainly use isMarked* methods rather than this one.
	 * You *must* specify only one node through the xpath expression since one
	 * node may have multiple read-marks.
	 * @param xpath
	 * @return
	 */
	Mark[] getMarks(String xpath);
	
	boolean isMarked(String xpath);
	boolean isMarkedRead(String xpath);
	boolean isMarkedWrite(String xpath);
}
