/*
 * Created on 12 mars 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package dopidom.dom;

import java.util.StringTokenizer;

import org.w3c.dom.Attr;
import org.w3c.dom.Element;
import org.w3c.dom.Node;

import dopidom.Component;
import dopidom.Observable;
import dopidom.ObserverInterface;

/**
 * @author Olivier Beaudoux
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */

public abstract class DOMObserverInterface implements ObserverInterface
{
	private Component ownerComponent;
	private Observable observable;
	private String[] xpaths;

	public DOMObserverInterface(Component ownerComponent, Observable observable, String xpath)
	{
		this.ownerComponent = ownerComponent;
		this.observable = observable;
		StringTokenizer tokenizer = new StringTokenizer(xpath, ",");
		xpaths = new String[tokenizer.countTokens()];
		for (int s = 0; s < xpaths.length; s++)
			xpaths[s] = tokenizer.nextToken();
		ownerComponent.registerObserverInterface(this);
	}

	public Component getOwnerComponent()
	{
		return ownerComponent;
	}

	public Element getWrappedElement()
	{
		return ownerComponent.getWrappedElement();
	}

	public String[] getXPaths()
	{
		return xpaths;
	}

	public Observable getObservable()
	{
		return observable;
	}

	/* (non-Javadoc)
	 * @see dpidom.ObserverInterface#attributeValueChanged(org.w3c.dom.Attr, java.lang.String, java.lang.String)
	 */
	public void attributeValueChanged(Attr attr, String previousValue, String newValue)
	{
	}

	/* (non-Javadoc)
	 * @see dpidom.ObserverInterface#nodeInserted(org.w3c.dom.Node)
	 */
	public void nodeInserted(Node node)
	{
	}

	/* (non-Javadoc)
	 * @see dpidom.ObserverInterface#nodeRemoved(org.w3c.dom.Node)
	 */
	public void nodeRemoved(Node node)
	{
	}

	/* (non-Javadoc)
	 * @see dpidom.ObserverInterface#nodeTextChanged(org.w3c.dom.Node, java.lang.String, java.lang.String)
	 */
	public void nodeTextChanged(Node node, String previousValue, String newValue)
	{
	}

}
