/*
 * Created on 30 mars 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package dopidom.dom;

import org.w3c.dom.Attr;
import org.w3c.dom.Node;

import dopidom.Component;
import dopidom.Observable;
import dopidom.SynchronizationInterface;

/**
 * @author Olivier Beaudoux
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public abstract class DOMRelationInterface implements SynchronizationInterface
{
	protected Component observerComponent;
	protected String observerXPath;
	protected Component observableComponent;
	protected String observableXPath;

	public DOMRelationInterface(
		Component observerComponent,
		String observerXPath,
		Component observableComponent,
		String observableXPath)
	{
		this.observerComponent = observerComponent;
		this.observerXPath = observerXPath;
		this.observableComponent = observableComponent;
		this.observableXPath = observableXPath;

		new ObserverObserverInterface(observerComponent, observerComponent, observerXPath);
		new ObservableObserverInterface(observerComponent, observableComponent, observableXPath);
	}

	protected class ObserverObserverInterface extends DOMObserverInterface
	{
		public ObserverObserverInterface(Component ownerComponent, Observable observable, String xpath)
		{
			super(ownerComponent, observable, xpath);
		}

		public void nodeTextChanged(Node node, String previousValue, String newValue)
		{
			observerToObservable(node, previousValue, newValue);
		}

		public void attributeValueChanged(Attr attr, String previousValue, String newValue)
		{
			observerToObservable(attr, previousValue, newValue);
		}

		public void nodeInserted(Node node)
		{
			// ??? operation sur insertion ?
		}

		public void nodeRemoved(Node node)
		{
			// ??? operation sur retrait ?
		}
	}

	protected class ObservableObserverInterface extends DOMObserverInterface
	{
		public ObservableObserverInterface(Component ownerComponent, Observable observable, String xpath)
		{
			super(ownerComponent, observable, xpath);
		}

		public void nodeTextChanged(Node node, String previousValue, String newValue)
		{
			observableToObserver(node, previousValue, newValue);
		}

		public void attributeValueChanged(Attr attr, String previousValue, String newValue)
		{
			observableToObserver(attr, previousValue, newValue);
		}
	}

	/* (non-Javadoc)
	 * @see dopidom.ObserverObservableOperation#getObserverComponent()
	 */
	public Component getObserverComponent()
	{
		return observerComponent;
	}

	/* (non-Javadoc)
	 * @see dopidom.ObserverObservableOperation#getObservableComponent()
	 */
	public Component getObservableComponent()
	{
		return observableComponent;
	}

	/* (non-Javadoc)
	 * @see dopidom.ObserverObservableOperation#getObserverXPath()
	 */
	public String getObserverXPath()
	{
		return observerXPath;
	}

	/* (non-Javadoc)
	 * @see dopidom.ObserverObservableOperation#getObservableXPath()
	 */
	public String getObservableXPath()
	{
		return observableXPath;
	}
}
