/*
 * Created on 2 mai 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package dopidom.points;

import java.util.Stack;
import java.util.Vector;

import org.w3c.dom.Element;
import org.w3c.dom.events.Event;

import dopidom.Action;
import dopidom.ActionEvent;
import dopidom.svg.SVGEventPoint;

/**
 * @author Olivier Beaudoux
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
// NOTE 1: ajout/retrait annotation
// NOTE 2: undo/redo pourraient tre jous en echo aussi (option ?), voire mme fournir un echo spcifique...
public class EchoingPoint extends SVGEventPoint
{
	protected Stack stack;

	public EchoingPoint(Element pointedElement)
	{
		super(pointedElement, EchoingPoint.class, true);
		stack = new Stack();
	}

	/**
	 * @see dopidom.EventPoint#getEventTypes()
	 */
	public String[] getEventTypes()
	{
		return new String[] { ActionEvent.REPLICATION_EVENT };
	}

	/**
	 * @see org.w3c.dom.events.EventListener#handleEvent(org.w3c.dom.events.Event)
	 */
	public void handleEvent(Event event)
	{
		ActionEvent replicationEvent = (ActionEvent) event;
		ActionEvent replicatedEvent = replicationEvent.getReplicatedEvent();
		if (replicatedEvent.getType().equals(ActionEvent.BEGIN_INTERACTION_EVENT))
		{
//			System.out.println(
//				"begin interaction " + replicatedEvent.getActionClass() + " on " + replicatedEvent.getConsumer());
			stack.push(new Entry(replicatedEvent));
			replicationEvent.stopPropagation();
		}
		else if (replicatedEvent.getType().equals(ActionEvent.DO_ACTION_EVENT))
		{
			getEntry(replicatedEvent).pushAction(replicatedEvent.getAction());
			replicationEvent.stopPropagation();
		}
		else if (replicatedEvent.getType().equals(ActionEvent.END_INTERACTION_EVENT))
		{
			replicatedEvent.getProducer().echoActionsOn(
				getEntry(replicatedEvent).getActions(),
				replicatedEvent.getConsumer());
//			System.out.println(
//				"end interaction " + replicatedEvent.getActionClass() + " on " + replicatedEvent.getConsumer());
			stack.remove(getEntry(replicatedEvent));
			replicationEvent.stopPropagation();
		}
	}

	protected Entry getEntry(ActionEvent actionEvent)
	{
		for (int e = stack.size() - 1; e >= 0; e--)
		{
			Entry entry = (Entry) stack.get(e);
			if (entry.isRelatedTo(actionEvent))
				return entry;
		}
		return null;
	}

	protected class Entry
	{
		protected Vector actions;
		protected ActionEvent beginEvent;

		public Entry(ActionEvent beginEvent)
		{
			this.beginEvent = beginEvent;
			actions = new Vector();
		}

		public void pushAction(Action action)
		{
			actions.add(action);
		}

		public Action[] getActions()
		{
			return (Action[]) actions.toArray(new Action[actions.size()]);
		}

		public boolean isRelatedTo(ActionEvent actionEvent)
		{
			return (beginEvent.getConsumer() == actionEvent.getConsumer())
				&& (beginEvent.getProducer() == actionEvent.getProducer())
				&& (beginEvent.getActionClass() == actionEvent.getActionClass());
		}
	}
}
