/*
 * Created on 2 mai 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package dopidom.points;

import org.w3c.dom.Attr;
import org.w3c.dom.Element;
import org.w3c.dom.NamedNodeMap;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;
import org.w3c.dom.events.Event;
import org.w3c.dom.events.MutationEvent;

import dopidom.svg.SVGEventPoint;

/**
 * @author Olivier Beaudoux
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class RenderingPoint extends SVGEventPoint
{
	protected AttributeRenderer[] renderers;

	public RenderingPoint(Element pointedElement, String[] renderers)
	{
		super(pointedElement, null, false);
		this.renderers = new AttributeRenderer[renderers.length];
		// TODO revoir l'ide de contrat pour les EventPoint (et les Component...!)
		for (int r = 0; r < renderers.length; r++)
			try
			{
				this.renderers[r] = (AttributeRenderer) Class.forName(renderers[r]).newInstance();
				rendererElement(this.renderers[r], pointedElement);
			}
			catch (Exception e)
			{
				System.err.println("Warning! " + "The renderer " + renderers[r] + " is not available");
				this.renderers[r] = null;
			}
	}

	protected void rendererElement(AttributeRenderer renderer, Element element)
	{
		NamedNodeMap attributes = element.getAttributes();
		for (int a = 0; a < attributes.getLength(); a++)
		{
			Attr attribute = (Attr) attributes.item(a);
			renderer.renderAttribute(element, attribute);
		}
		// recurse in child elements
		NodeList children = element.getChildNodes();
		for (int c = 0; c < children.getLength(); c++)
			if (children.item(c).getNodeType() == Node.ELEMENT_NODE)
				rendererElement(renderer, (Element) children.item(c));
	}

	/**
	 * @see dopidom.EventPoint#getEventTypes()
	 */
	public String[] getEventTypes()
	{
		return new String[] { "DOMAttrModified" };
	}

	/**
	 * @see org.w3c.dom.events.EventListener#handleEvent(org.w3c.dom.events.Event)
	 */
	public void handleEvent(Event event)
	{
		MutationEvent mutationEvent = (MutationEvent) event;
		for (int r = 0; r < renderers.length; r++)
			if (renderers[r] != null)
			{
				boolean rendered =
					renderers[r].renderAttribute(
						(Element) mutationEvent.getTarget(),
						(Attr) mutationEvent.getRelatedNode());
				// if the atrribute is rendered, the original mutation event will be implicitely refined by the renderer, 
				// we thus need to stop the orignal event so that its effect does not occur
				if (rendered)
					event.stopPropagation();
			}
	}

}
