/*
 * Created on 12 mars 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package dopidom.svg;

import org.w3c.dom.Element;
import org.w3c.dom.events.Event;

import dopidom.Action;
import dopidom.ActionEvent;
import dopidom.ActionInterface;
import dopidom.Component;

/**
 * @author Olivier Beaudoux
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */

public abstract class SVGActionInterface implements ActionInterface
{
	protected Component ownerComponent;

	public SVGActionInterface(Component ownerComponent)
	{
		this.ownerComponent = ownerComponent;
		ownerComponent.registerActionInterface(this);
	}

	public Component getOwnerComponent()
	{
		return ownerComponent;
	}

	public Element getWrappedElement()
	{
		return ownerComponent.getWrappedElement();
	}

	/**
	 * Batik 1.5(.1) does not support animation, and does not plan to support it :-(
	 * This is the reason why the echoing process is not runned through the invokeLater
	 * call (this allows to do the animation at the consumer level).
	 */
	public void handleEvent(Event event)
	{
		final ActionEvent actionEvent = (ActionEvent) event;
		if (actionEvent.getType().equals(ActionEvent.ECHO_ACTIONS_EVENT))
			echoActions(actionEvent.getActions());
		else
			SVGScene.getInstance().invokeLater(new Runnable()
		{
			public void run()
			{
				if (actionEvent.getType().equals(ActionEvent.REPLICATION_EVENT))
					handleActionEvent(actionEvent.getReplicatedEvent());
				else
					handleActionEvent(actionEvent);
			}

			protected void handleActionEvent(ActionEvent actionEvent)
			{
				if (actionEvent.getType().equals(ActionEvent.BEGIN_INTERACTION_EVENT))
					beginInteraction();
				else if (actionEvent.getType().equals(ActionEvent.DO_ACTION_EVENT))
					doAction(actionEvent.getAction());
				else if (actionEvent.getType().equals(ActionEvent.END_INTERACTION_EVENT))
					endInteraction();
				else if (actionEvent.getType().equals(ActionEvent.UNDO_ACTIONS_EVENT))
					undoActions(actionEvent.getActions());
				else if (actionEvent.getType().equals(ActionEvent.REDO_ACTIONS_EVENT))
					redoActions(actionEvent.getActions());
				else if (actionEvent.getType().equals(ActionEvent.ECHO_ACTIONS_EVENT))
					echoActions(actionEvent.getActions());
			}
		});
	}

	/* (non-Javadoc)
	 * @see dpidom.action.Handler#canDo(dpidom.action.Action)
	 */
	public boolean canDoAction(Class actionClass)
	{
		return true;
	}

	/* (non-Javadoc)
	 * @see dpidom.action.Handler#begin(dpidom.action.Action)
	 */
	public void beginInteraction()
	{
	}

	/* (non-Javadoc)
	 * @see dpidom.action.Handler#end(dpidom.action.Action)
	 */
	public void endInteraction()
	{
	}


	/* (non-Javadoc)
	 * @see dpidom.action.Handler#redo(dpidom.action.Action)
	 */
	public void redoActions(Action[] actions)
	{
		// TODO methodes undo/red abstraites
	}

	/* (non-Javadoc)
	 * @see dpidom.action.Handler#undo(dpidom.action.Action)
	 */
	public void undoActions(Action[] actions)
	{
	}

	/* (non-Javadoc)
	 * @see dopidom.ActionInterface#echoActions(dopidom.Action[])
	 */
	public void echoActions(Action[] actions)
	{
		redoActions(actions);
	}

}
