/*
 * Created on 7 avr. 2005
 *
 *  * Copyright 2004-2008 Frdric FONDEMENT
 */
package dopidom.svg;

import java.awt.event.KeyEvent;
import java.awt.event.MouseEvent;
import java.awt.event.MouseWheelEvent;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import org.w3c.dom.Element;

/**
 * @author fondemen
 *
 *  * Copyright 2004-2008 Frdric FONDEMENT
 */
public abstract class SVGCleanToolInteractor extends SVGToolInteractor {
	
	protected final List interactions = new ArrayList();

	/**
	 * @param wrappedElement
	 */
	public SVGCleanToolInteractor(Element wrappedElement) {
		super(wrappedElement);
	}

	public List getInteractions() {
		return interactions;
	}
	
	public void addInteraction(SVGInteraction i) {
		this.interactions.add(i);
	}
	
	public void mouseDragged(MouseEvent event) {
		super.mouseDragged(event);
		Iterator i = this.getInteractions().iterator();
		while (i.hasNext() && !event.isConsumed()) {
			SVGInteraction interaction = (SVGInteraction) i.next();
			interaction.mouseDragged(event);
		}
	}
	public void mouseMoved(MouseEvent event) {
		super.mouseMoved(event);
		Iterator i = this.getInteractions().iterator();
		while (i.hasNext() && !event.isConsumed()) {
			SVGInteraction interaction = (SVGInteraction) i.next();
			interaction.mouseMoved(event);
		}
	}
	public void mousePressed(MouseEvent event) {
		super.mousePressed(event);
		Iterator i = this.getInteractions().iterator();
		while (i.hasNext() && ! event.isConsumed()) {
			SVGInteraction interaction = (SVGInteraction) i.next();
			interaction.mousePressed(event);
		}
	}
	public void keyPressed(KeyEvent event) {
		super.keyPressed(event);
		Iterator i = this.getInteractions().iterator();
		while (i.hasNext() && !event.isConsumed()) {
			SVGInteraction interaction = (SVGInteraction) i.next();
			interaction.keyPressed(event);
		}
	}
	public void keyReleased(KeyEvent event) {
		super.keyReleased(event);
		Iterator i = this.getInteractions().iterator();
		while (i.hasNext() && !event.isConsumed()) {
			SVGInteraction interaction = (SVGInteraction) i.next();
			interaction.keyReleased(event);
		}
	}
	public void keyTyped(KeyEvent event) {
		super.keyTyped(event);
		Iterator i = this.getInteractions().iterator();
		while (i.hasNext() && !event.isConsumed()) {
			SVGInteraction interaction = (SVGInteraction) i.next();
			interaction.keyTyped(event);
		}
	}
	public void mouseClicked(MouseEvent event) {
		super.mouseClicked(event);
		Iterator i = this.getInteractions().iterator();
		while (i.hasNext() && !event.isConsumed()) {
			SVGInteraction interaction = (SVGInteraction) i.next();
			interaction.mouseClicked(event);
		}
	}
	public void mouseEntered(MouseEvent event) {
		super.mouseEntered(event);
		Iterator i = this.getInteractions().iterator();
		while (i.hasNext() && !event.isConsumed()) {
			SVGInteraction interaction = (SVGInteraction) i.next();
			interaction.mouseEntered(event);
		}
	}
	public void mouseExited(MouseEvent event) {
		super.mouseExited(event);
		Iterator i = this.getInteractions().iterator();
		while (i.hasNext() && !event.isConsumed()) {
			SVGInteraction interaction = (SVGInteraction) i.next();
			interaction.mouseExited(event);
		}
	}
	public void mouseReleased(MouseEvent event) {
		super.mouseReleased(event);
		Iterator i = this.getInteractions().iterator();
		while (i.hasNext() && !event.isConsumed()) {
			SVGInteraction interaction = (SVGInteraction) i.next();
			interaction.mouseReleased(event);
		}
	}
	public void mouseWheelMoved(MouseWheelEvent event) {
		super.mouseWheelMoved(event);
		Iterator i = this.getInteractions().iterator();
		while (i.hasNext() && !event.isConsumed()) {
			SVGInteraction interaction = (SVGInteraction) i.next();
			interaction.mouseWheelMoved(event);
		}
	}
}
