/*
 * Created on 2 mai 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package dopidom.svg;

import org.w3c.dom.Element;
import org.w3c.dom.events.Event;
import org.w3c.dom.events.EventListener;
import org.w3c.dom.events.EventTarget;

import dopidom.EventPoint;
import dopidom.EventPointFactory;

/**
 * @author Olivier Beaudoux
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public abstract class SVGEventPoint implements EventPoint
{
	protected static final EventPointFactory FACTORY = new SVGEventPointFactory();

	public static EventPointFactory getFactory()
	{
		return FACTORY;
	}

	protected Element attachedElement;
	protected Object eventGroup;

	protected SVGEventPoint(Element attachedElement, Object eventGroup, boolean topDown)
	{
		this.attachedElement = attachedElement;
		this.eventGroup = eventGroup;

		String[] eventTypes = getEventTypes();
		EventTarget eventTarget = (EventTarget) getAttachedElement();
		for (int e = 0; e < eventTypes.length; e++)
			eventTarget.addEventListener(eventTypes[e], new EventHandler(), topDown);
	}

	/* (non-Javadoc)
	 * @see dopidom.EventPoint#getAttachedElement()
	 */
	public Element getAttachedElement()
	{
		return attachedElement;
	}

	public Object getEventGroup()
	{
		return eventGroup;
	}

	protected class EventHandler implements EventListener
	{
		/* (non-Javadoc)
		 * @see org.w3c.dom.events.EventListener#handleEvent(org.w3c.dom.events.Event)
		 */
		public void handleEvent(Event event)
		{
			if (event instanceof SVGActionEvent)
			{
				SVGActionEvent actionEvent = (SVGActionEvent) event;
				if (!actionEvent.isPropagationStopped(eventGroup))
					SVGEventPoint.this.handleEvent(event);
			}
			else
				SVGEventPoint.this.handleEvent(event);
		}
	}
}
