/*
 * Created on 6 mai 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package dopidom.svg;

import java.lang.reflect.Constructor;
import java.lang.reflect.InvocationTargetException;
import java.util.Hashtable;
import java.util.StringTokenizer;

import org.apache.batik.swing.svg.GVTTreeBuilderAdapter;
import org.apache.batik.swing.svg.GVTTreeBuilderEvent;
import org.w3c.dom.Attr;
import org.w3c.dom.Element;
import org.w3c.dom.Node;

import dopidom.Component;
import dopidom.EventPoint;
import dopidom.EventPointFactory;

/**
 * @author Olivier Beaudoux
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class SVGEventPointFactory implements EventPointFactory
{
	/**
	 * key: attached element, value: associated event-point
	 * NOTE pb garbage collection... (utiliser Element.userObject quand DOM3...)
	 */
	protected Hashtable eventPointMap = new Hashtable();


	public SVGEventPointFactory() {
		super();
		SVGScene.getInstance().getCanvas().addGVTTreeBuilderListener(new GVTTreeBuilderAdapter()
		{
			public void gvtBuildStarted(GVTTreeBuilderEvent event)
			{
				eventPointMap.clear();
			}
		});
	}


	/**
	 * @see dopidom.EventPointFactory#newEventPoint(org.w3c.dom.Element)
	 */
	public EventPoint newEventPoint(Element element)
	{
		// check for the "dpi:event-point" attribute
		Attr attr = element.getAttributeNodeNS(Component.NAMESPACE_URI, EventPoint.EVENT_POINT_ATTR);
		EventPoint eventPoint = null;
		if (attr != null)
		{
			// retrieve the class name and the optional arguments
			StringTokenizer tokenizer = new StringTokenizer(attr.getValue(), " ");
			String[] arguments = new String[tokenizer.countTokens() - 1];
			String className = tokenizer.nextToken();
			try
			{
				// create the associated event-point
				Class klass = Class.forName(className);
				// constructor with no argument (except the attached element)
				if (arguments.length == 0)
				{
					Constructor constructor = klass.getConstructor(new Class[] { Element.class });
					eventPoint = (EventPoint) constructor.newInstance(new Object[] { element });
				}
				else
				{
					// constructor with string arguments
					for (int a = 0; a < arguments.length; a++)
						arguments[a] = tokenizer.nextToken();
					Constructor constructor = klass.getConstructor(new Class[] { Element.class, String[].class });
					eventPoint = (EventPoint) constructor.newInstance(new Object[] { element, arguments });
				}
				eventPointMap.put(element, eventPoint);
			}
			catch (ClassNotFoundException e)
			{
				System.err.println("Event-point not created since its specified class " + className + "was not found");
			}
			catch (SecurityException e)
			{
				e.printStackTrace();
			}
			catch (NoSuchMethodException e)
			{
				System.err.println(
					"Event-point not created since its specified constructor does not exist within class " + className);
			}
			catch (IllegalArgumentException e)
			{
				e.printStackTrace();
			}
			catch (InstantiationException e)
			{
				e.printStackTrace();
			}
			catch (IllegalAccessException e)
			{
				e.printStackTrace();
			}
			catch (InvocationTargetException e)
			{
				e.printStackTrace();
			}
		}
		// recurse in subtree
		for (Node node = element.getFirstChild(); node != null; node = node.getNextSibling())
			if (node.getNodeType() == Node.ELEMENT_NODE)
				newEventPoint((Element) node);
		// return the (root) Component	
		return eventPoint;
	}
}
