/*
 * Created on 15 mars 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package dopidom.svg;

import java.util.Vector;

import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;

import dopidom.ActionConsumer;
import dopidom.Component;
import dopidom.QueryConsumer;
import dopidom.dom.DOMComponent;

/**
 * @author Olivier Beaudoux
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */

//==================
// "Semantic" filtering to picking
//==================

public class SVGPicking implements NodeList
{
	protected Element[] pickedElements;

	protected SVGPicking(Vector pickedElements)
	{
		this.pickedElements = (Element[]) pickedElements.toArray(new Element[pickedElements.size()]);
	}

	public boolean hasComponent()
	{
		return getComponent() != null;
	}

	public Component getComponent()
	{
		Element element = (Element) item(0);
		if (element != null)
		{
			Component component = DOMComponent.getFactory().getOwnerComponent(element);
			if (component != null)
				return component;
		}
		return null;
	}

	public boolean hasQueryConsumer(Class queryClass)
	{
		return getQueryConsumer(queryClass) != null;
	}

	public boolean hasActionConsumer(Class actionClass)
	{
		return getActionConsumer(actionClass) != null;
	}

	public boolean hasActionConsumer(Class[] actionClasses)
	{
		for (int c = 0; c < actionClasses.length; c++)
			if (!hasActionConsumer(actionClasses[c]))
				return false;
		return true;
	}

	public QueryConsumer getQueryConsumer(Class queryClass)
	{
		for (int i = 0, max = this.pickedElements == null ? 0 : this.pickedElements.length; i < max; i++) {
			Element element = (Element) item(i);
	
			if (element != null)
			{
				Component component = DOMComponent.getFactory().getOwnerComponent(element);
				if ((component != null) && (component.getQueryInterface(queryClass) != null)){
					return component;				
				}
			}
		}
		return null;
	}

	public ActionConsumer getActionConsumer(Class actionClass)
	{
		for (int i = 0, max = this.pickedElements == null ? 0 : this.pickedElements.length; i < max; i++) {
			Element element = (Element) item(i);
			if (element != null)
			{
				Component component = DOMComponent.getFactory().getOwnerComponent(element);
				if ((component != null) && (component.getActionInterface(actionClass) != null)){
					return component;
				}
			}
		}
		return null;
	}

	public ActionConsumer getActionConsumer(Class[] actionClasses)
	{
		return getActionConsumer(actionClasses[0]);
	}

	public String toString()
	{
		String result = "";
		for (int e = 0; e < pickedElements.length; e++)
			result += pickedElements[e] + "\n";
		return result;
	}

	//=========
	// NodeList interface
	//=========

	/* (non-Javadoc)
	 * @see org.w3c.dom.NodeList#item(int)
	 */
	public Node item(int index)
	{
		if (pickedElements.length == 0){
			return null;
		}
		else 
			return (Node) pickedElements[index];
	}

	/* (non-Javadoc)
	 * @see org.w3c.dom.NodeList#getLength()
	 */
	public int getLength()
	{
		return pickedElements.length;
	}

}
