/*
 * Created on 15 fvr. 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package dopidom.svg;

import java.awt.Color;
import java.awt.Cursor;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Shape;
import java.awt.geom.AffineTransform;
import java.awt.geom.NoninvertibleTransformException;
import java.awt.geom.Point2D;
import java.awt.geom.Rectangle2D;
import java.awt.print.PageFormat;
import java.awt.print.Printable;
import java.io.FileWriter;
import java.io.IOException;
import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;
import java.util.HashSet;
import java.util.Set;
import java.util.Vector;

import org.apache.batik.dom.AbstractDocument;
import org.apache.batik.dom.svg.ExtensibleSVGDOMImplementation;
import org.apache.batik.dom.svg.SVGDOMImplementation.ElementFactory;
import org.apache.batik.dom.util.DOMUtilities;
import org.apache.batik.gvt.CompositeGraphicsNode;
import org.apache.batik.gvt.GraphicsNode;
import org.apache.batik.swing.JSVGCanvas;
import org.apache.batik.swing.svg.GVTTreeBuilderAdapter;
import org.apache.batik.swing.svg.GVTTreeBuilderEvent;
import org.apache.batik.swing.svg.JSVGComponent;
import org.apache.batik.transcoder.TranscoderInput;
import org.apache.batik.transcoder.print.PrintTranscoder;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;
import org.w3c.dom.svg.SVGDocument;
import org.w3c.dom.svg.SVGElement;
import org.w3c.dom.svg.SVGGElement;
import org.w3c.dom.svg.SVGSVGElement;
import org.w3c.dom.svg.SVGUseElement;

import test.languageloading.MDRUpdaterElement;
import test.languageloading.VariableElement;

import dopidom.dom.DOMComponent;
import dopidom.dom.DOMPath;

/**
 * @author Olivier Beaudoux
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class SVGScene implements Printable
{
	protected JSVGCanvas svgCanvas;
	protected Cursor cursor;
	protected Set interactors = new HashSet();

	protected static final SVGScene INSTANCE = new SVGScene();

	protected SVGScene()
	{
		svgCanvas = new JSVGCanvas(null, true, false);
		svgCanvas.setEnableImageZoomInteractor(false);
		svgCanvas.setEnablePanInteractor(false);
		svgCanvas.setEnableResetTransformInteractor(false);
		svgCanvas.setEnableRotateInteractor(false);
		svgCanvas.setEnableZoomInteractor(false);

		svgCanvas.addGVTTreeBuilderListener(new GVTTreeBuilderAdapter()
				{
					public void gvtBuildStarted(GVTTreeBuilderEvent event)
					{
						removeAllInteractors();
					}
				});
	}

	public static SVGScene getInstance()
	{
		return INSTANCE;
	}
	
	private void createCanvas() {
		
	}

	public JSVGComponent getCanvas()
	{
		return svgCanvas;
	}

	//============
	// SVG document
	//============

	public void loadSVGDocument(String uri)
	{
		svgCanvas.setDocumentState(JSVGCanvas.ALWAYS_DYNAMIC);
		svgCanvas.setCursor(new Cursor(Cursor.WAIT_CURSOR));
		// we must wait for the gvt build before loading DPI components
		svgCanvas.addGVTTreeBuilderListener(new GVTTreeBuilderAdapter()
		{
			public void gvtBuildCompleted(GVTTreeBuilderEvent event)
			{
				((ExtensibleSVGDOMImplementation)svgCanvas.getSVGDocument().getImplementation()).registerCustomElementFactory("http://lgl.epfl.ch/probxs/mdr", MDRUpdaterElement.Updater_Local_Name, new ElementFactory () {

					public Element create(String prefix, Document doc) {
						// TODO Auto-generated method stub
						return new MDRUpdaterElement((AbstractDocument)doc);
					}
					
				});
				((ExtensibleSVGDOMImplementation)svgCanvas.getSVGDocument().getImplementation()).registerCustomElementFactory("http://lgl.epfl.ch/probxs/mdr", VariableElement.Variable_Local_Name, new ElementFactory () {

					public Element create(String prefix, Document doc) {
						// TODO Auto-generated method stub
						return new VariableElement((AbstractDocument)doc);
					}
					
				});
				Element root = svgCanvas.getSVGDocument().getRootElement();
				DOMComponent.getFactory().newComponent(root);
				SVGEventPoint.getFactory().newEventPoint(root);
				svgCanvas.setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
			}
		});
		svgCanvas.removeAll();
		svgCanvas.loadSVGDocument(uri);
	}
	
	public Dimension getSize() {
		return this.svgCanvas.getSize();
	}
	
	public int print(Graphics g, PageFormat pageFormat, int pageIndex) {
		if (pageIndex == 0) {

	        final PrintTranscoder prm = new PrintTranscoder();
	        TranscoderInput ti = new TranscoderInput(SVGScene.getInstance().getDocument());
	        prm.transcode(ti, null);

			((Graphics2D)g).setBackground(Color.WHITE);
			Dimension d = SVGScene.getInstance().getSize();
			double scaleX = pageFormat.getImageableWidth()/d.width;
			double scaleY = pageFormat.getImageableHeight()/d.height;
			double scale = Math.min(Math.min(scaleX, scaleY), 1.0d);
			AffineTransform t = ((Graphics2D)g).getTransform(), u = new AffineTransform(), v = new AffineTransform();
			v.setToTranslation(pageFormat.getImageableX()/scale, pageFormat.getImageableY()/scale);
			u.setToScale(scale, scale);
			u.concatenate(v);
			t.concatenate(u);
			((Graphics2D)g).setTransform(t);
	        
	        return prm.print(g, pageFormat, pageIndex);
		} else
			return NO_SUCH_PAGE;
	}

	public void saveSVGDocument(String fileName) throws IOException
	{
		FileWriter writer = new FileWriter(fileName);
		writer.write("<?xml version='1.0' standalone='yes'?>" + '\n');
		DOMUtilities.writeDocument(getDocument(), writer);
		writer.close();
	}

	public void waitForSVGDocument()
	{
		//		while (SVGScene.getInstance().getSVGDocument() == null)
		while (svgCanvas.getUpdateManager() == null)
		{
			try
			{
				Thread.sleep(10);
			}
			catch (InterruptedException e)
			{
			}
		}
	}

	public SVGDocument getDocument()
	{
		return svgCanvas.getSVGDocument();
	}

	public SVGSVGElement getRootElement()
	{
		return (SVGSVGElement) svgCanvas.getSVGDocument().getRootElement();
	}

	//=========
	// Interactors
	//=========
	
	public SVGInteractor [] getInteractors() {
		return (SVGInteractor[])this.interactors.toArray(new SVGInteractor[this.interactors.size()]);
	}

	public void addInteractor(SVGInteractor interactor)
	{
		if (this.interactors.contains(interactor))
			return;
		
		svgCanvas.addKeyListener(interactor);
		svgCanvas.addMouseListener(interactor);
		svgCanvas.addMouseMotionListener(interactor);
		svgCanvas.addMouseWheelListener(interactor);
		
		this.interactors.add(interactor);
	}

	public void removeInteractor(SVGInteractor interactor)
	{
		if (!this.interactors.contains(interactor))
			return;
		
		svgCanvas.removeMouseListener(interactor);
		svgCanvas.removeMouseMotionListener(interactor);
		svgCanvas.removeMouseWheelListener(interactor);
		svgCanvas.removeKeyListener(interactor);
		
		this.interactors.remove(interactor);
	}
	
	public void removeAllInteractors() {
		SVGInteractor [] inter = this.getInteractors();
		for (int i = 0; i < inter.length; i++) {
			this.removeInteractor(inter[i]);
		}
	}

	//============
	// DOM "painting"
	//============

	public void invokeLater(Runnable runnable)
	{
		svgCanvas.getUpdateManager().getUpdateRunnableQueue().invokeLater(runnable);
	}

	//===================
	// Graphical Picking
	// @see SVGPickingList for semantic picking
	//===================

	public SVGPicking getPickedElements(int x, int y)
	{
		return getPickedElementsWithin(x, y, getDocument().getRootElement());
	}

	public SVGPicking getPickedElementsWithin(int x, int y, Element withInElement)
	{
		Vector pickedElements = new Vector();
		pickElements(withInElement, x, y, pickedElements);
		return new SVGPicking(pickedElements);
	}

	public SVGPicking getPickedElementsUnder(int x, int y, Element underElement)
	{
		Vector pickedElements = new Vector();
		pickElements(getDocument().getRootElement(), x, y, pickedElements);
		// filter picked elements that are not located after the under element
		DOMPath underElementPath = new DOMPath(underElement);
		for (int n = 0; n < pickedElements.size(); n++)
		{
			Element pickedElement = (Element) pickedElements.get(n);
			DOMPath pickedElementPath = new DOMPath(pickedElement);
			if (!underElementPath.isAfter(pickedElementPath))
			{
				pickedElements.remove(n);
				n--;
			}
		}
		return new SVGPicking(pickedElements);
	}

	protected void pickElements(Element element, int x, int y, Vector pickNodes)
	{
		// we do not directly picked in "g", "svg" and "use" elements but rather in their children so:
		// 		- recurse on "g" and "svg" element
		if ((element instanceof SVGSVGElement)
			|| (element instanceof SVGGElement)
			|| (element instanceof SVGUseElement))
		{
			// in case of a use element, we must pick in its root instance 
			// (which is not a group element within Batik implementation... so don't use recursion here!)
			if (element instanceof SVGUseElement)
			{
				SVGUseElement useElement = (SVGUseElement) element;
				SVGElement useInstanceRoot = SVGScene.getInstance().getUseInstanceRoot(useElement);
				// if the useInstanceRoot is picked (i.e. one of its element is picked), we add the *use element*
				if (isPicked(useInstanceRoot, x, y))
					pickNodes.add(useElement);
			}
			else if (element.hasChildNodes())
			{
				NodeList children = element.getChildNodes();
				for (int c = children.getLength() - 1; c >= 0; c--)
					if (children.item(c) instanceof Element)
						pickElements((Element) children.item(c), x, y, pickNodes);
			}
		}
		//		- and do picking on graphic "leaf"
		/*else*/ if (isPicked(element, x, y))
			pickNodes.add(element);
	}

	public SVGPicking getPickedGroups(int x, int y)
	{
		Vector pickedGroups = new Vector();
		pickGroups(getDocument().getRootElement(), x, y, pickedGroups);
		return new SVGPicking(pickedGroups);
	}

	protected void pickGroups(Element element, int x, int y, Vector pickNodes)
	{
		if ((element instanceof SVGSVGElement) || (element instanceof SVGGElement))
		{
			// a group is considered as picked as soon as it is picked but not its child groups
			if (element.hasChildNodes() && isPicked(element, x, y))
			{
				NodeList children = element.getChildNodes();
				boolean childrenPicked = false;
				for (int c = children.getLength() - 1; c >= 0; c--)
				{
					Node child = children.item(c);
					if (((child instanceof SVGSVGElement) || (child instanceof SVGGElement))
						&& isPicked((Element) child, x, y))
					{
						pickGroups((Element) child, x, y, pickNodes);
						childrenPicked = true;
					}
				}
				if (!childrenPicked)
					pickNodes.add(element);
			}
		}

	}

	public GraphicsNode getGVTNode(Element element)
	{
		return svgCanvas.getUpdateManager().getBridgeContext().getGraphicsNode(element);
	}

	public SVGElement getSVGElement(GraphicsNode gvtNode)
	{
		return (SVGElement) svgCanvas.getUpdateManager().getBridgeContext().getElement(gvtNode);
	}

	//===============================
	// Batik unimplemented methods...
	//===============================
	
	public static final double ERROR = 10.0;

	protected boolean isPicked(Element element, int x, int y)
	{
		GraphicsNode gvtNode = getGVTNode(element);
		if (gvtNode == null)
			return false;
		Point2D point = new Point2D.Double(x, y);
		try
		{
			gvtNode.getGlobalTransform().inverseTransform(point, point);
		}
		catch (NoninvertibleTransformException e)
		{
			e.printStackTrace();
		}
		
		Shape ol;
		try {
			ol = gvtNode.getOutline();
		} catch (RuntimeException _) {
			ol = null;
		}
		return ol == null ? gvtNode.contains(point) : ol.intersects(new Rectangle2D.Double(point.getX()-ERROR/2, point.getY()-ERROR/2, ERROR, ERROR));
	}

	public SVGElement getUseInstanceRoot(SVGUseElement useElement)
	{
		// the GVT "use node" is a composite...
		CompositeGraphicsNode gvtUseNode = (CompositeGraphicsNode) SVGScene.getInstance().getGVTNode(useElement);
		// ... that contains a gvt that represents the gvt instanciated element
		GraphicsNode gvtCanvasNode = (GraphicsNode) gvtUseNode.get(0);
		// ... so that we just need to convert this gvt node into the corresponding svg element
		return getSVGElement(gvtCanvasNode);
		// NOTE: The return SVGElement is NOT an instance of SVGGElement (this point does not match
		// the SVG 1.0 recommandation)
	}
	
	/**
	 * Forces the evaluation of all CSVG constraints.
	 *
	 */
	public void updateConstraints() {
        //this.getCanvas().getSVGDocument().getConstraintEngine().updateAllConstraints();
		Object o = this.getCanvas().getSVGDocument();
		try {
			Method m = o.getClass().getMethod("getConstraintEngine", new Class [0]);
			o = m.invoke(o, new Object[0]);
			m = o.getClass().getMethod("updateAllConstraints", new Class[0]);
			o = m.invoke(o, new Object[0]);
		} catch (NoSuchMethodException e) {
		} catch (IllegalArgumentException e) {
			e.printStackTrace();
		} catch (IllegalAccessException e) {
			e.printStackTrace();
		} catch (InvocationTargetException e) {
			throw new RuntimeException(e.getCause());
		}
	}
}
