/*
 * Created on 26 fvr. 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package dopidom.svg;

import java.awt.event.MouseEvent;

import org.w3c.dom.Element;
import org.w3c.dom.svg.SVGTransformable;

/**
 * @author Olivier Beaudoux
 *
 * A tool interactor is a tool displayed as an SVG element, not as an OS cursor.
 * THis class handles the translation of the tool shape;
 */
public abstract class SVGToolInteractor extends SVGInteractor
{
	boolean hasCursor;
	
	/**
	 * @param wrappedElement
	 */
	protected SVGToolInteractor(Element wrappedElement)
	{
		super(wrappedElement);
		SVGTransformable cursor = (SVGTransformable) getWrappedElement();
		hasCursor = cursor.getTransform().getBaseVal().consolidate() != null;
	}

	public void mouseMoved(MouseEvent event)
	{
		if (hasCursor)
			SVGScene.getInstance().invokeLater(new PaintCursor(event));
	}

	protected class PaintCursor implements Runnable
	{
		protected float x, y;

		public PaintCursor(MouseEvent event)
		{
			x = event.getX();
			y = event.getY();
		}

		public void run()
		{
			SVGTransformable cursor = (SVGTransformable) getWrappedElement();
			cursor.getTransform().getBaseVal().consolidate().setTranslate(x, y);
		}
	}

	public void mousePressed(MouseEvent event)
	{
	}

	public void mouseDragged(MouseEvent event)
	{
	}
}
