/*
 * Created on 25 mars 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package dopidom.swt;

import org.eclipse.swt.SWT;
import org.eclipse.swt.awt.SWT_AWT;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Event;
import org.eclipse.swt.widgets.Listener;
import org.eclipse.swt.widgets.Menu;
import org.eclipse.swt.widgets.MenuItem;
import org.eclipse.swt.widgets.Shell;

/**
 * @author Olivier Beaudoux
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class SWTWindow
{
	protected Display swtDisplay;
	protected Shell swtShell;

	public SWTWindow(String title, java.awt.Component awtComponent)
	{
		// SWT shell
		swtDisplay = new Display();
		swtShell = new Shell(swtDisplay);
		swtShell.setText(title);
		Listener exitListener = new Listener()
		{
			public void handleEvent(Event e)
			{
				swtShell.dispose();
			}
		};
		swtShell.addListener(SWT.Close, exitListener);

		// SWT menu bar of the shell
		Menu swtMenuBar = new Menu(swtShell, SWT.BAR);
		swtShell.setMenuBar(swtMenuBar);
		Menu fileMenu = new Menu(swtShell, SWT.DROP_DOWN);
		MenuItem fileItem = new MenuItem(swtMenuBar, SWT.CASCADE);
		fileItem.setText("SWT Menu");
		fileItem.setMenu(fileMenu);
		MenuItem exitItem = new MenuItem(fileMenu, SWT.CASCADE);
		exitItem.setText("Exit");
		exitItem.addListener(SWT.Selection, exitListener);
		// root composite of SWT shell
		Composite swtShellComposite = new Composite(swtShell, SWT.NONE);

		// SWT to AWT containment
		Composite swtToAwtComposite = new Composite(swtShellComposite, SWT.EMBEDDED);
		java.awt.Frame awtFrame = SWT_AWT.new_Frame(swtToAwtComposite);

		// layout
		GridLayout layout = new GridLayout();
		layout.marginWidth = layout.marginHeight = 0;
		GridData data = new GridData(GridData.FILL_BOTH);
		swtShell.setLayout(layout);
		swtShellComposite.setLayout(layout);
		swtShellComposite.setLayoutData(data);
		swtToAwtComposite.setLayoutData(data);

		awtFrame.add(awtComponent);
		swtShell.open();
	}

	public void runEventLoop()
	{
		// SWT event loop
		while (!swtShell.isDisposed())
		{
			if (!swtDisplay.readAndDispatch())
				swtDisplay.sleep();
		}
		swtDisplay.dispose();
	}
}
