package event;

import dopidom.Component;
import test.EditableString;
import listeners.AbstractEvent;
import listeners.EventKind;

public class CharacterDeletedEvent extends AbstractEvent {

	protected final EditableString textDeletedComponent;
	protected final int offsetInText;
	protected final String text;
	protected final String newText;
	
	public CharacterDeletedEvent(EditableString textDeletedComponent, String text, String newText, int offsetInText){
		this.textDeletedComponent = textDeletedComponent;
		this.offsetInText = offsetInText;
		this.text = text;
		this.newText = newText;
	}
	
	public Component getTextDeletedComponent() {
		return this.textDeletedComponent;
	}
	
	public int getOffsetInText() {
		return this.offsetInText;
	}
	
	
	public EventKind getEventKind() {
		return EventKind.CharacterDeleted;
	}

	public String getNewText() {
		return newText;
	}

	public String getText() {
		return text;
	}

}
