package event;

import dopidom.Component;
import test.EditableString;
import listeners.AbstractEvent;
import listeners.EventKind;

public class CharacterInsertedEvent extends AbstractEvent {

	protected final EditableString textInsertedComponent;
	protected final String text;
	protected final String newText;
	protected final String characterChanged;
	
	public CharacterInsertedEvent(EditableString textInsertedComponent,String text, String newText, String characterChanged){
		this.textInsertedComponent = textInsertedComponent;
		this.text = text;
		this.newText = newText;
		this.characterChanged = characterChanged;
	}
	
	public Component getTextInsertedComponent() {
		return this.textInsertedComponent;
	}
	
	public String getText() {
		return this.text;
	}

	public EventKind getEventKind() {
		return EventKind.CharacterInserted;
	}

	public String getCharacterChanged() {
		return characterChanged;
	}

	public String getNewText() {
		return newText;
	}

}
