package event;

import dopidom.Component;
import listeners.AbstractEvent;
import listeners.EventKind;

public class DirectionAdjustEvent extends AbstractEvent {
	
	protected final double alpha;
	protected final Component directionAdjustedComponent;
	
	public DirectionAdjustEvent(Component dac, double alpha) {
		this.directionAdjustedComponent = dac;
		this.alpha = alpha;
	}

	public EventKind getEventKind() {
		return EventKind.DirectionAdjusted; 
	}

	public double getAlpha() {
		return alpha;
	}

	public Component getDirectionAdjustedComponent() {
		return directionAdjustedComponent;
	}

}
