package event;

import dopidom.Component;
import listeners.AbstractEvent;
import listeners.EventKind;

public class LocateEvent extends AbstractEvent {

	protected final Component locatedComponent;
	protected final double x;
	protected final double y;
	
	public LocateEvent(Component locatedComponent, double x, double y) {
		this.locatedComponent = locatedComponent;
		this.x = x;
		this.y = y;
	}

	public EventKind getEventKind() {
		return EventKind.Located;
	}

	public Component getLocatedComponent() {
		return locatedComponent;
	}

	public double getX() {
		return x;
	}

	public double getY() {
		return y;
	}

}
