package event;

import dopidom.Component;
import listeners.AbstractEvent;
import listeners.EventKind;

public class PositionEvent extends AbstractEvent {
	
	protected final double posX;
	protected final double posY;
	protected final Component positionedComponent;
	
	public PositionEvent(Component pc, double posX, double posY) {
		this.positionedComponent = pc;
		this.posX = posX;
		this.posY = posY;
	}

	public Component getPositionedComponent() {
		return positionedComponent;
	}

	public double getPosX() {
		return posX;
	}

	public double getPosY() {
		return posY;
	}
	
	public EventKind getEventKind() {
		return EventKind.Positioned;
	}

}
