package event;

import dopidom.Component;
import listeners.AbstractEvent;
import listeners.EventKind;

public class ResizeEvent extends AbstractEvent {

	protected final double sizeX;
	protected final double sizeY;
	protected final Component resizedComponent;
	
	public ResizeEvent(Component rc, double a, double d) {
		this.resizedComponent = rc;
		this.sizeX = a;
		this.sizeY = d;
	}

	public EventKind getEventKind() {

		return EventKind.Resized;
	}

	public Component getResizedComponent() {
		return resizedComponent;
	}

	public double getSizeX() {
		return sizeX;
	}

	public double getSizeY() {
		return sizeY;
	}

}
