package event;

import interfaces.Stickable;
import listeners.AbstractEvent;
import listeners.EventKind;
import dopidom.Component;

public class StickEvent extends AbstractEvent {
	protected final Stickable source;
	protected final Component stickedComponent;
	protected final boolean sticked;
	

	public StickEvent(boolean sticked, Stickable source, Component stickedComponent) {
		super();
		this.sticked = sticked;
		this.source = source;
		this.stickedComponent = stickedComponent;
	}

	public Component getStickedComponent() {
		return stickedComponent;
	}

	public Stickable getSource() {
		return source;
	}

	public EventKind getEventKind() {
		return this.sticked ? EventKind.Stick : EventKind.Unstick;
	}

}
