package event;

import dopidom.Component;
import interfaces.Translatable;
import listeners.AbstractEvent;
import listeners.EventKind;

/**
 * @author Franois
 *
 * At this time, the event is lauched each time a Component is tranlated.
 *
 */
public class TranslateEvent extends AbstractEvent {

	protected final double finalPosX;
	protected final double finalPosY;
	protected final Component translatedComponent;
	
	public TranslateEvent(Component tc, double finalPosX, double finalPosY) {
		this.translatedComponent = tc;
		this.finalPosX = finalPosX;
		this.finalPosY = finalPosY;
	}

	public EventKind getEventKind() {
		return EventKind.Translated;
	}

	public double getFinalPosX() {
		return finalPosX;
	}

	public double getFinalPosY() {
		return finalPosY;
	}

	public Component getTranslatedComponent() {
		return translatedComponent;
	}
}
