package graphicalelements;

/**
 * A_contains_container association proxy interface.
 */
public interface AContainsContainer extends javax.jmi.reflect.RefAssociation {
    /**
     * Queries whether a link currently exists between a given pair of instance 
     * objects in the associations link set.
     * @param contains Value of the first association end.
     * @param container Value of the second association end.
     * @return Returns true if the queried link exists.
     */
    public boolean exists(graphicalelements.GraphicalElement contains, graphicalelements.GraphicalElement container);
    /**
     * Queries the instance objects that are related to a particular instance 
     * object by a link in the current associations link set.
     * @param container Required value of the second association end.
     * @return Collection of related objects.
     */
    public java.util.Collection getContains(graphicalelements.GraphicalElement container);
    /**
     * Queries the instance object that is related to a particular instance object 
     * by a link in the current associations link set.
     * @param contains Required value of the first association end.
     * @return Related object or <code>null</code> if none exists.
     */
    public graphicalelements.GraphicalElement getContainer(graphicalelements.GraphicalElement contains);
    /**
     * Creates a link between the pair of instance objects in the associations 
     * link set.
     * @param contains Value of the first association end.
     * @param container Value of the second association end.
     */
    public boolean add(graphicalelements.GraphicalElement contains, graphicalelements.GraphicalElement container);
    /**
     * Removes a link between a pair of instance objects in the current associations 
     * link set.
     * @param contains Value of the first association end.
     * @param container Value of the second association end.
     */
    public boolean remove(graphicalelements.GraphicalElement contains, graphicalelements.GraphicalElement container);
}
