/*
 * Created on 26 fvr. 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package ihm04;

import ihm04.actions.ClickThrough;
import ihm04.actions.FollowLocation;
import ihm04.actions.Translate;

import java.awt.event.MouseEvent;

import org.w3c.dom.Element;

import dopidom.svg.SVGPicking;
import dopidom.svg.SVGScene;
import dopidom.svg.SVGToolInteractor;

/**
 * @author Olivier Beaudoux
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */

public class Hand extends SVGToolInteractor
{
	protected SVGPicking picking;
	protected boolean followLocation;

	/**
	 * @param wrappedElement
	 */
	public Hand(Element wrappedElement)
	{
		super(wrappedElement);
	}

	public void mousePressed(MouseEvent event)
	{
		super.mousePressed(event);
		int x = event.getX();
		int y = event.getY();
		picking = SVGScene.getInstance().getPickedElementsUnder(x, y, getWrappedElement());

		// click-through
		if ((event.getButton() == 1) && (picking.hasActionConsumer(ClickThrough.class)))
			doActionOnceOn(new ClickThrough(x, y), picking.getActionConsumer(ClickThrough.class));
		// translate
		else if ((event.getButton() == 1) && (picking.hasActionConsumer(Translate.class)))
			beginInteractionOn(Translate.class, picking.getActionConsumer(Translate.class));
		// follow location
		else if ((event.getButton() == 3) && (picking.hasActionConsumer(FollowLocation.class)))
		{
			if (!followLocation)
			{
				beginInteractionOn(FollowLocation.class, picking.getActionConsumer(FollowLocation.class));
				doActionOn(new FollowLocation(x, y), picking.getActionConsumer(FollowLocation.class));
				followLocation = true;
			}
			else
			{
				endInteractionOn(FollowLocation.class, picking.getActionConsumer(FollowLocation.class));
				followLocation = false;
			}
		}
	}

	public void mouseDragged(MouseEvent event)
	{/*
		if (picking != null)
			if (picking.hasActionConsumer(Translate.class))
				doActionOn(
					new Translate(event.getX() - previousX, event.getY() - previousY),
					picking.getActionConsumer(Translate.class));

		super.mouseDragged(event);*/
	}

	public void mouseMoved(MouseEvent event)
	{
		if (picking != null)
			if (followLocation && picking.hasActionConsumer(FollowLocation.class))
				doActionOn(
					new FollowLocation(event.getX(), event.getY()),
					picking.getActionConsumer(FollowLocation.class));

		super.mouseMoved(event);
	}

	public void mouseReleased(MouseEvent event)
	{
		if (picking != null)
			if (event.getButton() == 1)
				if (picking.hasActionConsumer(Translate.class))
					endInteractionOn(Translate.class, picking.getActionConsumer(Translate.class));
	}
}
