/*
 * Created on 26 fvr. 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package ihm04;

import ihm04.actions.Paint;
import ihm04.interfaces.ColorPickable;
import ihm04.interfaces.Paintable;
import ihm04.queries.PickColor;

import java.awt.event.MouseEvent;

import org.w3c.dom.Element;

import dopidom.svg.SVGPicking;
import dopidom.svg.SVGScene;
import dopidom.svg.SVGToolInteractor;

/**
 * @author Olivier Beaudoux
 *
 * A tool that applies painting actions:
 *  - left clic => paint 
 *  - right click => pick color
 */

public class PaintBrush extends SVGToolInteractor
{
	/**
	 * @param wrappedElement
	 */
	public PaintBrush(Element wrappedElement)
	{
		super(wrappedElement);
		new Paintable(this);
		new ColorPickable(this);
	}

	public String getFill()
	{
		return getWrappedElement().getAttribute("fill");
	}

	public void mousePressed(MouseEvent event)
	{
		super.mousePressed(event);
		int x = event.getX();
		int y = event.getY();
		SVGPicking picking = SVGScene.getInstance().getPickedElementsUnder(x, y, getWrappedElement());

		// paint
		if ((event.getButton() == 1) && picking.hasActionConsumer(Paint.class))
			doActionOnceOn(new Paint(getFill()), picking.getActionConsumer(Paint.class));
		// pick color
		else if ((event.getButton() == 3) && picking.hasQueryConsumer(PickColor.class))
		{
			PickColor pickColor = new PickColor();
			doQueryOn(pickColor, picking.getQueryConsumer(PickColor.class));
			// self painting
			doActionOnceOn(new Paint(pickColor.getColor()), this);
		}
	}
}
