/*
 * Created on 14 mars 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package ihm04.interfaces;

import ihm04.queries.PickColor;

import org.apache.batik.util.SVGConstants;
import org.w3c.dom.Element;
import org.w3c.dom.svg.SVGStylable;

import dopidom.Component;
import dopidom.Query;
import dopidom.svg.SVGQueryInterface;

/**
 * @author Olivier Beaudoux
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class ColorPickable extends SVGQueryInterface
{
	public ColorPickable(Component ownerComponent)
	{
		super(ownerComponent);
	}

	public Class getQuery()
	{
		return PickColor.class;
	}

	public Class[] getScope()
	{
		return new Class[] { SVGStylable.class };
	}

	/* (non-Javadoc)
	 * @see dpidom.ConsumerInterface#doQuery(dpidom.Query)
	 */
	public void doQuery(Query query)
	{
		PickColor pickColor = (PickColor) query;
		Element e = (Element)getWrappedElement();
		SVGStylable s = (SVGStylable)e;
		String fill = e.getAttribute(SVGConstants.SVG_FILL_ATTRIBUTE);
		if (fill == null || fill.length() == 0) {
			fill = s.getStyle().getPropertyValue(SVGConstants.CSS_FILL_PROPERTY);
		}
		if (fill == null || fill.length() == 0) { //default fill
			fill = SVGConstants.CSS_BLACK_VALUE;
		}
		pickColor.setColor(fill);
		
		String alpha = e.getAttribute(SVGConstants.SVG_OPACITY_ATTRIBUTE);
		if (alpha == null || alpha.length() == 0) {
			alpha = s.getStyle().getPropertyValue(SVGConstants.CSS_OPACITY_PROPERTY);
		}
		if (alpha == null || alpha.length() == 0) {
			alpha = s.getStyle().getPropertyValue(SVGConstants.CSS_FILL_OPACITY_PROPERTY);
		}
		if (alpha == null || alpha.length() == 0) {
			alpha = SVGConstants.SVG_OPAQUE_VALUE;
		}
		
		pickColor.setAlpha(alpha);
	}
}
