/*
 * Created on 12 mars 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package ihm04.interfaces;

import ihm04.actions.FollowLocation;

import org.w3c.dom.svg.SVGMatrix;
import org.w3c.dom.svg.SVGTransformable;

import dopidom.Action;
import dopidom.Component;
import dopidom.svg.SVGActionInterface;

/**
 * @author Olivier Beaudoux
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class LocationFollowable extends SVGActionInterface
{
	public LocationFollowable(Component ownerComponent)
	{
		super(ownerComponent);
	}

	public Class getAction()
	{
		return FollowLocation.class;
	}

	public Class[] getScope()
	{
		return new Class[] { SVGTransformable.class };
	}

	public void doAction(Action action)
	{
		FollowLocation followLocation = (FollowLocation) action;
		translateTo(followLocation.getX(), followLocation.getY());
	}

	public void undoActions(Action[] actions)
	{
		FollowLocation followLocation = (FollowLocation) actions[0];
		translateTo(followLocation.getX(), followLocation.getY());
	}

	public void redoActions(Action[] actions)
	{
		FollowLocation followLocation = (FollowLocation) actions[actions.length - 1];
		translateTo(followLocation.getX(), followLocation.getY());
	}

	protected void translateTo(float x, float y)
	{
		SVGTransformable transformable = (SVGTransformable) getWrappedElement();
		// note: don't use SVGMatrix.translate in order to do an absolute translation
		SVGMatrix matrix = transformable.getTransform().getBaseVal().consolidate().getMatrix();
		matrix.setE(x);
		matrix.setF(y);
	}
}