/*
 * Created on 12 mars 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package ihm04.interfaces;

import ihm04.actions.Paint;

import org.w3c.dom.css.CSSValue;
import org.w3c.dom.svg.SVGStylable;

import dopidom.Action;
import dopidom.Component;
import dopidom.svg.SVGActionInterface;

/**
 * @author Olivier Beaudoux
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */

public class Paintable extends SVGActionInterface
{
	public Paintable(Component ownerComponent)
	{
		super(ownerComponent);
	}

	public Class getAction()
	{
		return Paint.class;
	}

	public Class[] getScope()
	{
		return new Class[] { SVGStylable.class };
	}

	public void doAction(Action action)
	{
		Paint paint = (Paint) action;
		String previousColorName = fill(paint.getColorName());
		paint.setData(previousColorName);
	}

	public void undoActions(Action[] actions)
	{
		fill((String) actions[0].getData());
	}

	public void redoActions(Action[] actions)
	{
		Paint paint = (Paint) actions[actions.length - 1];
		fill(paint.getColorName());
	}

	protected String fill(String newColorName)
	{
		SVGStylable stylable = (SVGStylable) getWrappedElement();
		CSSValue fillValue = stylable.getPresentationAttribute("fill");
		String previousColorName = fillValue.getCssText();
		fillValue.setCssText(newColorName);
		return previousColorName;
	}
}