/*
 * Created on 7 avr. 2005
 *
 *  * Copyright 2004-2008 Frdric FONDEMENT
 */
package interactions;

import interfaces.Stickable;

import java.awt.event.MouseEvent;
import java.awt.event.MouseWheelEvent;
import java.awt.geom.Point2D;

import testFab.Pointer;
import actions.PullLine;
import actions.Stick;
import dopidom.Component;
import dopidom.svg.SVGCleanToolInteractor;
import dopidom.svg.SVGComponent;
import dopidom.svg.SVGInteraction;
import dopidom.svg.SVGPicking;
import dopidom.svg.SVGScene;

/**
 * @author fondemen
 *
 *  * Copyright 2004-2008 Frdric FONDEMENT
 */
public class Attacher extends SVGInteraction {
	
	protected double fromX;
	protected double fromY;
	protected boolean attaching = false;
	protected Component source = null;

	/**
	 * @param interactor
	 */
	public Attacher(SVGCleanToolInteractor interactor) {
		super(interactor);
	}
	
	public void mousePressed(MouseEvent e) {
		// if Component isn't BorderSlidable get out
		Pointer it = (Pointer)this.getInteractor();
		// TODO : problem : Slider a besoin du select ke Pointer a fait, mais pointer execute Slider avant car il doit executer la super methode avant pour avoir previousX et previousY
		SVGPicking picking = SVGScene.getInstance().getPickedElementsUnder(e.getX(), e.getY(), it.getWrappedElement());
		//SVGScene.getInstance().getPickedElementsWithin(e.getX(), e.getY(), it.getWrappedElement());
		
		if (picking == null || !picking.hasActionConsumer(PullLine.class))
			return;
		if (e.getClickCount() == 1) {
			switch (e.getButton()) {
				case MouseEvent.BUTTON2 :
					// get the Component to whom the arrow is attached
					this.source = (Component)picking.getActionConsumer(PullLine.class);
					this.attaching = true;
					this.fromX = e.getX();
					this.fromY = e.getY();
					this.source.getActionInterface(PullLine.class).beginInteraction();
					break;
			}
		}
	}
	
	public void mouseDragged(MouseEvent e) {
		if (!this.attaching)
			return;
		Pointer it = (Pointer)this.getInteractor();
		PullLine line = new PullLine (new Point2D.Double(this.fromX, this.fromY), new Point2D.Double(e.getX(), e.getY()));
		it.doActionOn(line, this.source);
	}

	/* (non-Javadoc)
	 * @see java.awt.event.MouseListener#mouseReleased(java.awt.event.MouseEvent)
	 */
	public void mouseReleased(MouseEvent e) {
		if (!this.attaching)
			return;
		System.out.println ("trying to set attachment");
		this.attaching = false;
		this.source.getActionInterface(PullLine.class).endInteraction();
		Pointer it = (Pointer)this.getInteractor();
		SVGPicking picking = SVGScene.getInstance().getPickedElementsUnder(e.getX(), e.getY(), it.getWrappedElement());

		boolean actionDone = false;
		Component c;
		/* UNCOMMENT THIS TO ENABLE LINK CREATION BY ATTACHEMENT
		 * if you do this, you have to find a way to instanciate new arrow nodes in Link constructor
		 * if it's an link created with attacher, or if it's a normal link loaded in SVG file (there you don't have to instanciate new nodes)
		if (this.source.canDoAction(LinkAction.class)) {
			if (actionDone)
				return;
			c = (SVGComponent)picking.getQueryConsumer(GetBorder.class);
			if (c!=null && c instanceof SVGComponent) {
				//FIXME : on ne dois pas nommer de classe comme AnchorPoint mais seulement nommer des interactions !
				actionDone = true;
				((AnchorPoint)this.source).attachTo((AnchorPoint)c);
			}
		}
		*/
		if (this.source.canDoAction(Stick.class)) {
			if (actionDone)
				return;
			System.out.println("trying to stick");
			Stickable stick = (Stickable)this.source.getActionInterface(Stick.class);
			c = picking.getComponent();
			if (c!=null && c instanceof SVGComponent) {
				actionDone=true;
				if (stick.addSticker(c)) {
					System.out.println ("new sticker added ! :");
					System.out.println (c.toString());
				}
			}
		}
	}
	
	/* (non-Javadoc)
	 * @see java.awt.event.MouseWheelListener#mouseWheelMoved(java.awt.event.MouseWheelEvent)
	 */
	public void mouseWheelMoved(MouseWheelEvent e) {

	}
}
