/*
 * Created on 7 avr. 2005
 *
 *  * Copyright 2004-2008 Frdric FONDEMENT
 */
package interactions;

import interpretor.Variable;

import java.awt.event.KeyEvent;
import java.io.File;
import java.io.IOException;
import java.net.MalformedURLException;
import java.util.ArrayList;
import java.util.List;

import javax.jmi.reflect.RefObject;
import javax.jmi.xmi.MalformedXMIException;
import javax.swing.JFileChooser;
import javax.swing.filechooser.FileFilter;

import test.GUI.GUI;
import test.languageloading.InitFileFilterClass;
import test.languageloading.ScriptFileFilterClass;
import test.model.ModelHelper;
import utils.AWK;

import dopidom.svg.SVGCleanToolInteractor;
import dopidom.svg.SVGInteraction;
import dopidom.svg.SVGScene;

/**
 * @author fondemen
 *
 *  * Copyright 2004-2008 Frdric FONDEMENT
 */
public class Loader extends SVGInteraction {

	public static final String LoadKind = "load";
	public static final String SVGFileName = "SVGFile";
	protected static final ScriptFileFilterClass loader = new ScriptFileFilterClass(LoadKind);
	
	/**
	 * @param interactor
	 */
	public Loader(SVGCleanToolInteractor interactor) {
		super(interactor);
	}
	
	public void keyPressed(KeyEvent e) {
		if (e.isControlDown() && e.getKeyCode() == KeyEvent.VK_L) {
			JFileChooser fc = new JFileChooser(); 
			fc.setFileFilter(new FileFilter() {
					public boolean accept(File pathname) {
						return pathname.isDirectory() || pathname.getName().endsWith(".svg");
					}

				    public String getDescription() {
				    	return "SVG File";
				    }
				});
			if (fc.showOpenDialog(null) == JFileChooser.APPROVE_OPTION) {
				final File f = fc.getSelectedFile();
				try {
					SVGScene.getInstance().loadSVGDocument(f.toURL().toString());
					
					GUI gui = GUI.INSTANCE;
					if (gui != null && gui.getLanguageDirectory() != null) {
						List<Variable> additionalVars = new ArrayList<Variable>(1);
						additionalVars.add(new Variable () {

							public String getName() {
								return SVGFileName;
							}

							public Object getValue() {
								return f.getAbsolutePath();
							}});
						loader.run(new File(gui.getLanguageDirectory()), null, additionalVars);
					}
				} catch (MalformedURLException e1) {
					throw new RuntimeException("Problem while loading an SVG file.", e1);
				}
			}
		}
	}
}
