/*
 * Created on 7 avr. 2005
 *
 *  * Copyright 2004-2008 Frdric FONDEMENT
 */
package interactions;

import interpretor.Variable;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.event.KeyEvent;
import java.awt.geom.AffineTransform;
import java.awt.print.PageFormat;
import java.awt.print.Printable;
import java.awt.print.PrinterException;
import java.awt.print.PrinterJob;
import java.io.File;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;
import java.util.Locale;

import javax.jmi.xmi.MalformedXMIException;
import javax.print.DocFlavor;
import javax.print.PrintService;
import javax.print.PrintServiceLookup;
import javax.print.StreamPrintServiceFactory;
import javax.print.attribute.HashPrintRequestAttributeSet;
import javax.print.attribute.PrintRequestAttributeSet;
import javax.print.attribute.standard.JobName;
import javax.swing.JFileChooser;
import javax.swing.JOptionPane;
import javax.swing.filechooser.FileFilter;

import org.apache.batik.transcoder.TranscoderInput;
import org.apache.batik.transcoder.print.PrintTranscoder;

import test.GUI.GUI;
import test.languageloading.ScriptFileFilterClass;
import test.model.ModelHelper;
import test.selection.SelectionManager;
import utils.AWK;

import dopidom.Component;
import dopidom.svg.SVGCleanToolInteractor;
import dopidom.svg.SVGInteraction;
import dopidom.svg.SVGScene;

/**
 * @author fondemen
 *
 *  * Copyright 2004-2008 Frdric FONDEMENT
 */
public class Printer extends SVGInteraction {
	public static final String SaveKind = "save";
	public static final String SVGFileName = "SVGFile";
	protected static final ScriptFileFilterClass saver = new ScriptFileFilterClass(SaveKind);
	
	/**
	 * @param interactor
	 */
	public Printer(SVGCleanToolInteractor interactor) {
		super(interactor);
	}
	
	public void keyPressed(KeyEvent e) {
		if (e.isControlDown() && e.getKeyCode() == KeyEvent.VK_P) {
			//Component[] selected = SelectionManager.INSTANCE.getSelectedComponents();
			try {
				//SelectionManager.INSTANCE.setSelectedComponent(null);
				

		        PrintRequestAttributeSet aset = new HashPrintRequestAttributeSet();
		        PrinterJob pj = PrinterJob.getPrinterJob();
		        
		        pj.setPrintable(SVGScene.getInstance());
		        PrintService[] services = PrinterJob.lookupPrintServices();
		        if (services.length > 0) {
					try {
						pj.setPrintService(services[0]);
						aset.add(new JobName(GUI.INSTANCE.getTitle(), Locale.getDefault()));
						if(pj.printDialog(aset)) {
							pj.print(aset);
						}
					} catch (PrinterException pe) { 
						System.err.println(pe);
					}
				} else
			        JOptionPane.showMessageDialog(GUI.INSTANCE, "No print service found", "Print", JOptionPane.ERROR_MESSAGE);
			} catch (Exception e1) {
				e1.printStackTrace();
				JOptionPane.showMessageDialog(null, e1.getMessage(), "Problem while printing " + GUI.INSTANCE.getTitle(), JOptionPane.ERROR_MESSAGE);
			} finally  {
				//SelectionManager.INSTANCE.setSelectedComponents(selected);
			}
		}
	}
}
