/*
 * Created on 7 avr. 2005
 *
 *  * Copyright 2004-2008 Frdric FONDEMENT
 */
package interactions;

import interpretor.Variable;

import java.awt.event.KeyEvent;
import java.io.File;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

import javax.jmi.xmi.MalformedXMIException;
import javax.swing.JFileChooser;
import javax.swing.JOptionPane;
import javax.swing.filechooser.FileFilter;

import test.GUI.GUI;
import test.languageloading.ScriptFileFilterClass;
import test.model.ModelHelper;
import test.selection.SelectionManager;
import utils.AWK;

import dopidom.Component;
import dopidom.svg.SVGCleanToolInteractor;
import dopidom.svg.SVGInteraction;
import dopidom.svg.SVGScene;

/**
 * @author fondemen
 *
 *  * Copyright 2004-2008 Frdric FONDEMENT
 */
public class Saver extends SVGInteraction {
	public static final String SaveKind = "save";
	public static final String SVGFileName = "SVGFile";
	protected static final ScriptFileFilterClass saver = new ScriptFileFilterClass(SaveKind);
	
	/**
	 * @param interactor
	 */
	public Saver(SVGCleanToolInteractor interactor) {
		super(interactor);
	}
	
	public void keyPressed(KeyEvent e) {
		if (e.isControlDown() && e.getKeyCode() == KeyEvent.VK_S) {
			JFileChooser fc = new JFileChooser(); 
			fc.setFileFilter(new FileFilter() {
					public boolean accept(File pathname) {
						return pathname.isDirectory() || pathname.getName().toLowerCase().endsWith(".svg");
					}

				    public String getDescription() {
				    	return "SVG File";
				    }
				});
			if (fc.showSaveDialog(null) == JFileChooser.APPROVE_OPTION) {
				File f = fc.getSelectedFile();
				if (! f.getName().toLowerCase().endsWith(".svg"))
					f = new File(f.getParentFile(), f.getName() + ".svg");
				try {
					Component[] selected = SelectionManager.INSTANCE.getSelectedComponents();
					SelectionManager.INSTANCE.setSelectedComponent(null);
					SVGScene.getInstance().saveSVGDocument(f.getAbsolutePath());
					SelectionManager.INSTANCE.setSelectedComponents(selected);
					
					
					GUI gui = GUI.INSTANCE;
					if (gui != null && gui.getLanguageDirectory() != null) {
						List<Variable> additionalVars = new ArrayList<Variable>(1);
						final String svgFile = f.getAbsolutePath();
						additionalVars.add(new Variable () {

							public String getName() {
								return SVGFileName;
							}

							public Object getValue() {
								return svgFile;
							}});
						saver.run(new File(gui.getLanguageDirectory()), null, additionalVars);
					}
				} catch (IOException e1) {
					e1.printStackTrace();
					JOptionPane.showMessageDialog(null, e1.getMessage(), "Problem while saving " + f.getAbsolutePath(), JOptionPane.ERROR_MESSAGE);
				}
			}
		}
	}
}
