/*
 * Created on 7 avr. 2005
 *
 *  * Copyright 2004-2008 Frdric FONDEMENT
 */
package interactions;

import interfaces.BorderSlidable;

import java.awt.event.MouseEvent;

import queries.GetBorder;
import test.selection.SelectionManager;
import testFab.Pointer;
import actions.BorderSlide;
import dopidom.Component;
import dopidom.svg.SVGCleanToolInteractor;
import dopidom.svg.SVGInteraction;
import dopidom.svg.SVGPicking;
import dopidom.svg.SVGScene;

/**
 * @author fondemen
 *
 *  * Copyright 2004-2008 Frdric FONDEMENT
 */
public class Slider extends SVGInteraction {
	
	protected GetBorder border = null;
	protected boolean borderGot = false;
	protected Component source = null;

	/**
	 * @param interactor
	 */
	public Slider(SVGCleanToolInteractor interactor) {
		super(interactor);
	}
	
	public void mousePressed(MouseEvent e) {
		// if Component isn't BorderSlidable get out
		Pointer it = (Pointer)this.getInteractor();
		// TODO : problem : Slider a besoin du select ke Pointer a fait, mais pointer execute Slider avant car il doit executer la super methode avant pour avoir previousX et previousY
		SVGPicking picking = SVGScene.getInstance().getPickedElementsUnder(e.getX(), e.getY(), it.getWrappedElement());
		if (picking == null || !picking.hasActionConsumer(BorderSlide.class))
			return;
		System.err.println ("picking non vide et selection est border slidable");
		if (e.getClickCount() == 1) {
			switch (e.getButton()) {
				case MouseEvent.BUTTON1 :
					// get the Component to whom the arrow is attached
					// TODO : et si c'est pas un arrow ? essayer de gnraliser !
					
					Component c = ((BorderSlidable)picking.getActionConsumer(BorderSlide.class).getActionInterface(BorderSlide.class)).getAttachedComponent();
					if (c==null) {
						System.err.println ("The arrow isn't attached to any Component !");
						return;
					}
					// it should be borderFindable so get the border
					if (!c.canDoQuery(GetBorder.class)) {
						System.err.println ("The Component to whom the arrow is attached isn't BorderFindable !");
						return;
					}
					this.border = new GetBorder();
					this.borderGot = true;
					this.source = (Component)picking.getActionConsumer(BorderSlide.class);
					if (!(c.canDoQuery(GetBorder.class))) {
						System.err.println("the Component attached to the arrow can not execute getBorder !");
						return;
					}
					c.getQueryInterface(GetBorder.class).doQuery(this.border);
					break;
			}
		}
	}
	
	public void mouseDragged(MouseEvent e) {
		if (!this.borderGot)
			return;
		Pointer it = (Pointer)this.getInteractor();
		// TODO : resoudre le problme du de l'ordre d'execution des methodes de souris. L'objet a t il t selectionn ?
		Component c = SelectionManager.INSTANCE.getSelectedComponent();
		if (c == null)
		{
			System.err.println ("aucune selection !");
			return;
		}
		if (!c.canDoAction(BorderSlide.class)) {
			return;			
		}
		if (((BorderSlidable)this.source.getActionInterface(BorderSlide.class)).attached()) {
			double deltaX = this.border.getLocation().getX();
			double deltaY = this.border.getLocation().getY();
			BorderSlide slide = new BorderSlide (e.getX()- deltaX, e.getY()-deltaY, this.border.getPoints(), deltaX, deltaY);
			it.doActionOn(slide, c);
		}
	}
	
	/* (non-Javadoc)
	 * @see java.awt.event.MouseListener#mouseReleased(java.awt.event.MouseEvent)
	 */
	public void mouseReleased(MouseEvent e) {
		this.borderGot = false;
	}
}
