/*
 * Created on 14 mars 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package interfaces;

import java.awt.geom.Point2D;
import java.util.ArrayList;
import java.util.List;

import org.apache.batik.gvt.GraphicsNode;
import org.w3c.dom.Element;
import org.w3c.dom.svg.SVGLocatable;

import queries.GetBorder;
import utils.PointsDecomposer;
import dopidom.Component;
import dopidom.Query;
import dopidom.svg.SVGQueryInterface;
import dopidom.svg.SVGScene;

/**
 * @author Olivier Beaudoux
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class BorderFindable extends SVGQueryInterface
{
//	public final static String[] acceptedTypes = {"polygon", "rect", "circle", "line"};
//	//final int numberCircleSteps = 16;
//	final double stepLength = 15;
	
	public BorderFindable(Component ownerComponent)
	{
		super(ownerComponent);
	}

	public Class getQuery()
	{
		return GetBorder.class;
	}

	public Class[] getScope()
	{
		return new Class[] { SVGLocatable.class };
	}

	public synchronized void doQuery(Query query)
	{
		GetBorder border = (GetBorder)query;
		Element e = (Element)getWrappedElement();
		List points = getPoints (e);
		border.setPoints(points);
		border.setLocation(getLocation());
	}

	private Point2D getLocation() {
		GraphicsNode gn = SVGScene.getInstance().getGVTNode(getWrappedElement());
		Point2D ret = new Point2D.Double();
		gn.getGlobalTransform().transform(new Point2D.Double(0, 0), ret);
		return ret;
	}
	
	private List getPoints(Element node) {
		return PointsDecomposer.getPoints(node);
	}
}
