/*
 * Created on 12 mars 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package interfaces;

import ihm04.actions.Translate;

import java.awt.geom.Line2D;
import java.awt.geom.Point2D;
import java.util.ArrayList;
import java.util.List;

import org.apache.batik.gvt.GraphicsNode;
import org.w3c.dom.svg.SVGTransformable;

import queries.GetBorder;
import test.listeners.SVGListenableActionInterface;
import test.queries.Location;
import utils.ComponentVarPersistant;
import PBXSComponents.Arrow;
import PBXSComponents.Link;
import actions.BorderSlide;
import actions.Stick;
import dopidom.Action;
import dopidom.Component;
import dopidom.svg.SVGActionInterface;
import dopidom.svg.SVGScene;

/**
 * @author Olivier Beaudoux
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public abstract class BorderSlidable extends SVGListenableActionInterface
{
	List points = null;
	// FIXME: attention le attachedComponent etais final a la base (invokeLatter ?)
	protected ComponentVarPersistant attachedComponent = new ComponentVarPersistant(this.getWrappedElement(), "BorderSlidable", "attachedComponent");

	public BorderSlidable(Component ownerComponent)
	{
		super(ownerComponent);
		if (! ownerComponent.canDoQuery(Location.class))
			throw new RuntimeException("a border slidable must be locatable");
	}

	public Class getAction()
	{
		return BorderSlide.class;
	}

	public Class[] getScope()
	{
		return new Class[] { SVGTransformable.class };
	}

	public void act(Action action)
	{
		BorderSlide borderSlide = (BorderSlide) action;
		Location sl = new Location();
		this.getOwnerComponent().getQueryInterface(Location.class).doQuery(sl);
		this.points = borderSlide.getBorder();
		Point2D pointOnBorder = getNearestPointFromLinePair(getLinePairFromIndex(getNearestPointIndex(borderSlide.getPosX(),borderSlide.getPosY())), borderSlide.getPosX(), borderSlide.getPosY());
		//Point2D.Double pointOnBorder = new Point2D.Double(borderSlide.getPosX(), borderSlide.getPosY());
		putOnBorder(pointOnBorder.getX(), pointOnBorder.getY(), new Point2D.Double(borderSlide.getLocX(), borderSlide.getLocY()));
		//if (this.getOwnerComponent() instanceof Arrow)
		//	((Arrow)this.getOwnerComponent()).adjustArrow();
		Location el = new Location();
		this.getOwnerComponent().getQueryInterface(Location.class).doQuery(el);
		borderSlide.setDeltaX(el.getX()-sl.getX());
		borderSlide.setDeltaY(el.getY()-sl.getY());
	}
// TODO : change undo and redo actions !!!
	public void tca(Action[] actions)
	{
		Translate sum = sumTranslates(actions);
		putOnBorder(-sum.getDeltaX(), -sum.getDeltaY(), new Point2D.Double(0,0));
	}

	public void redoActions(Action[] actions)
	{
		Translate sum = sumTranslates(actions);
		putOnBorder(sum.getDeltaX(), sum.getDeltaY(), new Point2D.Double(0,0));
	}

	protected void putOnBorder(double x, double y, Point2D location)
	{
		/*
		SVGTransformable transformable = (SVGTransformable) getWrappedElement();
		SVGMatrix matrix = transformable.getTransform().getBaseVal().consolidate().getMatrix();
		//matrix.setE(x);
		//matrix.setF(y);
		matrix.setE(x + (float)location.getX());
		matrix.setF(y + (float)location.getY());
		*/
		// FIXME: optimize speed
		
		Link link = ((Arrow)this.getOwnerComponent()).getAttachedLink();
		Arrow arrow = (Arrow)this.getOwnerComponent();
		if (arrow.hasLink()) {
			if (arrow.isStartArrow())
				link.setStartLocation(new Point2D.Double((float) (x+location.getX()),(float) (y+location.getY())));
			else
				link.setEndLocation(new Point2D.Double((float) (x+location.getX()),(float) (y+location.getY())));
		}
		
		
	}

	protected Translate sumTranslates(Action[] actions)
	{
		float dx = 0;
		float dy = 0;
		for (int a = 0; a < actions.length; a++)
		{
			Translate translate = (Translate) actions[a];
			dx += translate.getDeltaX();
			dy += translate.getDeltaY();
		}
		return new Translate(dx, dy);
	}

	private int getNearestPointIndex (double px, double py){
		double dstMin = Double.MAX_VALUE;
		double dst;
		int iMin = 0;
		for (int x = 0; x < points.size(); x++) {
			dst = ((Point2D.Double)points.get(x)).distance (px, py);
			if (dst < dstMin)
			{
				dstMin = dst;
				iMin = x;
			}
		}
		return iMin;
	}

	private Point2D getNearestPointFromLinePair (List pair, double px, double py) {
		Line2D theLine1 = (Line2D)pair.get(0);
		Line2D theLine2 = new Line2D.Double();
		//if there is 2 line
		if(pair.size() > 1) {
			theLine2 = (Line2D)pair.get(1);
		}
		// if there is 2 lines
		if (pair.size() > 1) {
			if (theLine1.ptSegDist(px, py) > theLine2.ptSegDist(px, py))
				theLine1 = theLine2;
		}
		// if the point is not in range of the Line the nearest point will be the intersection of the two lines
		if (theLine1.ptLineDist(px, py) < theLine1.ptSegDist(px, py)) {
			if (theLine1.getP1().distance(px, py) > theLine1.getP2().distance(px, py))
				return theLine1.getP2();
			else
				return theLine1.getP1();
		}
		else {
			double px1 = theLine1.getP1().getX();
			double py1 = theLine1.getP1().getY();
			double px2 = theLine1.getP2().getX();
			double py2 = theLine1.getP2().getY();
			double newX;
			double newY;
			if (px2 == px1) {
				newX = px1;
				newY = py;
			} else if (py2 == py1) {
				newX = px;
				newY = py1;
			}else {
				double pente = (py2 - py1)/(px2 - px1);
				double b = py1 - pente * px1;
				newX = (((double)px)/pente + py - b)/(pente + 1/pente);
				newY = pente * newX + b;
			}
			return new Point2D.Double (newX, newY);
		}
	}
	
	private List getLinePairFromIndex (int i) {
		int nextPoint;
		List list = new ArrayList();
		Line2D l1 = new Line2D.Double();
		Line2D l2 = new Line2D.Double();
		if ( points.size() < 2)
			return list;
		else
		{
			if (i==points.size()-1)
				nextPoint = 0;
			else 
				nextPoint = i+1;
			l1.setLine( ((Point2D)points.get(i)).getX(), ((Point2D)points.get(i)).getY(),((Point2D)points.get(nextPoint)).getX(), ((Point2D)points.get(nextPoint)).getY());
			if (i==0)
				nextPoint = points.size()-1;
			else 
				nextPoint = i-1;
			l2.setLine( ((Point2D)points.get(nextPoint)).getX(), ((Point2D)points.get(nextPoint)).getY(),((Point2D)points.get(i)).getX(), ((Point2D)points.get(i)).getY());
		}
		list.add(l1);
		list.add(l2);
		return list;
	}
	
	public boolean attachTo (BorderFindable anchor) {
		if (! setAttachedComponent(anchor.getOwnerComponent()))
			return false;
		// get the origin of the component
		GraphicsNode gn = SVGScene.getInstance().getGVTNode(anchor.getWrappedElement());
		Point2D loc = new Point2D.Double();
		gn.getGlobalTransform().transform(new Point2D.Double(0, 0), loc);
		
		// get the border of the anchor
		GetBorder border = new GetBorder();
		anchor.doQuery(border);
		// FIXME: it would be good if the attach point is the nearest point from the other anchor.getAnchor() point on the border
		Point2D pt = (Point2D.Double)border.getPoints().get(0);
		setLocation (new Point2D.Double (pt.getX()+loc.getX(), pt.getY()+loc.getY()));
		SVGScene.getInstance().getDocument().getDocumentElement().appendChild(getWrappedElement());
		return true;
	}
	
	public abstract void setLocation (Point2D point);

	// FIXME: attention le attachedComponent etais final a la base (invokeLatter ?)
	public Component getAttachedComponent() {
		return attachedComponent.get();
	}
	
	// FIXME: attention le attachedComponent etais final a la base (invokeLatter ?)
	public boolean setAttachedComponent(Component attachedComponent) {
		if (!attachedComponent.canDoAction(Stick.class))
			throw new RuntimeException("Arrows must be attached to Stickable Component");

		Component old = this.attachedComponent.get();
		if (old != null)
			if (!((Stickable)old.getActionInterface(Stick.class)).removeSticker(this.getOwnerComponent()))
				return false;
			
		if (!((Stickable)attachedComponent.getActionInterface(Stick.class)).addSticker(this.getOwnerComponent()))
			return false;
			
		this.attachedComponent.set(attachedComponent);
		return true;
	}
	
	public boolean attached() {
		return this.attachedComponent.isSet();
	}
}