/*
 * Created on 12 mars 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package interfaces;

import java.awt.geom.Point2D;

import org.apache.batik.util.SVGConstants;
import org.w3c.dom.Element;
import org.w3c.dom.svg.SVGAnimatedTransformList;
import org.w3c.dom.svg.SVGMatrix;
import org.w3c.dom.svg.SVGTransform;
import org.w3c.dom.svg.SVGTransformList;
import org.w3c.dom.svg.SVGTransformable;

import test.listeners.SVGListenableActionInterface;
import utils.LineDescription;

import PBXSComponents.CurvedLine;
import PBXSComponents.LineHandle;
import actions.Handle;
import dopidom.Action;
import dopidom.Component;
import dopidom.svg.SVGActionInterface;

/**
 * @author Olivier Beaudoux
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class Handlable extends SVGListenableActionInterface
{

	public Handlable(Component ownerComponent)
	{
		super(ownerComponent);
	}

	public Class getAction()
	{
		return Handle.class;
	}

	public Class[] getScope()
	{
		return new Class[] { SVGTransformable.class };
	}

	public void act(Action action)
	{
		Handle handle = (Handle)action;
		CurvedLine curvedLine = ((LineHandle)this.getOwnerComponent()).getAttachedLine();
		LineHandle lineHandle = (LineHandle)this.getOwnerComponent();
		

		Point2D sp = curvedLine.getLineDescription().getHandle(lineHandle.getHIndex());
		
		curvedLine.setHandle(lineHandle.getHIndex(), new Point2D.Double(handle.getPosX(), handle.getPosY()));
		translate(handle.getPosX(), handle.getPosY());

		Point2D ep = curvedLine.getLineDescription().getHandle(lineHandle.getHIndex());
		handle.setDeltaX(ep.getX()-sp.getX());
		handle.setDeltaY(ep.getY()-sp.getY());
	}

	protected void translate(double x, double y)
	{
		if (x == 0 && y == 0)
			return;
		SVGTransformable transformable = (SVGTransformable) getWrappedElement();
		if (transformable == null) {
			System.err.println ("L'objet n'est pas transformable");
			return;
		}
		
		if (((Element)transformable).getAttributeNode(SVGConstants.SVG_TRANSFORM_ATTRIBUTE) == null) {
			((Element)transformable).setAttribute(SVGConstants.SVG_TRANSFORM_ATTRIBUTE, SVGConstants.TRANSFORM_TRANSLATE + "(0,0)");
		}
		
		SVGAnimatedTransformList satl = transformable.getTransform();
		SVGTransformList stl = satl.getBaseVal();
		SVGTransform st = stl.consolidate();
		SVGMatrix matrix = st.getMatrix();
		matrix.setE((float)x);
		matrix.setF((float)y);
	}
	
	
// TODO : change undo and redo actions !!!
	public void tca(Action[] actions)
	{
	}

	public void redoActions(Action[] actions)
	{
	}


}