/*
 * Created on 12 mars 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package interfaces;

import org.apache.batik.util.SVGConstants;
import org.w3c.dom.svg.SVGLineElement;
import org.w3c.dom.svg.SVGTransformable;

import test.templates.SVGTemplate;
import actions.PullLine;
import dopidom.Action;
import dopidom.Component;
import dopidom.svg.SVGActionInterface;
import dopidom.svg.SVGScene;

/**
 * @author Olivier Beaudoux
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class LinePullable extends SVGActionInterface
{
	String lineID = new String();
	SVGLineElement pulledLine = null;
	
	public void beginInteraction() {
		// TODO Auto-generated method stub
		super.beginInteraction();

		this.pulledLine = (SVGLineElement)SVGScene.getInstance().getDocument().createElementNS(SVGTemplate.SVGElementNS, "line");
		pulledLine.setAttribute(SVGConstants.SVG_X1_ATTRIBUTE, "0");
		pulledLine.setAttribute(SVGConstants.SVG_Y1_ATTRIBUTE, "0");
		pulledLine.setAttribute(SVGConstants.SVG_X2_ATTRIBUTE, "0");
		pulledLine.setAttribute(SVGConstants.SVG_Y2_ATTRIBUTE, "0");
		pulledLine.setAttribute(SVGConstants.SVG_STROKE_ATTRIBUTE, "black");
		pulledLine.setAttribute(SVGConstants.SVG_STROKE_WIDTH_ATTRIBUTE, "1");
		pulledLine.setAttribute(SVGConstants.SVG_STROKE_DASHARRAY_ATTRIBUTE, "3");
		pulledLine.setAttribute(SVGConstants.SVG_STROKE_DASHOFFSET_ATTRIBUTE, "2");
		pulledLine.setAttribute(SVGConstants.SVG_STROKE_OPACITY_ATTRIBUTE, "0.4");

		SVGScene.getInstance().getCanvas().getSVGDocument().getRootElement().appendChild(this.pulledLine);
	}
	public void endInteraction() {
		super.endInteraction();
		SVGScene.getInstance().getCanvas().getSVGDocument().getRootElement().removeChild(this.pulledLine);
		this.pulledLine = null;
	}
	public LinePullable(Component ownerComponent)
	{
		super(ownerComponent);
	}

	public Class getAction()
	{
		return PullLine.class;
	}

	public Class[] getScope()
	{
		return new Class[] { SVGTransformable.class };
	}

	public void doAction(Action action)
	{
		PullLine line = (PullLine) action;
		drawLine (line.getP1().getX(), line.getP1().getY(), line.getP2().getX(), line.getP2().getY());
	}
// TODO : change undo and redo actions !!!
	public void undoActions(Action[] actions)
	{
//		Translate sum = sumTranslates(actions);
//		putOnBorder(-sum.getDeltaX(), -sum.getDeltaY());
	}

	public void redoActions(Action[] actions)
	{
//		Translate sum = sumTranslates(actions);
//		putOnBorder(sum.getDeltaX(), sum.getDeltaY());
	}

	protected void drawLine (double fromX, double fromY, double toX, double toY) {
		if (this.pulledLine==null)
			return;
		this.pulledLine.setAttribute(SVGConstants.SVG_X1_ATTRIBUTE, new Double(fromX).toString());
		this.pulledLine.setAttribute(SVGConstants.SVG_Y1_ATTRIBUTE, new Double(fromY).toString());
		this.pulledLine.setAttribute(SVGConstants.SVG_X2_ATTRIBUTE, new Double(toX).toString());
		this.pulledLine.setAttribute(SVGConstants.SVG_Y2_ATTRIBUTE, new Double(toY).toString());
	}
	
}