/*
 * Created on 12 mars 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package interfaces;

import listeners.DefaultListenable;
import listeners.Event;
import listeners.EventKind;
import listeners.Listenable;
import listeners.Listener;
import listeners.UncheckedEventException;

import org.apache.batik.util.SVGConstants;
import org.w3c.dom.Element;
import org.w3c.dom.svg.SVGMatrix;
import org.w3c.dom.svg.SVGTransformable;

import actions.Position;
import dopidom.Action;
import dopidom.Component;
import dopidom.svg.SVGActionInterface;
import event.CreationEvent;
import event.PositionEvent;
import event.TranslateEvent;

/**
 * @author Olivier Beaudoux
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class Positionable extends SVGActionInterface implements Listenable
{
	public static final DefaultListenable PositionableListener = new DefaultListenable();
	private DefaultListenable listenableDelegate = new DefaultListenable();
	
	public Positionable(Component ownerComponent)
	{
		super(ownerComponent);
		PositionableListener.testAndFireEvent(new CreationEvent(EventKind.PositionableCreated, this));
	}
	
	public Class getAction()
	{
		return Position.class;
	}
	
	public Class[] getScope()
	{
		return new Class[] { SVGTransformable.class };
	}
	
	public void doAction(Action action)
	{
		Position pos = (Position) action;
		SVGTransformable transformable = (SVGTransformable) getWrappedElement();
		if (transformable == null) {
			System.err.println ("L'objet n'est pas transformable");
			return;
		}
		
		if (((Element)transformable).getAttributeNode(SVGConstants.SVG_TRANSFORM_ATTRIBUTE) == null) {
			((Element)transformable).setAttribute(SVGConstants.SVG_TRANSFORM_ATTRIBUTE, SVGConstants.TRANSFORM_TRANSLATE + "(0,0)");
		}
		
		SVGMatrix matrix = transformable.getTransform().getBaseVal().consolidate().getMatrix();
		matrix.setE((float) (pos.getX()));
		matrix.setF((float) (pos.getY()));
		this.testAndFireEvent(new PositionEvent(this.ownerComponent, pos.getX(), pos.getY()));
	}
	public void undoActions(Action[] actions)
	{
	}
	
	public void redoActions(Action[] actions)
	{
	}
	public void addListener(Listener l) {
		this.listenableDelegate.addListener(l);
	}
	
	public void removeListener(Listener l) {
		this.listenableDelegate.removeListener(l);
	}
	
	public void fireEvent(Event e) throws UncheckedEventException {
		this.listenableDelegate.fireEvent(e);
	}
	
	public void checkEvent(Event e) {
		this.listenableDelegate.checkEvent(e);
	}
	
	public boolean testAndFireEvent(Event e) {
		return this.listenableDelegate.testAndFireEvent(e);
	}
	
}