/*
 * Created on 12 mars 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package interfaces;

import listeners.DefaultListenable;
import listeners.Event;
import listeners.EventKind;
import listeners.Listenable;
import listeners.Listener;
import listeners.UncheckedEventException;
import ihm04.actions.Translate;

import org.apache.batik.util.SVGConstants;
import org.w3c.dom.Element;
import org.w3c.dom.svg.SVGAnimatedTransformList;
import org.w3c.dom.svg.SVGMatrix;
import org.w3c.dom.svg.SVGTransform;
import org.w3c.dom.svg.SVGTransformList;
import org.w3c.dom.svg.SVGTransformable;

import test.listeners.SVGListenableActionInterface;
import dopidom.Action;
import dopidom.Component;
import dopidom.svg.SVGScene;
import event.CreationEvent;
import event.StickEvent;
import event.TranslateEvent;

/**
 * @author Olivier Beaudoux
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class Translatable extends SVGListenableActionInterface implements Listenable
{
	static Translate currentTranslate;
	
	public static final DefaultListenable TranslatableListener = new DefaultListenable();
	private DefaultListenable listenableDelegate = new DefaultListenable();
	
	public Translatable(Component ownerComponent)
	{
		super(ownerComponent);
		TranslatableListener.testAndFireEvent(new CreationEvent(EventKind.TranslatableCreated, this));
	}

	public Class getAction()
	{
		return Translate.class;
	}

	public Class[] getScope()
	{
		return new Class[] { SVGTransformable.class };
	}

	protected void act(Action action)
	{
		Translatable.currentTranslate = (Translate) action;
		if (!  Translatable.currentTranslate.isDone()) {
			translate(Translatable.currentTranslate.getDeltaX(), Translatable.currentTranslate.getDeltaY());
	//		if (this.getOwnerComponent().canDoAction(Stick.class))
	//			this.getOwnerComponent().getActionInterface(Stick.class).doAction (new Stick (Translatable.currentTranslate.getDeltaX(), Translatable.currentTranslate.getDeltaY()));
			Translatable.currentTranslate.done();
		}
	}

	protected void fireSVGActionEvent(String eventType, Action action) {
		if (((Translate)action).isDone())
			super.fireSVGActionEvent(eventType, action);
	}

	public void tca(Action[] actions)
	{
		Translate sum = sumTranslates(actions);
		translate(-sum.getDeltaX(), -sum.getDeltaY());
	}

	public void redoActions(Action[] actions)
	{
		Translate sum = sumTranslates(actions);
		translate(sum.getDeltaX(), sum.getDeltaY());
	}

	protected void translate(double dx, double dy)
	{				
		if (dx == 0 && dy == 0)
			return;
		SVGTransformable transformable = (SVGTransformable) getWrappedElement();
		if (transformable == null) {
			System.err.println ("L'objet n'est pas transformable");
			return;
		}
		
		if (((Element)transformable).getAttributeNode(SVGConstants.SVG_TRANSFORM_ATTRIBUTE) == null) {
			((Element)transformable).setAttribute(SVGConstants.SVG_TRANSFORM_ATTRIBUTE, SVGConstants.TRANSFORM_TRANSLATE + "(0,0)");
		}
		
		SVGAnimatedTransformList satl = transformable.getTransform();
		SVGTransformList stl = satl.getBaseVal();
		SVGTransform st = stl.consolidate();
		SVGMatrix matrix = st.getMatrix();
		float posX = (float) (matrix.getE() + dx);
		float posY = (float) (matrix.getF() + dy);
		try {
		matrix.setE(posX);
		} catch (NullPointerException x) {} //bug in the CSVG constraint engine when the node was changed its ordering in the scene
		try {
		matrix.setF(posY);
		} catch (NullPointerException x) {} //bug in the CSVG constraint engine when the node was changed its ordering in the scene
		this.testAndFireEvent(new TranslateEvent(this.ownerComponent, posX, posY));
	}

	protected Translate sumTranslates(Action[] actions)
	{
		float dx = 0;
		float dy = 0;
		for (int a = 0; a < actions.length; a++)
		{
			Translate translate = (Translate) actions[a];
			dx += translate.getDeltaX();
			dy += translate.getDeltaY();
		}
		return new Translate(dx, dy);
	}
	
	public void addListener(Listener l) {
		this.listenableDelegate.addListener(l);
	}

	public void removeListener(Listener l) {
		this.listenableDelegate.removeListener(l);
	}

	public void fireEvent(Event e) throws UncheckedEventException {
		this.listenableDelegate.fireEvent(e);
	}

	public void checkEvent(Event e) {
		this.listenableDelegate.checkEvent(e);
	}

	public boolean testAndFireEvent(Event e) {
		return this.listenableDelegate.testAndFireEvent(e);
	}
}