package interpretor;

import java.util.Arrays;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;
import java.util.Set;

public class InterpretorFactory {
	
	private static Map<String, interpretorFacade> interpretors = new HashMap<String, interpretorFacade>();
	
	/** resyet all language interpreter environment */
	public static void resetInterpreters() {
		for (Iterator iter = interpretors.values().iterator(); iter.hasNext();) {
			interpretorFacade interpretor = (interpretorFacade) iter.next();
			interpretor.setEnvironment(null);
		}
	}

	/*
	 * Possible interpretors soulb be referenced here...
	 */
	public static interpretorFacade createInterpretorFacade(String language) {
		
		language = language.toLowerCase();
		interpretorFacade ret = interpretors.get(language);
		
		if (ret == null) {
			if (language.equals("java") || language.equals("koala"))
				ret = InterpretorFacadeKoala.getInstance();
			else if (language.equals("kermeta"))
				ret = interpretorFacadeKermeta.getInstance();
			else
				return null;
			
			interpretors.put(language, ret);
		}
		
		return ret;
	}
	
}
