package listeners;

public interface Listenable {

	void addListener(Listener l);
	void removeListener(Listener l);

	/**
	 * If no listener vetoes that eventm, it should be marked as checked
	 */
	void checkEvent(Event e);
	
	/**
	 *	should throw an UncheckedEventException exception if an event is not checked
	 */
	void fireEvent(Event e) throws UncheckedEventException;
	
	/**
	 * Check wheether the event is not vetoed before firing it ; if the event is vetoed, returns false;
	 */
	boolean testAndFireEvent(Event e);

}