package listeners;

public interface Listener {
	EventKind getEventKind();
	
	/**
	 * Gives a chance to the listener to avoid the execution of the expected event.
	 * If all listeners of the sending object accept, then the method receiveEvent should be called soon.
	 */
	boolean vetoesEvent(Event e);
	void receiveEvent(Event e);
}
