package listeners.initial;

import interpretor.InterpretorFacadeKoala;
import interpretor.InterpretorFactory;
import interpretor.Variable;
import interpretor.VariableKoala;
import interpretor.interpretorFacade;

import java.util.ArrayList;
import java.util.HashSet;

import javax.jmi.reflect.RefObject;

import org.w3c.dom.Node;

import test.interfaces.CharacterDeletable;
import utils.DomFinding;
import utils.ListenerFunctions;
import utils.ManipString;
import utils.SelfContainer;
import event.CharacterDeletedEvent;
import listeners.Event;
import listeners.EventKind;
import listeners.Listener;


public abstract class CharacterDeletableListenersInitiator {
	private CharacterDeletableListenersInitiator(){}
	
	protected static void initiateCharacterDeletableListener(CharacterDeletable cd) {
		cd.addListener(new Listener() {

			public EventKind getEventKind() {
				return EventKind.CharacterDeleted;
			}

			public void receiveEvent(Event e) {
				
				final CharacterDeletedEvent cde = (CharacterDeletedEvent)e;
				
				HashSet<String[]> listSpec = new HashSet<String[]>();
				
				String[] v1  = {"content", ManipString.createSerialization("String", cde.getNewText())};

				listSpec.add(v1);
				
				ListenerFunctions.foo("onChange",(Node)cde.getTextDeletedComponent().getWrappedElement(),listSpec);
			}
			
			

			public boolean vetoesEvent(Event e) {
				return false;
			}});
	}
}
