package listeners.initial;

import java.util.HashSet;

import org.w3c.dom.Node;

import utils.ListenerFunctions;
import utils.ManipString;

import interfaces.DirectionAdjustable;

import listeners.Event;
import listeners.EventKind;
import listeners.Listener;

import event.DirectionAdjustEvent;

public class DirectionAdjustableListenersInitiator {

	public DirectionAdjustableListenersInitiator() {}
	
	protected static void initiateDirectionAdjustableListener(DirectionAdjustable da) {
		
		da.addListener(new Listener() {

			public EventKind getEventKind() {
				return EventKind.DirectionAdjusted;
			}

			public void receiveEvent(Event e) {
				
				final DirectionAdjustEvent dae = (DirectionAdjustEvent)e;
				HashSet<String[]> listSpec = new HashSet<String[]>();
				
				String[] alpha = {"alpha",ManipString.createSerialization("Double", (new Double(dae.getAlpha())).toString())};
				
				listSpec.add(alpha);
				
				ListenerFunctions.foo("onRotate",(Node)dae.getDirectionAdjustedComponent().getWrappedElement(),listSpec);
			
			}

			public boolean vetoesEvent(Event e) {
				return false;
			}});

	}

}
