package listeners.initial;

import java.util.HashSet;

import org.w3c.dom.Node;

import listeners.Event;
import listeners.EventKind;
import listeners.Listener;
import test.interfaces.Locatable;
import utils.ListenerFunctions;
import utils.ManipString;
import event.LocateEvent;

public class LocatableListenersInitiator {

	public LocatableListenersInitiator() {}
	
	protected static void initiateLocatableListener(Locatable l) {
		
		l.addListener(new Listener() {

			public EventKind getEventKind() {
				return EventKind.Located;
			}

			public void receiveEvent(Event e) {
				
				final LocateEvent le = (LocateEvent)e;
				
				HashSet<String[]> listSpec = new HashSet<String[]>();
				
				String[] vX = {"posX",ManipString.createSerialization("Double", (new Double(le.getX())).toString())};
				String[] vY = {"posY",ManipString.createSerialization("Double", (new Double(le.getY())).toString())};
				
				listSpec.add(vX);
				listSpec.add(vY);
				
				ListenerFunctions.foo("onPosition",(Node)le.getLocatedComponent().getWrappedElement(),listSpec);
				ListenerFunctions.updateGraphicalElement(le.getLocatedComponent().getWrappedElement(), "x", new Double(le.getX()));
				ListenerFunctions.updateGraphicalElement(le.getLocatedComponent().getWrappedElement(), "y", new Double(le.getY()));
				
			}

			public boolean vetoesEvent(Event e) {
				return false;
			}});

	}
}
