package listeners.initial;

import interfaces.Positionable;

import java.util.HashSet;

import listeners.Event;
import listeners.EventKind;
import listeners.Listener;

import org.w3c.dom.Node;

import event.PositionEvent;

import utils.ListenerFunctions;
import utils.ManipString;

public class PositionableListenersInitiator {

	public PositionableListenersInitiator() {}

	protected static void initiatePositionableListener(Positionable p) {
		
		p.addListener(new Listener() {

			public EventKind getEventKind() {
				return EventKind.Positioned;
			}

			public void receiveEvent(Event e) {
				
				final PositionEvent pe = (PositionEvent)e;
				HashSet<String[]> listSpec = new HashSet<String[]>();
				
				String[] vX = {"posX",ManipString.createSerialization("Double", (new Double(pe.getPosX())).toString())};
				String[] vY = {"posY",ManipString.createSerialization("Double", (new Double(pe.getPosY())).toString())};
				
				listSpec.add(vX);
				listSpec.add(vY);
				
				ListenerFunctions.foo("onPosition",(Node)pe.getPositionedComponent().getWrappedElement(),listSpec);
				ListenerFunctions.updateGraphicalElement(pe.getPositionedComponent().getWrappedElement(), "x", new Double(pe.getPosX()));
				ListenerFunctions.updateGraphicalElement(pe.getPositionedComponent().getWrappedElement(), "y", new Double(pe.getPosY()));
			}

			public boolean vetoesEvent(Event e) {
				return false;
			}});

	}
}
