package listeners.initial;

import java.util.HashSet;

import listeners.Event;
import listeners.EventKind;
import listeners.Listener;

import org.w3c.dom.Node;

import test.interfaces.Resizable;
import utils.ListenerFunctions;
import utils.ManipString;
import event.ResizeEvent;

public class ResizableListenersInitiator {

	public ResizableListenersInitiator() {}
	
	protected static void initiateResizableListener(Resizable r) {
		
		r.addListener(new Listener() {

			public EventKind getEventKind() {
				return EventKind.Resized;
			}

			public void receiveEvent(Event e) {
				
				final ResizeEvent re = (ResizeEvent)e;
				HashSet<String[]> listSpec = new HashSet<String[]>();
				
				String[] vX = {"sizeX",ManipString.createSerialization("Double", (new Double(re.getSizeX())).toString())};
				String[] vY = {"sizeY",ManipString.createSerialization("Double", (new Double(re.getSizeY())).toString())};
				
				listSpec.add(vX);
				listSpec.add(vY);
				
				ListenerFunctions.foo("onResize",(Node)re.getResizedComponent().getWrappedElement(),listSpec);
			}

			public boolean vetoesEvent(Event e) {
				return false;
			}});

	}

}
