package listeners.initial;

import java.util.ArrayList;
import java.util.HashSet;
import java.util.Iterator;
import java.util.List;

import javax.jmi.reflect.RefObject;

import org.w3c.dom.Node;

import utils.DomFinding;
import utils.ListenerFunctions;
import utils.ManipString;
import utils.SelfContainer;
import event.StickEvent;
import listeners.Event;
import listeners.EventKind;
import listeners.Listener;
import interfaces.Stickable;
import interpretor.InterpretorFacadeKoala;
import interpretor.Variable;
import interpretor.VariableKoala;

public abstract class StickableListenersInitiator {
	private StickableListenersInitiator(){}
	
	protected static void initiateStickableListener(Stickable s) {
		
		s.addListener(new Listener() {
			
			public EventKind getEventKind() {
				return EventKind.Stick;
			}
			
			public void receiveEvent(Event e) {
				
				final StickEvent se = (StickEvent)e;
				HashSet<String[]> listSpec = new HashSet<String[]>();
				
				List<String[]> listVars = DomFinding.domFindVariables(se.getStickedComponent().getWrappedElement());
				for (Iterator iter = listVars.iterator(); iter.hasNext();) {
					String[] element = (String[]) iter.next();
					element[0] = "stickedComponent_".concat(element[0]);
					listSpec.add(element);
				}
				
				ListenerFunctions.foo("onStick",(Node)se.getSource().getWrappedElement(),listSpec);
				ListenerFunctions.updateGraphicalElement(se.getStickedComponent().getWrappedElement(), "connects", se.getSource().getWrappedElement(), true);
			}
			
			public boolean vetoesEvent(Event e) {
				return false;
			}});
		
		s.addListener(new Listener() {
			
			public EventKind getEventKind() {
				return EventKind.Unstick;
			}
			
			public void receiveEvent(Event e) {
				
				final StickEvent se = (StickEvent)e;
				
				HashSet<String[]> listSpec = new HashSet<String[]>();
				
				List<String[]> listVars = DomFinding.domFindVariables(se.getStickedComponent().getWrappedElement());
				for (Iterator iter = listVars.iterator(); iter.hasNext();) {
					String[] element = (String[]) iter.next();
					element[0] = "unStickedComponent_".concat(element[0]);
					listSpec.add(element);
				}
				ListenerFunctions.foo("onUnStick",(Node)se.getSource().getWrappedElement(),listSpec);
				ListenerFunctions.updateGraphicalElement(se.getStickedComponent().getWrappedElement(), "connects", se.getSource().getWrappedElement(), false);
			}
			
			public boolean vetoesEvent(Event e) {
				return false;
			}});
	}
	
	
}
