package listeners.initial;
import java.util.HashSet;

import org.w3c.dom.Node;

import utils.ListenerFunctions;
import utils.ManipString;

import interfaces.Translatable;
import interpretor.Variable;
import event.TranslateEvent;
import listeners.Event;
import listeners.EventKind;
import listeners.Listener;


public abstract class TranslatableListenersInitiator {

	private TranslatableListenersInitiator() {}
	
	protected static void initiateTranslatableListener(Translatable t) {
		
		t.addListener(new Listener() {

			public EventKind getEventKind() {
				return EventKind.Translated;
			}

			public void receiveEvent(Event e) {
				
				final TranslateEvent te = (TranslateEvent)e;
				HashSet<String[]> listSpec = new HashSet<String[]>();
				
				String[] vX = {"posX",ManipString.createSerialization("Double", (new Double(te.getFinalPosX())).toString())};
				String[] vY = {"posY",ManipString.createSerialization("Double", (new Double(te.getFinalPosY())).toString())};
				
				listSpec.add(vX);
				listSpec.add(vY);
				
				ListenerFunctions.foo("onPosition",(Node)te.getTranslatedComponent().getWrappedElement(),listSpec);
				ListenerFunctions.updateGraphicalElement(te.getTranslatedComponent().getWrappedElement(), "x", new Double(te.getFinalPosX()));
				ListenerFunctions.updateGraphicalElement(te.getTranslatedComponent().getWrappedElement(), "y", new Double(te.getFinalPosY()));
			}

			public boolean vetoesEvent(Event e) {
				return false;
			}});

	}
}
