package model;

import java.io.File;

import javax.jmi.reflect.RefPackage;

import test.GUI.GUI;
import test.model.ModelHelper;
import utils.AWK;

public class MDRModelProvider implements ModelProvider {

	public String modelKind() {
		return "MDR";
	}

	/**
	 * arguments[0] : String : XMI file for the metamodel
	 */
	public Object provideModel(Object [] arguments) throws ModelCreationException {
		RefPackage extent = null;
		
		try {
			File fmm = new File((String)arguments[0]);
			extent = ModelHelper.createExtent(fmm, AWK.eliminateLastFieldOf(fmm.getName(), "."));
			System.out.println("Connected a new model of kind " + arguments[0]);
		} catch (Exception e) {
			throw new ModelCreationException(e, this, arguments);
		}
		
		if (extent == null)
			System.out.println("No model connected.");
		return extent;
	}

	/**
	 * arguments[0] : String : the name of the XMI file to save
	 */
	public void loadModel(Object model, Object[] arguments) throws ModelLoadException {
		try {
			File xmi = new File((String)arguments[0]);
			ModelHelper.load((RefPackage) model, xmi);
		} catch (Exception x) {
			throw new ModelLoadException(x, this, arguments);
		}
	}

	/**
	 * arguments[0] : String : the name of the XMI file to save
	 */
	public void saveModel(File svgFile, Object model, Object[] arguments) throws ModelSaveException {
		try {
			File xmi = new File((String)arguments[0]);
			ModelHelper.save((RefPackage) model, xmi, svgFile);
		} catch (Exception x) {
			throw new ModelSaveException(x, this, arguments);
		}
	}
}
