package model;

public class ModelCreationException extends Exception {
	private static final long serialVersionUID = -918501723924872878L;
	public final ModelProvider modelProvider;
	
	public ModelCreationException(Throwable error, ModelProvider provider, Object [] arguments) {
		super("Unable to create a " + provider.modelKind() + " model: " + error.getMessage(), error);
		this.modelProvider = provider;
	}

	public ModelProvider getModelProvider() {
		return modelProvider;
	}

	protected static String serializeArguments(Object [] arguments) {
		StringBuffer ret = new StringBuffer();
		ret.append('<');
		boolean first = true;
		for (Object arg : arguments) {
			if (first)
				first = false;
			else {
				ret.append(',');
				ret.append(' ');
			}
			ret.append(arg.toString());
		}
		ret.append('>');
		return ret.toString();
	}
}
