package model;

import java.io.File;
import java.io.FilenameFilter;

public interface ModelProvider {
	
	public static FilenameFilter XmiFilter = new FilenameFilter() {

		public boolean accept(File arg0, String arg1) {
			return arg1.endsWith(".xml")  || arg1.endsWith(".xmi");
		}
		
	};
	
	
	String modelKind();
	Object provideModel(Object [] arguments) throws ModelCreationException;
	void loadModel(Object model, Object [] arguments) throws ModelLoadException;
	void saveModel(File svgFile, Object model, Object[] arguments) throws ModelSaveException;
}
