package model;

public class ModelSaveException extends Exception {
	private static final long serialVersionUID = -918501723924872878L;
	public final ModelProvider modelProvider;
	
	public ModelSaveException(Throwable error, ModelProvider provider, Object [] arguments) {
		super("Unable to save a " + provider.modelKind() + " model with arguments " + ModelCreationException.serializeArguments(arguments) + error.getMessage(), error);
		this.modelProvider = provider;
	}

	public ModelProvider getModelProvider() {
		return modelProvider;
	}
}
