package scgm;

/**
 * A_end_sVGTransition association proxy interface.
 */
public interface AEndSVgtransition extends javax.jmi.reflect.RefAssociation {
    /**
     * Queries whether a link currently exists between a given pair of instance 
     * objects in the associations link set.
     * @param end Value of the first association end.
     * @param sVgtransition Value of the second association end.
     * @return Returns true if the queried link exists.
     */
    public boolean exists(scgm.SvgarrowEnd end, scgm.Svgtransition sVgtransition);
    /**
     * Queries the instance object that is related to a particular instance object 
     * by a link in the current associations link set.
     * @param sVgtransition Required value of the second association end.
     * @return Related object or <code>null</code> if none exists.
     */
    public scgm.SvgarrowEnd getEnd(scgm.Svgtransition sVgtransition);
    /**
     * Creates a link between the pair of instance objects in the associations 
     * link set.
     * @param end Value of the first association end.
     * @param sVgtransition Value of the second association end.
     */
    public boolean add(scgm.SvgarrowEnd end, scgm.Svgtransition sVgtransition);
    /**
     * Removes a link between a pair of instance objects in the current associations 
     * link set.
     * @param end Value of the first association end.
     * @param sVgtransition Value of the second association end.
     */
    public boolean remove(scgm.SvgarrowEnd end, scgm.Svgtransition sVgtransition);
}
