package scgm;

/**
 * A_nearby_graphicalElement association proxy interface.
 */
public interface ANearbyGraphicalElement extends javax.jmi.reflect.RefAssociation {
    /**
     * Queries whether a link currently exists between a given pair of instance 
     * objects in the associations link set.
     * @param nearby Value of the first association end.
     * @param graphicalElement Value of the second association end.
     * @return Returns true if the queried link exists.
     */
    public boolean exists(scgm.GraphicalElement nearby, scgm.GraphicalElement graphicalElement);
    /**
     * Queries the instance objects that are related to a particular instance 
     * object by a link in the current associations link set.
     * @param graphicalElement Required value of the second association end.
     * @return Collection of related objects.
     */
    public java.util.Collection getNearby(scgm.GraphicalElement graphicalElement);
    /**
     * Creates a link between the pair of instance objects in the associations 
     * link set.
     * @param nearby Value of the first association end.
     * @param graphicalElement Value of the second association end.
     */
    public boolean add(scgm.GraphicalElement nearby, scgm.GraphicalElement graphicalElement);
    /**
     * Removes a link between a pair of instance objects in the current associations 
     * link set.
     * @param nearby Value of the first association end.
     * @param graphicalElement Value of the second association end.
     */
    public boolean remove(scgm.GraphicalElement nearby, scgm.GraphicalElement graphicalElement);
}
