/*
 * Created on 25 nov. 2004
 *
 *  * Copyright 2004-2008 Frdric FONDEMENT
 */
package templates;

import org.apache.batik.util.SVGConstants;
import org.w3c.dom.svg.SVGCircleElement;
import org.w3c.dom.svg.SVGSVGElement;

import test.templates.DefaultSVGTemplateProperties;
import test.templates.DefaultSVGTemplatePropertyClass;
import test.templates.SVGTemplate;
import test.templates.SVGTemplateProperties;
import test.templates.SVGTemplatePropertyClass;
import test.templates.SVGTemplatePropertyException;
import utils.InstanceManager;
import dopidom.Component;
import dopidom.svg.SVGScene;

/**
 * @author fondemen
 *
 *  * Copyright 2004-2008 Frdric FONDEMENT
 */
public class CircleTemplate implements SVGTemplate {
	public static SVGTemplatePropertyClass CirclePropertyClass;
	protected String classe = "PBXSComponents.Link"; // classe par defaut
	
	static {
		SVGTemplateProperties p = new DefaultSVGTemplateProperties();
		p.set("cx", Double.class);
		p.set("cy", Double.class);
		p.set("r", Double.class);
		p.set("fill", String.class, true);
		p.set("stroke", String.class);
		p.set("stroke-width", Double.class);
		p.set("stroke-dasharray", String.class);
		
		
		CirclePropertyClass = new DefaultSVGTemplatePropertyClass(p);
	}

	public CircleTemplate() {
		super();
	}
	
	
	public void setClasse (String classe) {
		this.classe = classe;
	}

	public Component[] createElement(SVGSVGElement container,
			SVGTemplateProperties properties)
			throws SVGTemplatePropertyException {
		this.getPropertyClass().validate(properties);
		
		SVGCircleElement e = (SVGCircleElement)SVGScene.getInstance().getDocument().createElementNS(SVGTemplate.SVGElementNS, "circle");
		//events sent by the following line
		//creating the text
		//setting the text value
		//	DOMMutationEvent "DOMCharacterDataModified" (old ""; new "ihm04.BasicShape"; target on the GenericText value for the attribute "dpi:component" - sent after update) to the newly created GenericText (at target phase)
		//creating the attribute
		//adding the text value to the attribute
		//	DOMMutationEvent "DOMNodeInserted" (target the generic text, relatedNode the attributeNS) to the newly created attributeNS (capturing phase) and the newly created GenericText (at target phase) and again the attributeNS (at bubbling phase)
		//	DOMMutationEvent "DOMNodeInsertedIntoDocument" (target the generic text) to the attributeNS (capturing phase) and the GenericText (at target phase) and again the attributeNS (at bubbling phase)
		//	DOMMutationEvent "DOMSubtreeModified" (target the attributeNS) to the attributeNS (at target phase)
		//adding the attribute to the rect
		//  DOMMutationEvent "DOMAttrModified" (related the attributeNS; old=""; new="BasicShape"; attrName="component") to the rect (at target phase)
		e.setAttributeNS(SVGTemplate.SVGAttributeNS, "dpi:component", this.classe);
		//again...
		e.setAttribute(SVGConstants.SVG_STROKE_ATTRIBUTE, (String)properties.get("stroke"));
		e.setAttribute(SVGConstants.SVG_STROKE_WIDTH_ATTRIBUTE, ((Double)properties.get("stroke-width")).toString());
		e.setAttribute(SVGConstants.SVG_R_ATTRIBUTE, ((Double)properties.get("r")).toString());
		e.setAttribute(SVGConstants.SVG_FILL_ATTRIBUTE, (String)properties.get("fill"));
		if (!((String)properties.get("stroke-dasharray")).equalsIgnoreCase(""))
			e.setAttribute(SVGConstants.SVG_STROKE_DASHARRAY_ATTRIBUTE, (String)properties.get("stroke-dasharray"));
		
		e.setAttribute(SVGConstants.SVG_CX_ATTRIBUTE, "0");
		e.setAttribute(SVGConstants.SVG_CY_ATTRIBUTE, "0");
//		e.setAttribute(SVGConstants.SVG_CX_ATTRIBUTE, ((Double)properties.get("cx")).toString());
//		e.setAttribute(SVGConstants.SVG_CY_ATTRIBUTE, ((Double)properties.get("cy")).toString());
		
		/*
		SVGScene.getInstance().getCanvas().getSVGDocument().getRootElement().appendChild(e);
		DOMComponent.getFactory().newComponent(e);
		SVGEventPoint.getFactory().newEventPoint(e);
		return new Component[] {(Component)DOMComponent.getFactory().newComponent(e)};
		*/
		InstanceManager im = new InstanceManager();
		
		Component[] newC = {im.instanciateFromNode(e)};
		return newC;
	}

	public SVGTemplatePropertyClass getPropertyClass() {
		return CirclePropertyClass;
	}

}
