/*
 * Created on 4 dc. 2004
 *
 *  * Copyright 2004-2008 Frdric FONDEMENT
 */
package test;

import ihm04.interfaces.ColorPickable;
import ihm04.interfaces.Paintable;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.HashSet;
import java.util.Iterator;
import java.util.List;
import java.util.Set;

import org.w3c.dom.Element;
import org.w3c.dom.Node;

import test.interfaces.Hiligthtable;
import test.interfaces.Locatable;
import test.interfaces.Resizable;
import dopidom.ActionInterface;
import dopidom.Component;
import dopidom.QueryInterface;
import dopidom.dom.DOMComponent;
import dopidom.svg.SVGComponent;

/**
 * @author fondemen
 *
 *  * Copyright 2004-2008 Frdric FONDEMENT
 */
public class Background extends SVGComponent {

	public Background(Element wrappedElement) {
		super(wrappedElement);
		new Paintable(this);
		new ColorPickable(this);
		new Locatable(this);
		new Resizable(this);
		new Hiligthtable(this);
		new test.interfaces.Container(this);
		
//		SVGScene.getInstance().invokeLater(new Runnable() {
//
//			public void run() {
//				ListenerManager.INSTANCE.register(new QueryListener() {
//
//					public void handleEvent(QueryChangedEvent evt) {
//						Location oldV = (Location)evt.getOldValue();
//						Location newV = (Location)evt.getNewValue();
//						if (oldV.getWidth() != newV.getWidth() || oldV.getHeight() != newV.getHeight()) {
//							final ResizeAction ra = new ResizeAction(newV.getWidth(), newV.getHeight());
//							/*/SVGScene.getInstance().invokeLater(new Runnable(){
//
//								public void run() {*/
//									Background.this.getActionInterface(ResizeAction.class).doAction(ra);
//								/*}});*/
//						}
//					}}, getContainer().getQueryInterface(Location.class), new Location());
//			}});
	}
	
	public Container getContainer() {
		Node n = getWrappedElement().getParentNode();
		
		while (n instanceof Element) {
			Component component = DOMComponent.getFactory().getOwnerComponent((Element)n);
			if (component instanceof Container)
				return (Container)component;
			else
				n = n.getParentNode();
		}
		return null;
	}

	public ActionInterface[] getActionInterfaces() {
		Container owner = this.getContainer();
		if (owner != null) {
			List ret = new ArrayList();
			List initial = Arrays.asList(super.getActionInterfaces());
			Set actions = new HashSet();
			Iterator i = initial.iterator();
			while (i.hasNext()) {
				ActionInterface a = (ActionInterface) i.next();
				actions.add(a.getAction());
			}
			ret.addAll(initial);
			List inherited = Arrays.asList(owner.getActionInterfaces());
			List inheritedSelected = new ArrayList(inherited);
			i = inheritedSelected.iterator();
			while (i.hasNext()) {
				ActionInterface a = (ActionInterface) i.next();
				if (actions.contains(a.getAction()))
					i.remove();
			}
			ret.addAll(inheritedSelected);
			return (ActionInterface[])ret.toArray(new ActionInterface[ret.size()]);
		} else
			return super.getActionInterfaces();
	}
	public QueryInterface[] getQueryInterfaces() {
		Container owner = this.getContainer();
		if (owner != null) {
			List ret = new ArrayList();
			List initial = Arrays.asList(super.getQueryInterfaces());
			Set queries = new HashSet();
			Iterator i = initial.iterator();
			while (i.hasNext()) {
				QueryInterface q = (QueryInterface) i.next();
				queries.add(q.getQuery());
			}
			ret.addAll(initial);
			List inherited = Arrays.asList(owner.getQueryInterfaces());
			List inheritedSelected = new ArrayList(inherited);
			i = inheritedSelected.iterator();
			while (i.hasNext()) {
				QueryInterface q = (QueryInterface) i.next();
				if (queries.contains(q.getQuery()))
					i.remove();
			}
			ret.addAll(inheritedSelected);
			return (QueryInterface[])ret.toArray(new QueryInterface[ret.size()]);
		} else
			return super.getQueryInterfaces();
	}
}
