/*
 * Created on 4 dc. 2004
 *
 *  * Copyright 2004-2008 Frdric FONDEMENT
 */
package test;

import java.util.ArrayList;
import java.util.List;

import org.w3c.dom.Element;
import org.w3c.dom.Node;

import test.interfaces.Deletable;

import dopidom.Component;
import dopidom.dom.DOMComponent;
import dopidom.svg.SVGComponent;
import dopidom.svg.SVGInteractor;

/**
 * @author fondemen
 *
 *  * Copyright 2004-2008 Frdric FONDEMENT
 */
public class Container extends SVGComponent {
	public Container(Element wrappedElement) {
		super(wrappedElement);
		
		new test.interfaces.Container(this);
	}
		

	public Background getBackground(){
		Node n = getWrappedElement().getFirstChild();
		Background ret = null;
		
		while (n != null) {
			if (n instanceof Element) {
				Component component = DOMComponent.getFactory().getOwnerComponent((Element)n);
				if (component instanceof Background)
					ret = (Background)component;
			}
			n = n.getNextSibling();
		}
		return ret;
	}
	
	public Component [] getContents() {
		List ret = new ArrayList();
		Node n = getWrappedElement().getFirstChild();
		
		while (n != null) {
			if (n instanceof Element) {
				Component c = DOMComponent.getFactory().getOwnerComponent((Element)n);
				if (c != null && c != this)
					ret.add(c);
			}
			n = n.getNextSibling();
		}
		return (Component [])ret.toArray(new Component [ret.size()]);
		
		//return this.getChildren();
	}
	
	public SVGInteractor [] getInteractors() {
		Component [] contents = this.getContents();
		List ret = new ArrayList();
		for (int i = 0; i < contents.length; i++) {
			if (contents[i] instanceof SVGInteractor)
				ret.add(contents[i]);
		}
		return (SVGInteractor [])ret.toArray(new SVGInteractor [ret.size()]);
	}
}
