/*
 * Created on 4 mai 2005
 *
 * TODO To change the template for this generated file go to
 *  * Copyright 2004-2008 Frdric FONDEMENT
 */
package test.GUI;

import ihm04.actions.Translate;

import java.awt.BorderLayout;
import java.awt.event.ActionEvent;
import java.awt.event.MouseEvent;
import java.io.File;
import java.io.FilenameFilter;
import java.io.IOException;
import java.net.MalformedURLException;
import java.net.URI;
import java.net.URL;

import javax.jmi.reflect.RefPackage;
import javax.jmi.xmi.MalformedXMIException;
import javax.swing.AbstractAction;
import javax.swing.Action;
import javax.swing.Icon;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JOptionPane;
import javax.swing.JScrollPane;
import javax.swing.JToolBar;
import javax.swing.SwingConstants;

import listeners.initial.ListenerInitiator;

import org.apache.batik.dom.svg.ExtensibleSVGDOMImplementation;
import org.apache.batik.swing.gvt.GVTTreeRendererAdapter;
import org.apache.batik.swing.gvt.GVTTreeRendererEvent;
import org.apache.batik.swing.svg.SVGDocumentLoaderAdapter;
import org.apache.batik.swing.svg.SVGDocumentLoaderEvent;
import org.netbeans.api.mdr.CreationFailedException;
import org.w3c.dom.svg.SVGDocument;

import actions.Handle;

import test.actions.ResizeAction;
import test.languageloading.Creator;
import test.languageloading.Language;
import test.languageloading.LanguageLoader;
import test.model.ModelHelper;
import test.queries.Location;
import test.selection.SelectionManager;
import test.templates.DefaultSVGTemplateProperties;
import test.templates.SVGFileTemplate;
import test.templates.SVGTemplatePropertyException;
import utils.AWK;
import utils.ClassPathHacker;
import utils.Directories;
import dopidom.ActionInterface;
import dopidom.Component;
import dopidom.svg.SVGCleanToolInteractor;
import dopidom.svg.SVGInteraction;
import dopidom.svg.SVGInteractor;
import dopidom.svg.SVGScene;

/**
 * @author fondemen
 *
 * TODO To change the template for this generated type comment go to
 *  * Copyright 2004-2008 Frdric FONDEMENT
 */
public class GUI extends JFrame {
	public static GUI INSTANCE;
	
	protected final String languageDir;
	
	protected JScrollPane canvaContainer;
	protected JToolBar creatorToolbar;
	
	protected Creator [] creators;
	
	protected SVGInteractor interactor;
	
	protected Language language;
	
	/**
	 * @param title
	 * @throws java.awt.HeadlessException
	 */
	public GUI(String languageDirectory) {
		super();
		this.languageDir = languageDirectory;
		try {
			ListenerInitiator.initiateListeners();
			this.language = LanguageLoader.INSTANCE.loadLanguage(new File(Directories.getResource(this.languageDir, new Class[] {GUI.class}).getFile()));
			this.init();
			SVGScene.getInstance().loadSVGDocument(new URI(AWK.replace(this.language.getScene().toExternalForm().toString(), " ", "%20")).toASCIIString());
			INSTANCE = this;
			this.resize();
			this.show();
		} catch (Exception e1) {
			e1.printStackTrace();
			JOptionPane.showMessageDialog(this, "Problem while loading the language templates.", "Error", JOptionPane.ERROR_MESSAGE);
		}
	}
	
	public String getLanguageDirectory() {
		return this.languageDir;
	}
	
	protected void init() {
		this.getContentPane().setLayout(new BorderLayout());

		this.canvaContainer = new JScrollPane(SVGScene.getInstance().getCanvas());
		this.getContentPane().add(canvaContainer, BorderLayout.CENTER);
		canvaContainer.setSize(SVGScene.getInstance().getCanvas().getPreferredSize());
		
		setTitle();
		
		SVGScene.getInstance().getCanvas().addSVGDocumentLoaderListener(new SVGDocumentLoaderAdapter()
				{
					public void documentLoadingCompleted(SVGDocumentLoaderEvent event)
					{
						setTitle();
					}
				});
		
		SVGScene.getInstance().getCanvas().addGVTTreeRendererListener(new GVTTreeRendererAdapter() {
					public void gvtRenderingCompleted(GVTTreeRendererEvent event)
					{
						resize();
					}
				});
		
		SVGScene.getInstance().getCanvas().addGVTTreeRendererListener(new GVTTreeRendererAdapter() {
					public void gvtRenderingCompleted(GVTTreeRendererEvent event)
					{
						createCreatorBar();
						SVGScene.getInstance().getCanvas().removeGVTTreeRendererListener(this);
					}
				});
		
		this.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
	}
	
	protected void resize() {
		this.pack();
		this.setLocationRelativeTo(null);
	}

	protected void setTitle() {
		SVGDocument doc = SVGScene.getInstance().getDocument();
		String title;
		if (doc == null)
			title = "<No Document Loaded>";
		else {
			title = doc.getTitle();
		}
		setTitle(title);
	}
	
	public SVGCleanToolInteractor getInteractor() {
		SVGInteractor[] interactors = SVGScene.getInstance().getInteractors();
		for (int i = 0; i < interactors.length; i++) {
			if (interactors[i] instanceof SVGCleanToolInteractor)
				return (SVGCleanToolInteractor)interactors[i];
		}
		return null;
	}

	
	protected void createCreatorBar() {
		if (this.creators != null)
			this.creators = null;
		if (this.creatorToolbar != null) {
			this.getContentPane().remove(this.creatorToolbar);
			this.creatorToolbar = null;
		}

		SVGFileTemplate [] ft = this.language.getTemplates();
		creatorToolbar = new JToolBar("Language Constructs");
		this.getContentPane().add(creatorToolbar, BorderLayout.PAGE_START);
		
		this.creators = new Creator[ft.length];
		SVGCleanToolInteractor interactor = this.getInteractor();
		
		for (int i = 0; i < ft.length; i++) {
			final Creator c = new Creator(interactor, ft[i]);
			this.creators[i] = c;
			Action a = new AbstractAction() {

				/**
				 * 
				 */
				private static final long serialVersionUID = -3644066101251685273L;

				public void actionPerformed(ActionEvent e) {
					for (int i = 0; i < creators.length; i++) {
						if (creators[i] != c)
							creators[i].setActive(false);
					}
					c.setActive(true);
				}};
			JButton b = new JButton(a);
			b.setName(ft[i].getName() + " creator");
			b.setToolTipText("Create a new " + ft[i].getName());
			Icon icon = ft[i].getIcon();
			if (icon != null)
				b.setIcon(icon);
			else
				b.setText(ft[i].getName());
			b.setHorizontalAlignment(SwingConstants.CENTER);
			b.setVerticalAlignment(SwingConstants.CENTER);
			creatorToolbar.add(b);
		}
		resize();
	}

	public Language getLanguage() {
		return language;
	}
}

