/*
 * Created on 25 nov. 2004
 *
 *  * Copyright 2004-2008 Frdric FONDEMENT
 */
package test.actions;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

import test.templates.DefaultSVGTemplateProperties;
import test.templates.SVGTemplate;
import test.templates.SVGTemplateProperties;
import dopidom.svg.SVGAction;

/**
 * @author fondemen
 *
 *  * Copyright 2004-2008 Frdric FONDEMENT
 */
public class InstanciateTemplateAction extends SVGAction {
	
	protected static String [] getPropertiesPart(String [] props) {
		String [] ret = new String [props.length-1];
		System.arraycopy(props, 1, ret, 0, ret.length);
		return ret;
	}
	
	protected final SVGTemplate template;
	protected final SVGTemplateProperties properties;
	
	public InstanciateTemplateAction(final SVGTemplate template,
			final SVGTemplateProperties properties) {
		super();
		this.template = template;
		this.properties = properties;
	}
	public InstanciateTemplateAction(String [] props) throws InstantiationException, IllegalAccessException, ClassNotFoundException {
		this((SVGTemplate) ClassLoader.getSystemClassLoader().loadClass(props[0]).newInstance(), new DefaultSVGTemplateProperties(getPropertiesPart(props)));
	}
	public SVGTemplateProperties getProperties() {
		return properties;
	}
	public SVGTemplate getTemplate() {
		return template;
	}
	public String[] toStrings() {
		List/*<String>*/ ret = new ArrayList/*<String>*/();
		ret.add(this.getTemplate().getClass().getName());
		ret.addAll(Arrays.asList(this.getProperties().toStrings()));
		return (String[])ret.toArray(new String[ret.size()]);
	}

}
