/*
 * Created on 25 nov. 2004
 *
 *  * Copyright 2004-2008 Frdric FONDEMENT
 */
package test.actions;

import java.io.Serializable;

import dopidom.svg.SVGAction;

/**
 * @author fondemen
 *
 *  * Copyright 2004-2008 Frdric FONDEMENT
 */
public class OrderingAction extends SVGAction {
	public static class Mode implements Serializable {
		public static final short ToFrontHash = 0;
		public static final short ToBackHash = 1;
		public static final short BackwardHash = 2;
		public static final short ForwardHash = 3;
		private static final String ToFrontStr = "To Front";
		private static final String ToBackStr = "To Back";
		private static final String BackwardStr = "Send Backward";
		private static final String ForwardStr = "Send Forward";
		
		private final short modeIdx;
		
		private Mode(final short mode) {
			super();
			this.modeIdx = mode;
		}
		public int hashCode() {
			return this.modeIdx;
		}
		public String toString() {
			switch (this.modeIdx) {
			case ToFrontHash : return ToFrontStr;
			case ToBackHash : return ToBackStr;
			case BackwardHash : return BackwardStr;
			case ForwardHash : return ForwardStr;
			}
			return null;
		}
	}
	public static final Mode ToFront = new Mode(Mode.ToFrontHash);
	public static final Mode ToBack = new Mode(Mode.ToBackHash);
	public static final Mode Backward = new Mode(Mode.BackwardHash);
	public static final Mode Forward = new Mode(Mode.ForwardHash);
	public static final Mode[] AllModes = new Mode [] {ToFront, ToBack, Backward, Forward};
	
	protected final Mode mode;

	public OrderingAction(Mode mode) {
		super();
		this.mode = mode;
	}
	public Mode getMode() {
		return mode;
	}
	public OrderingAction(String [] properties) {
		this(AllModes[Short.parseShort(properties[0])]);
	}
	public String[] toStrings() {
		return new String[] {this.getMode().toString()};
	}
}
