/*
 * Created on 14 mars 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package test.interfaces;

import javax.swing.JOptionPane;
import javax.xml.xpath.XPathConstants;
import javax.xml.xpath.XPathExpressionException;
import javax.xml.xpath.XPathFactory;

import listeners.DefaultListenable;
import listeners.Event;
import listeners.EventKind;
import listeners.Listenable;
import listeners.Listener;
import listeners.UncheckedEventException;

import org.apache.batik.constraint.AttributeDependency;
import org.apache.batik.constraint.Constraint;
import org.apache.batik.constraint.Dependency;
import org.apache.batik.constraint.TValElement;
import org.w3c.dom.Attr;
import org.w3c.dom.Node;
import org.w3c.dom.Text;
import org.w3c.dom.svg.SVGLocatable;

import test.EditableString;
import test.actions.DeleteCharacter;
import dopidom.Action;
import dopidom.Component;
import dopidom.svg.SVGActionInterface;
import event.CharacterDeletedEvent;
import event.CharacterInsertedEvent;
import event.CreationEvent;

/**
 * @author Olivier Beaudoux
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class CharacterDeletable extends SVGActionInterface implements Listenable
{
	
	public static final DefaultListenable CharacterDeletableListener = new DefaultListenable();
	private DefaultListenable listenableDelegate = new DefaultListenable();
	private Component textBox;
	private int offsetInText;
	private String textChanged;
	private String textBeforeChanged;
	
	public CharacterDeletable(Component ownerComponent)
	{
		super(ownerComponent);
		//assert getWrappedElement().getFirstChild() instanceof Text;
		textBox = ownerComponent;
		CharacterDeletableListener.testAndFireEvent(new CreationEvent(EventKind.CharacterDeletableCreated, this));
	}
	
	public Class getAction()
	{
		return DeleteCharacter.class;
	}

	public void doAction(Action action)
	{
		DeleteCharacter deleteCharacter = (DeleteCharacter) action;
		offsetInText = deleteCharacter.getPosition();
		if (deleteCharacter.isBefore())
			offsetInText--;
		Node tn = getWrappedElement().getFirstChild();
		if (tn instanceof Text) {
			Text text = (Text) getWrappedElement().getFirstChild();
			textBeforeChanged = text.getNodeValue();
			if ((offsetInText >= 0) && (offsetInText < text.getLength()))
				text.replaceData(offsetInText, 1, "");
			textChanged = text.getNodeValue();
		}else if (tn instanceof TValElement){
			Constraint val = ((TValElement)tn).getConstraint();
			Dependency dep = (Dependency)val.getDependencies().get(0);
			if (dep instanceof AttributeDependency){
				AttributeDependency ad = (AttributeDependency)dep;
				Node att = ad.getParentNode().getAttributes().getNamedItem(ad.getLocalName());
				textBeforeChanged = att.getNodeValue();
				textChanged = textBeforeChanged.substring(0, offsetInText)+textBeforeChanged.substring(offsetInText+1);
				try {
					att.setNodeValue(textChanged);
				} catch (NullPointerException x) {}
			} else {
				String expr = val.getExpression();
				javax.xml.xpath.XPath xpath = XPathFactory.newInstance().newXPath();
				Node n;
				try {
					n = (Node)xpath.evaluate(expr, tn, XPathConstants.NODE);
				} catch (XPathExpressionException e1) {
					throw new RuntimeException(e1);
				}
				if (n instanceof Attr) {
					textBeforeChanged = n.getNodeValue();
					textChanged = textBeforeChanged.substring(0, offsetInText)+textBeforeChanged.substring(offsetInText+1);
					n.setNodeValue(textChanged);
				} else if (n instanceof Text) {
					textBeforeChanged = ((Text)n).getData();
					textChanged = textBeforeChanged.substring(0, offsetInText)+textBeforeChanged.substring(offsetInText+1);
					((Text)n).setData(textChanged);
				} else {
					JOptionPane.showMessageDialog(null, "Modifying a C-SVG reference (node, variable, BBox, viewport, zoom and pan) is not implemented.", "Not implemented", JOptionPane.ERROR_MESSAGE);
					return;
				}
			}
		}
		//SVGScene.getInstance().updateConstraints();
		
		if(this.listenerTestAndFireEvent()) {

		}
	}
	
	private boolean listenerTestAndFireEvent() {
		//Component textBox = getEditableString();
		return this.testAndFireEvent(new CharacterDeletedEvent((EditableString)textBox,textBeforeChanged, textChanged, offsetInText));
	}

	public Class[] getScope() {
		return new Class[] {SVGLocatable.class};
	}
	
	
	public void addListener(Listener l) {
		this.listenableDelegate.addListener(l);
	}

	public void removeListener(Listener l) {
		this.listenableDelegate.removeListener(l);
	}

	public void fireEvent(Event e) throws UncheckedEventException {
		this.listenableDelegate.fireEvent(e);
	}

	public void checkEvent(Event e) {
		this.listenableDelegate.checkEvent(e);
	}

	public boolean testAndFireEvent(Event e) {
		return this.listenableDelegate.testAndFireEvent(e);
	}
}
