/*
 * Created on 14 mars 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package test.interfaces;

import interfaces.OriginGettable;

import java.awt.geom.Rectangle2D;

import org.w3c.dom.Element;
import org.w3c.dom.svg.SVGLocatable;
import org.w3c.dom.svg.SVGPoint;
import org.w3c.dom.svg.SVGTextContentElement;

import queries.GetOrigin;

import test.queries.HitCharacter;
import test.queries.Location;
import dopidom.Component;
import dopidom.Query;
import dopidom.QueryInterface;
import dopidom.dom.DOMComponent;
import dopidom.svg.SVGQueryInterface;
import dopidom.svg.SVGScene;

/**
 * @author Olivier Beaudoux
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class CharacterHitable extends SVGQueryInterface
{
	public CharacterHitable(Component ownerComponent)
	{
		super(ownerComponent);
		//assert getWrappedElement() instanceof SVGLocatable;
		//assert getWrappedElement() instanceof SVGTextContentElement;
		//assert getWrappedElement().getParentNode() instanceof SVGLocatable;
	}

	public Class getQuery()
	{
		return HitCharacter.class;
	}

	/* (non-Javadoc)
	 * @see dpidom.ConsumerInterface#doQuery(dpidom.Query)
	 */
	public void doQuery(Query query)
	{
		HitCharacter hitCharacter = (HitCharacter) query;
		SVGLocatable locatable = (SVGLocatable) getWrappedElement();
		SVGTextContentElement textContent = (SVGTextContentElement) getWrappedElement();
		// compute the index of the hit character
		int index = hitCharacter.getIndex();
		int textLength = textContent.getNumberOfChars();
		// if the index is specified within the query, bound it
		if (hitCharacter.isIndexSpecified())
		{
			if (index < 0)
				index = 0;
			else if (index > textLength)
				index = textLength;
		}
		// else (the hit location is specified) compute the index of the hit character
		else
		{
			int hitX = hitCharacter.getHitX();
			int hitY = hitCharacter.getHitY();
			// compute the *local* coordinates of the hit point
			SVGPoint hitPoint = SVGScene.getInstance().getRootElement().createSVGPoint();
			hitPoint.setX(hitX);
			hitPoint.setY(hitY);
			hitPoint = hitPoint.matrixTransform(locatable.getScreenCTM().inverse());
			// get the hit character
			index = textContent.getCharNumAtPosition(hitPoint);
			//assert index != -1;
			if (index > 0){
				// if the hit position is close to the end position, the next character is the one hit
				double startX = textContent.getStartPositionOfChar(index).getX();
				double endX = textContent.getEndPositionOfChar(index).getX();
				if ((endX - hitX) < (hitX - startX))
					index++;
			}
		}
		// retrieve its local location
		SVGPoint position;
		if (index < 0)
			position = textContent.getStartPositionOfChar(0);
		else if (index < textLength)
			position = textContent.getStartPositionOfChar(index);
		else
			position = textContent.getEndPositionOfChar(textLength - 1);
		SVGLocatable parentLocatable = (SVGLocatable) getWrappedElement().getParentNode();
		hitCharacter.setIndex(index);
		
		double shiftX, shiftY;
		QueryInterface oqi = getOwnerComponent().getQueryInterface(GetOrigin.class);
		if (oqi != null) {
			GetOrigin o = new GetOrigin();
			oqi.doQuery(o);
			shiftX = o.getX();
			shiftY = o.getY();
		} else {
			shiftX = 0; shiftY = 0;
		}
		
		//** soustraction dans consommateur ???!
		hitCharacter.setX(position.getX() + shiftX /*- parentLocatable.getCTM().getE()*/);
		hitCharacter.setY(position.getY() + shiftY /*- parentLocatable.getCTM().getF()*/);
		hitCharacter.setHeight(locatable.getBBox().getHeight());
	}

	public Class[] getScope() {
		return new Class[] {SVGTextContentElement.class, SVGLocatable.class};
	}
}
