/*
 * Created on 14 mars 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package test.interfaces;

import javax.swing.JOptionPane;
import javax.xml.xpath.XPathConstants;
import javax.xml.xpath.XPathExpressionException;
import javax.xml.xpath.XPathFactory;

import listeners.DefaultListenable;
import listeners.Event;
import listeners.EventKind;
import listeners.Listenable;
import listeners.Listener;
import listeners.UncheckedEventException;

import org.apache.batik.constraint.AttributeDependency;
import org.apache.batik.constraint.Constraint;
import org.apache.batik.constraint.Dependency;
import org.apache.batik.constraint.TValElement;
import org.eclipse.swt.widgets.List;
import org.w3c.dom.Attr;
import org.w3c.dom.Node;
import org.w3c.dom.Text;
import org.w3c.dom.svg.SVGLocatable;
import org.w3c.dom.svg.SVGTextContentElement;

import com.sun.org.apache.xerces.internal.impl.xpath.XPath;

import test.EditableString;
import test.actions.InsertCharacter;
import dopidom.Action;
import dopidom.Component;
import dopidom.svg.SVGActionInterface;
import event.CharacterInsertedEvent;
import event.CreationEvent;

/**
 * @author Olivier Beaudoux
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class CharacterInsertable extends SVGActionInterface implements Listenable
{
	public static final DefaultListenable CharacterInsertableListener = new DefaultListenable();
	private DefaultListenable listenableDelegate = new DefaultListenable();
	private Component textBox;
	private String caractereAdded;
	private String textChanged;
	private String textBeforeChanged;
	
	public CharacterInsertable(Component ownerComponent)
	{
		super(ownerComponent);
		textBox = ownerComponent;
		//assert getWrappedElement().getFirstChild() instanceof Text;
		CharacterInsertableListener.testAndFireEvent(new CreationEvent(EventKind.CharacterInsertableCreated, this));
	}

	public Class getAction()
	{
		return InsertCharacter.class;
	}

	public void doAction(Action action)
	{	
		// Maby not that good!
		InsertCharacter insertCharacter = (InsertCharacter) action;
		caractereAdded = String.valueOf(insertCharacter.getCharacter());
		Node tn = getWrappedElement().getFirstChild();
		if (tn instanceof Text) {
			Text text = (Text) tn;
			this.textBeforeChanged = text.getNodeValue();
			text.insertData(Math.min(insertCharacter.getPosition(), text.getLength()), caractereAdded);
			textChanged = text.getNodeValue();
		}else if (tn instanceof TValElement){
			Constraint val = ((TValElement)tn).getConstraint();
			java.util.List dependencies = val.getDependencies();
			if (dependencies.size() == 1 && (dependencies.get(0) instanceof AttributeDependency)) {
				Dependency dep = (Dependency)val.getDependencies().get(0);
				AttributeDependency ad = (AttributeDependency)dep;
				Node att = ad.getParentNode().getAttributes().getNamedItem(ad.getLocalName());
				textBeforeChanged = att.getNodeValue();
				textChanged = textBeforeChanged.substring(0, insertCharacter.getPosition())+caractereAdded+textBeforeChanged.substring(insertCharacter.getPosition());
				try {
				att.setNodeValue(textChanged);
				} catch (NullPointerException x) {}
			} else {
				String expr = val.getExpression();
				javax.xml.xpath.XPath xpath = XPathFactory.newInstance().newXPath();
				Node n;
				try {
					n = (Node)xpath.evaluate(expr, tn, XPathConstants.NODE);
				} catch (XPathExpressionException e1) {
					throw new RuntimeException(e1);
				}
				if (n instanceof Attr) {
					textBeforeChanged = n.getNodeValue();
					textChanged = textBeforeChanged.substring(0, insertCharacter.getPosition())+caractereAdded+textBeforeChanged.substring(insertCharacter.getPosition());
					n.setNodeValue(textChanged);
				} else if (n instanceof Text) {
					textBeforeChanged = ((Text)n).getData();
					textChanged = textBeforeChanged.substring(0, insertCharacter.getPosition())+caractereAdded+textBeforeChanged.substring(insertCharacter.getPosition());
					((Text)n).setData(textChanged);
				} else {
					JOptionPane.showMessageDialog(null, "Modifying a C-SVG reference (node, variable, BBox, viewport, zoom and pan) is not implemented.", "Not implemented", JOptionPane.ERROR_MESSAGE);
					return;
				}
			}
		}
		
		// New feature
		
		if(this.listenerTestAndFireEvent()) {
		
		// End new feature
		
		

		//SVGScene.getInstance().updateConstraints();
		
		}
	}

	private boolean listenerTestAndFireEvent() {
		//Component textBox = getEditableString();
		return this.testAndFireEvent(new CharacterInsertedEvent((EditableString)textBox, textBeforeChanged, textChanged,caractereAdded));
	}
	
	public Class[] getScope() {
		return new Class[] {SVGLocatable.class, SVGTextContentElement.class};
	}
	
	public String getCaractere() {
		return this.caractereAdded;
	}
	
	
	
	//private boolean
	
	public void addListener(Listener l) {
		this.listenableDelegate.addListener(l);
	}

	public void removeListener(Listener l) {
		this.listenableDelegate.removeListener(l);
	}

	public void fireEvent(Event e) throws UncheckedEventException {
		this.listenableDelegate.fireEvent(e);
	}

	public void checkEvent(Event e) {
		this.listenableDelegate.checkEvent(e);
	}

	public boolean testAndFireEvent(Event e) {
		return this.listenableDelegate.testAndFireEvent(e);
	}
}
