/*
 * Created on 15 juin 2005
 *
 * TODO To change the template for this generated file go to
 *  * Copyright 2004-2008 Frdric FONDEMENT
 */
package test.interfaces;

import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;
import java.util.Vector;

import listeners.DefaultListenable;
import listeners.Event;
import listeners.EventKind;
import listeners.Listenable;
import listeners.Listener;
import listeners.UncheckedEventException;

import test.actionqueries.Container;
import test.actionqueries.Contents;
import test.listeners.SVGActionInterfaceListener;
import test.listeners.SVGListenableActionInterface;
import utils.ComponentVarPersistant;
import dopidom.Action;
import dopidom.ActionEvent;
import dopidom.ActionInterface;
import dopidom.Component;
import dopidom.Query;
import dopidom.QueryInterface;
import dopidom.svg.SVGActionInterface;
import dopidom.svg.SVGQueryInterface;
import event.CreationEvent;

/**
 * @author fondemen
 *
 * TODO To change the template for this generated type comment go to
 *  * Copyright 2004-2008 Frdric FONDEMENT
 */


public class Containable extends SVGListenableActionInterface implements QueryInterface, Listenable {

	public static final DefaultListenable ContainableListener = new DefaultListenable();
	private DefaultListenable listenableDelegate = new DefaultListenable();
	
	protected ComponentVarPersistant container = new ComponentVarPersistant(getWrappedElement(), "Containable", "container");
	
	class ContainableQuery extends SVGQueryInterface {
	
	
		/**
		 * @param ownerComponent
		 */
		public ContainableQuery(Component ownerComponent) {
			super(ownerComponent);
			//One needs to fire an event when load is done
			Containable.this.container.addPropertyChangeListener(new PropertyChangeListener(){

				public void propertyChange(PropertyChangeEvent evt) {
					if (new Integer(0).equals(evt.getPropagationId())) {
						Component container = (Component)evt.getNewValue();
						Container action = new Container();
						action.setContainer(container);
						action.setContained(Containable.this.getOwnerComponent());
						Containable.this.fireSVGActionEvent(ActionEvent.DO_ACTION_EVENT, action);
					}
				}});
		}
	
		/* (non-Javadoc)
		 * @see dopidom.QueryInterface#getQuery()
		 */
		public Class getQuery() {
			return Container.class;
		}
	
		/* (non-Javadoc)
		 * @see dopidom.QueryInterface#getScope()
		 */
		public Class[] getScope() {
			return null;
		}
	
		public void doQuery(Query query) {
			Container q = (Container)query;
			q.setContainer(container.get());
			q.setContained(this.getOwnerComponent());
		}

	}

	protected final ContainableQuery containableQueryDelegate;

	/**
	 * @param ownerComponent
	 */
	public Containable(Component ownerComponent) {
		super(ownerComponent);

		this.containableQueryDelegate = new ContainableQuery(ownerComponent);
		ContainableListener.testAndFireEvent(new CreationEvent(EventKind.ContainableCreated, this));
		
		/*this.addListener(new SVGActionInterfaceListener() {
			public void rien(){}

			public void handleEvent(String eventType, ActionInterface target, Action action) {
				if (action instanceof Container) {
					Component container = ((Container)action).getContainer();
					Component contained = ((Container)action).getContained();
					rien();
				}
			}
		});*/
	}

	public Class getQuery() {
		return this.containableQueryDelegate.getQuery();
	}

	/* (non-Javadoc)
	 * @see dopidom.QueryInterface#getScope()
	 */
	public Class[] getScope() {
		return this.containableQueryDelegate.getScope();
	}

	/* (non-Javadoc)
	 * @see dopidom.QueryInterface#canDoQuery(java.lang.Class)
	 */
	public boolean canDoQuery(Class queryClass) {
		return this.containableQueryDelegate.canDoQuery(queryClass);
	}

	/* (non-Javadoc)
	 * @see dopidom.QueryInterface#doQuery(dopidom.Query)
	 */
	public void doQuery(Query query) {
		this.containableQueryDelegate.doQuery(query);
	}

	/* (non-Javadoc)
	 * @see dopidom.ActionInterface#getAction()
	 */
	public Class getAction() {
		return Container.class;
	}

	/* (non-Javadoc)
	 * @see test.listeners.SVGListenableActionInterface#act(dopidom.Action)
	 */
	protected void act(Action action) {
		Container c = (Container)action;
		
		if (c.getContained() != this.getOwnerComponent())
			throw new IllegalArgumentException("set container action sent to the bad object");

		if (c.getContainer() == this.container.get())
			return;
		
		if (this.container.get() != null) {
			ActionInterface ca = this.container.get().getActionInterface(Contents.class);
			QueryInterface cq = this.container.get().getQueryInterface(Contents.class);
			if (cq == null || ca == null)
				throw new RuntimeException("a containable element can only be contained by a container");

			Contents cadd = new Contents();
			cadd.setContainer(this.container.get());
			cq.doQuery(cadd);
			
			cadd.getContents().remove(this.getOwnerComponent());
			ca.doAction(cadd);
			
		}

		this.container.set(c.getContainer());
		
		if (c.getContainer() != null) {
			ActionInterface ca = c.getContainer().getActionInterface(Contents.class);
			QueryInterface cq = c.getContainer().getQueryInterface(Contents.class);
			if (cq == null || ca == null)
				throw new RuntimeException("a containable element can only be contained by a container");
			
			Contents cadd = new Contents();
			cadd.setContainer(c.getContainer());
			cq.doQuery(cadd);
			
			if (! cadd.getContents().contains(this.getOwnerComponent())) {
				cadd.getContents().add(this.getOwnerComponent());
				ca.doAction(cadd);
			}
			
		}
	}
	public void addListener(Listener l) {
		this.listenableDelegate.addListener(l);
	}

	public void removeListener(Listener l) {
		this.listenableDelegate.removeListener(l);
	}

	public void fireEvent(Event e) throws UncheckedEventException {
		this.listenableDelegate.fireEvent(e);
	}

	public void checkEvent(Event e) {
		this.listenableDelegate.checkEvent(e);
	}

	public boolean testAndFireEvent(Event e) {
		return this.listenableDelegate.testAndFireEvent(e);
	}
}
