/*
 * Created on 15 juin 2005
 *
 * TODO To change the template for this generated file go to
 *  * Copyright 2004-2008 Frdric FONDEMENT
 */
package test.interfaces;

import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Iterator;
import java.util.Vector;

import listeners.DefaultListenable;
import listeners.Event;
import listeners.EventKind;
import listeners.Listenable;
import listeners.Listener;
import listeners.UncheckedEventException;

import test.actionqueries.Contents;
import test.listeners.SVGActionInterfaceListener;
import test.listeners.SVGListenableActionInterface;
import utils.ListCVarPersistant;
import dopidom.Action;
import dopidom.ActionEvent;
import dopidom.ActionInterface;
import dopidom.Component;
import dopidom.Query;
import dopidom.QueryInterface;
import dopidom.svg.SVGActionInterface;
import dopidom.svg.SVGQueryInterface;
import event.CreationEvent;

/**
 * @author fondemen
 *
 * TODO To change the template for this generated type comment go to
 *  * Copyright 2004-2008 Frdric FONDEMENT
 */
public class Container extends SVGListenableActionInterface implements QueryInterface, Listenable {

	protected ListCVarPersistant contents = new ListCVarPersistant(getWrappedElement(), "Container", "contents");
	public static final DefaultListenable ContainerListener = new DefaultListenable();
	private DefaultListenable listenableDelegate = new DefaultListenable();
	
	protected class ContainerQuery extends SVGQueryInterface {
	
		/**
		 * @param ownerComponent
		 */
		public ContainerQuery(Component ownerComponent) {
			super(ownerComponent);
			//One needs to fire an event when load is done
			Container.this.contents.addPropertyChangeListener(new PropertyChangeListener(){

				public void propertyChange(PropertyChangeEvent evt) {
					if (new Integer(0).equals(evt.getPropagationId())) {
						Vector contained = (Vector)evt.getNewValue();
						Contents action = new Contents();
						action.setContainer(Container.this.getOwnerComponent());
						action.setContents(contained);
						Container.this.fireSVGActionEvent(ActionEvent.DO_ACTION_EVENT, action);
					}
				}});
		}
	
		/* (non-Javadoc)
		 * @see dopidom.QueryInterface#getQuery()
		 */
		public Class getQuery() {
			return Contents.class;
		}
	
		/* (non-Javadoc)
		 * @see dopidom.QueryInterface#getScope()
		 */
		public Class[] getScope() {
			return null;
		}
	
		public void doQuery(Query query) {
			Contents q = (Contents)query;
			q.setContainer(this.getOwnerComponent());
			q.setContents(new ArrayList(contents.getVector()));
		}
	}
	
	protected final ContainerQuery containerQueryDelegate;
	
	/**
	 * @param ownerComponent
	 */
	public Container(Component ownerComponent) {
		super(ownerComponent);
		
		this.containerQueryDelegate = new ContainerQuery(ownerComponent);
		ContainerListener.testAndFireEvent(new CreationEvent(EventKind.ContainerCreated, this));
		
		/*this.addListener(new SVGActionInterfaceListener () {

			public void handleEvent(String eventType, ActionInterface target, Action action) {
				if (action instanceof Contents) {
					Component container = ((Contents)action).getContainer();
					Collection contained = ((Contents)action).getContents();
				}
			}
			
		});*/
	}

	/* (non-Javadoc)
	 * @see dopidom.QueryInterface#getQuery()
	 */
	public Class getQuery() {
		return this.containerQueryDelegate.getQuery();
	}

	/* (non-Javadoc)
	 * @see dopidom.QueryInterface#getScope()
	 */
	public Class[] getScope() {
		return this.containerQueryDelegate.getScope();
	}

	/* (non-Javadoc)
	 * @see dopidom.QueryInterface#canDoQuery(java.lang.Class)
	 */
	public boolean canDoQuery(Class queryClass) {
		return this.containerQueryDelegate.canDoQuery(queryClass);
	}

	/* (non-Javadoc)
	 * @see dopidom.QueryInterface#doQuery(dopidom.Query)
	 */
	public void doQuery(Query query) {
		this.containerQueryDelegate.doQuery(query);
	}

	/* (non-Javadoc)
	 * @see dopidom.ActionInterface#getAction()
	 */
	public Class getAction() {
		return Contents.class;
	}

	/* (non-Javadoc)
	 * @see test.listeners.SVGListenableActionInterface#act(dopidom.Action)
	 */
	protected void act(Action action) {
		Contents c = (Contents)action;
		
		if (c.getContainer() != this.getOwnerComponent())
			throw new IllegalArgumentException("set contained action sent to the bad object");

		ArrayList toRemove = new ArrayList(this.contents.getVector());
		toRemove.removeAll(c.getContents());
		for (Iterator i = toRemove.iterator(); i.hasNext();) {
			Component rem = (Component)i.next();

			ActionInterface ca = rem.getActionInterface(test.actionqueries.Container.class);
			QueryInterface cq = rem.getQueryInterface(test.actionqueries.Container.class);
			if (cq == null || ca == null)
				throw new RuntimeException("a container element can only contain containable elements");
			
			this.contents.remove(rem);
			
			test.actionqueries.Container cadd = new test.actionqueries.Container();
			cadd.setContained(rem);
			cadd.setContainer(null);
			ca.doAction(cadd);
		}
				
		for (Iterator i = c.getContents().iterator(); i.hasNext();) {
			Component contained = (Component) i.next();
			
			if (! this.contents.getVector().contains(contained)) {
				ActionInterface ca = contained.getActionInterface(test.actionqueries.Container.class);
				QueryInterface cq = contained.getQueryInterface(test.actionqueries.Container.class);
				if (cq == null || ca == null)
					throw new RuntimeException("a container element can only contain containable elements");
				
				this.contents.add(contained);
				
				test.actionqueries.Container cadd = new test.actionqueries.Container();
				cadd.setContained(contained);
				cadd.setContainer(this.getOwnerComponent());
				ca.doAction(cadd);
			}
		}
	}
	
	public void addListener(Listener l) {
		this.listenableDelegate.addListener(l);
	}

	public void removeListener(Listener l) {
		this.listenableDelegate.removeListener(l);
	}

	public void fireEvent(Event e) throws UncheckedEventException {
		this.listenableDelegate.fireEvent(e);
	}

	public void checkEvent(Event e) {
		this.listenableDelegate.checkEvent(e);
	}

	public boolean testAndFireEvent(Event e) {
		return this.listenableDelegate.testAndFireEvent(e);
	}
}
