/*
 * Created on 14 mars 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package test.interfaces;

import java.awt.Shape;
import java.awt.geom.Rectangle2D;

import listeners.DefaultListenable;
import listeners.Event;
import listeners.EventKind;
import listeners.Listenable;
import listeners.Listener;
import listeners.UncheckedEventException;

import org.apache.batik.gvt.GraphicsNode;
import org.w3c.dom.svg.SVGLocatable;

import test.queries.Location;
import dopidom.Component;
import dopidom.Query;
import dopidom.svg.SVGQueryInterface;
import dopidom.svg.SVGScene;
import event.CreationEvent;

/**
 * @author Olivier Beaudoux
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class Locatable extends SVGQueryInterface implements Listenable
{
	
	public static final DefaultListenable LocatableListener = new DefaultListenable();
	private DefaultListenable listenableDelegate = new DefaultListenable();
	
	public Locatable(Component ownerComponent)
	{
		super(ownerComponent);
		LocatableListener.testAndFireEvent(new CreationEvent(EventKind.LocatableCreated, this));
	}

	public Class getQuery()
	{
		return Location.class;
	}

	public Class[] getScope()
	{
		return new Class[] { SVGLocatable.class };
	}

	public synchronized void doQuery(Query query)
	{
		Location l = (Location)query;
		
		GraphicsNode gn = SVGScene.getInstance().getGVTNode(getWrappedElement());
		Shape s;
		int i = 0;
		do {
			try {
				i++;
				s = gn.getGlobalTransform().createTransformedShape(gn.getOutline());
			} catch (RuntimeException e) {
				s = null;
				if (i > 1000) {
					l.setX(-1);
					l.setY(-1);
					l.setWidth(-1);
					l.setHeight(-1);
					return;
				}
			}
		} while (s == null);
		
		Rectangle2D stamp = s.getBounds2D();
		
		l.setX(stamp.getX());
		l.setY(stamp.getY());
		l.setWidth(stamp.getWidth());
		l.setHeight(stamp.getHeight());
	}
	
	public void addListener(Listener l) {
		this.listenableDelegate.addListener(l);
	}

	public void removeListener(Listener l) {
		this.listenableDelegate.removeListener(l);
	}

	public void fireEvent(Event e) throws UncheckedEventException {
		this.listenableDelegate.fireEvent(e);
	}

	public void checkEvent(Event e) {
		this.listenableDelegate.checkEvent(e);
	}

	public boolean testAndFireEvent(Event e) {
		return this.listenableDelegate.testAndFireEvent(e);
	}
}
