/*
 * Created on 14 mars 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package test.interfaces;


import listeners.DefaultListenable;
import listeners.Event;
import listeners.EventKind;
import listeners.Listenable;
import listeners.Listener;
import listeners.UncheckedEventException;

import org.w3c.dom.Node;

import test.Background;
import test.Container;
import test.actions.OrderingAction;
import dopidom.Action;
import dopidom.Component;
import dopidom.svg.SVGActionInterface;
import dopidom.svg.SVGInteractor;
import event.CreationEvent;

/**
 * @author Olivier Beaudoux
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class Orderable extends SVGActionInterface implements Listenable
{
	public static final DefaultListenable OrderableListener = new DefaultListenable();
	private DefaultListenable listenableDelegate = new DefaultListenable();
	
	public Orderable(Component ownerComponent)
	{
		super(ownerComponent);
		OrderableListener.testAndFireEvent(new CreationEvent(EventKind.OrderableCreated, this));
	}

	public Class getAction()
	{
		return OrderingAction.class;
	}

	public Class[] getScope()
	{
		return new Class[] { Node.class };
	}
	
	protected int getIndex() {
		Component [] ownerContents = ((Container)this.getOwnerComponent().getParent()).getContents();
		Node n = getWrappedElement();
		for (int i = 0; i < ownerContents.length; i++) {
			if (ownerContents[i].getWrappedElement() == n)
				return i;
		}
		return -1;
	}

	public void doAction(Action action)
	{
		OrderingAction o = (OrderingAction)action;
		Component comp = this.getOwnerComponent().getParent();
		if (comp instanceof Container) {
			Container c = (Container)comp;
			Component [] contents;
			int index;
			getWrappedElement().getParentNode().removeChild(getWrappedElement());
			switch (o.getMode().hashCode()) {
			case OrderingAction.Mode.ToFrontHash:
//				SVGInteractor [] interactors = c.getInteractors();
//				if (interactors != null && interactors.length > 0) {
//					c.getWrappedElement().insertBefore(getWrappedElement(), interactors[0].getWrappedElement());
//				} else {
//					c.getWrappedElement().appendChild(getWrappedElement());
//				}
				c.getWrappedElement().appendChild(getWrappedElement());
				break;
			case OrderingAction.Mode.ToBackHash:
				Background back = c.getBackground();
				if (back != null) {
					Node next = back.getWrappedElement().getNextSibling();
					if (next != null && next != getWrappedElement()) {
						c.getWrappedElement().insertBefore(getWrappedElement(), next);
					}
				} else if (c.getWrappedElement().getFirstChild() != null && c.getWrappedElement().getFirstChild() != getWrappedElement()) {
					c.getWrappedElement().insertBefore(getWrappedElement(), c.getWrappedElement().getFirstChild());
				}
				break;
			case OrderingAction.Mode.ForwardHash:
//				contents = c.getContents();
//				index = this.getIndex();
//				if (index != -1 && contents.length > index+1) {
//					if (! (contents[index+1] instanceof SVGInteractor)) {
//						if (contents[index+1].getWrappedElement().getNextSibling() == null)
//							c.getWrappedElement().appendChild(getWrappedElement());
//						else
//							c.getWrappedElement().insertBefore(getWrappedElement(), contents[index+1].getWrappedElement().getNextSibling());
//					}
//				}
				Node next = getWrappedElement().getNextSibling();
				if (next != null)
					c.getWrappedElement().insertBefore(getWrappedElement(), next);
				break;
			case OrderingAction.Mode.BackwardHash:
				contents = c.getContents();
				index = this.getIndex();
				if (index > 1) {
					if (! (contents[index-1] instanceof Background)) {
						c.getWrappedElement().insertBefore(getWrappedElement(), contents[index-1].getWrappedElement());
					}
				}
				break;
			}
		}
		/*Node n = getWrappedElement();
		Node owner = n.getParentNode();
		if (owner != null) {
			switch (o.getMode().hashCode()) {
			case OrderingAction.Mode.ToFrontHash:
				Node l = owner.getLastChild();
				if (l == null)
					owner.appendChild(n);
				else {
					while ((l instanceof Element) && (DOMComponent.getFactory().getWrapperComponent((Element)l) instanceof SVGToolInteractor))
						l = l.getPreviousSibling();
					owner.insertBefore(n, l);
				}
				break;
			case OrderingAction.Mode.ToBackHash:
				Node fc = owner.getFirstChild();
				Component container = DOMComponent.getFactory().getOwnerComponent((Element)owner);
				if (container instanceof Container) {
					Background back = ((Container)container).getBackground();
					if (back != null)
						fc = back.getWrappedElement().getNextSibling();
				}
				if (fc == null)
					;
				else if (fc != n)
					owner.insertBefore(n, fc);
				break;
			case OrderingAction.Mode.ForwardHash:
				if (owner.getLastChild() != n) {
					Node next = n.getNextSibling().getNextSibling();
					while(! ((next instanceof Element) && (DOMComponent.getFactory().getOwnerComponent((Element)next) != null)))
					next = next.getNextSibling();
					if (next != null)
						owner.insertBefore(n, next);
				}
				break;
			case OrderingAction.Mode.BackwardHash:
				if (owner.getFirstChild() != n) {
					Node next = n.getPreviousSibling();
					if (! ((next instanceof Element) && (DOMComponent.getFactory().getOwnerComponent((Element)next) instanceof Background)))
						owner.insertBefore(n, next);
				}
				break;
			}
		}*/
		
		
	}
	public void addListener(Listener l) {
		this.listenableDelegate.addListener(l);
	}
	
	public void removeListener(Listener l) {
		this.listenableDelegate.removeListener(l);
	}
	
	public void fireEvent(Event e) throws UncheckedEventException {
		this.listenableDelegate.fireEvent(e);
	}
	
	public void checkEvent(Event e) {
		this.listenableDelegate.checkEvent(e);
	}
	
	public boolean testAndFireEvent(Event e) {
		return this.listenableDelegate.testAndFireEvent(e);
	}
}
