/*
 * Created on 14 mars 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package test.interfaces;

import listeners.DefaultListenable;
import listeners.Event;
import listeners.EventKind;
import listeners.Listenable;
import listeners.Listener;
import listeners.UncheckedEventException;

import org.w3c.dom.svg.SVGMatrix;
import org.w3c.dom.svg.SVGTransform;
import org.w3c.dom.svg.SVGTransformList;
import org.w3c.dom.svg.SVGTransformable;

import test.EditableString;
import test.actions.ResizeAction;
import test.queries.Location;
import dopidom.Action;
import dopidom.Component;
import dopidom.svg.SVGActionInterface;
import dopidom.svg.SVGScene;
import event.CharacterInsertedEvent;
import event.CreationEvent;
import event.ResizeEvent;

/**
 * @author Olivier Beaudoux
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class Resizable extends SVGActionInterface implements Listenable
{	
	public static final DefaultListenable ResizableListener = new DefaultListenable();
	private DefaultListenable listenableDelegate = new DefaultListenable();
	
	public Resizable(Component ownerComponent)
	{
		super(ownerComponent);
		ResizableListener.testAndFireEvent(new CreationEvent(EventKind.ResizableCreated, this));
		//assert ownerComponent.canDoQuery(Locatable.class)
	}

	public Class getAction()
	{
		return ResizeAction.class;
	}

	public Class[] getScope()
	{
		return new Class[] { SVGTransformable.class };
	}

	public void doAction(Action action)
	{
		ResizeAction resize = (ResizeAction) action;
		resize(resize.getWidth(), resize.getHeight());
	}

	protected void resize(double w, double h)
	{
		Location l = new Location();
		this.getOwnerComponent().getQueryInterface(Location.class).doQuery(l);

		double scaleW = w/l.getWidth();
		double scaleH = h/l.getHeight();
			
		SVGTransformable transformable = (SVGTransformable) getWrappedElement();
		SVGTransformList transformList = transformable.getTransform().getBaseVal();
		SVGTransform transform = transformList.consolidate();
		SVGMatrix matrix;
		if (transform == null) {
			matrix = SVGScene.getInstance().getRootElement().createSVGMatrix();
			transform = transformList.createSVGTransformFromMatrix(matrix);
			transformable.getTransform().getBaseVal().appendItem(transform);
		} else
			matrix = transform.getMatrix();
		matrix.setA((float) (matrix.getA() * scaleW));
		matrix.setD((float) (matrix.getD() * scaleH));
		
		this.testAndFireEvent(new ResizeEvent(this.ownerComponent, (float) (matrix.getA() * scaleW), (float) (matrix.getD() * scaleH)));
	}
	
	public void addListener(Listener l) {
		this.listenableDelegate.addListener(l);
	}

	public void removeListener(Listener l) {
		this.listenableDelegate.removeListener(l);
	}

	public void fireEvent(Event e) throws UncheckedEventException {
		this.listenableDelegate.fireEvent(e);
	}

	public void checkEvent(Event e) {
		this.listenableDelegate.checkEvent(e);
	}

	public boolean testAndFireEvent(Event e) {
		return this.listenableDelegate.testAndFireEvent(e);
	}
}
