/*
 * Created on 14 mars 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package test.interfaces;

import org.w3c.dom.svg.SVGLocatable;

import test.Container;
import test.actions.HilightAction;
import test.actions.SelectAction;
import test.listeners.SVGListenableActionInterface;
import test.selection.SelectionManager;
import dopidom.Action;
import dopidom.Component;
import dopidom.svg.SVGActionInterface;

/**
 * @author Olivier Beaudoux
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class Selectable extends SVGListenableActionInterface
{
		
	public Selectable(Component ownerComponent)
	{
		super(ownerComponent);
		
		//assert ownerComponent.canDoQuery(HilightAction.class)
		//asset ownerComponent instanceof Container
	}

	public Class getAction()
	{
		return SelectAction.class;
	}

	public Class[] getScope()
	{
		return new Class[] { SVGLocatable.class };
	}

	public void act(Action action)
	{
		SelectAction s = (SelectAction)action;
		
		if (!s.isPartOfMultipleSelection()) {
			s.setPreviousSelection(SelectionManager.INSTANCE.getSelectedComponent());
		}	
		this.select(this.getComponentToHilight(), s);
	}
	
	public void redoActions(Action[] actions) {
		if (actions.length > 1)
			this.undoActions(new Action[]{actions[0]});
		if (actions.length > 0)
			this.doAction(actions[actions.length-1]);
	}
	
	public void tca(Action[] actions) {
		HilightAction [] has = new HilightAction[actions.length];
		for (int i = 0; i < has.length; i++) {
			has[i] = ((SelectAction)actions[i]).getHilight();
		}
		// CHANGED :
		if (this.getComponentToHilight()!= null && this.getComponentToHilight().canDoAction(HilightAction.class))
			this.getComponentToHilight().getActionInterface(HilightAction.class).undoActions(has);
		
		this.unselect(getOwnerComponent(), (SelectAction)actions[0]);
		
		if (actions.length > 0)
		//	SelectionManager.INSTANCE.setSelectedComponent(((SelectAction)actions[actions.length-1]).getPreviousSelection());
			this.unselect(getOwnerComponent(), (SelectAction)actions[actions.length-1]);
	}
	
	public void select(Component c, SelectAction s) {
		if (s.isPartOfMultipleSelection())
			SelectionManager.INSTANCE.addSelectedComponentLast(c);
		else
			SelectionManager.INSTANCE.setSelectedComponent(c);
		
		Component h = this.getComponentToHilight();
		if (h != null)
			c.getActionInterface(HilightAction.class).doAction(s.getHilight());
	}
	
	public void unselect(Component c, SelectAction s) {
		if (s.isPartOfMultipleSelection())
			SelectionManager.INSTANCE.removeSelectedComponent(c);
		else
			SelectionManager.INSTANCE.setSelectedComponent(s.getPreviousSelection());
		Component h = this.getComponentToHilight();
		if (h != null)
			h.getActionInterface(HilightAction.class).undoActions(new HilightAction[] {s.getHilight()});
	}
	
	public Component getComponentToHilight() {
		Component ret = this.getOwnerComponent();
		if (ret instanceof Container)
			ret = ((Container)ret).getBackground();
		if (ret != null && !ret.canDoAction(HilightAction.class))
			ret = null;
		return ret;
	}
}
