package test.languageloading;

import ihm04.actions.Translate;

import java.awt.event.MouseEvent;
import java.util.Arrays;

import actions.Handle;

import test.GUI.GUI;
import test.selection.SelectionManager;
import test.templates.DefaultSVGTemplateProperties;
import test.templates.SVGFileTemplate;
import test.templates.SVGTemplatePropertyException;
import dopidom.ActionInterface;
import dopidom.Component;
import dopidom.svg.SVGCleanToolInteractor;
import dopidom.svg.SVGInteraction;
import dopidom.svg.SVGScene;

public class Creator extends SVGInteraction {
	protected final SVGFileTemplate template;
	
	protected boolean isActive = false;

	public Creator(SVGCleanToolInteractor interactor, SVGFileTemplate template) {
		super(interactor);
		this.getInteractor().getInteractions().remove(this);
		this.getInteractor().getInteractions().add(0, this);
		this.template = template;
	}
	
	public boolean isActive() {
		return isActive;
	}
	public void setActive(boolean isActive) {
		this.isActive = isActive;
	}
	
	public void mouseClicked(final MouseEvent e) {
		if (this.isActive()) {
			try {
				SelectionManager.INSTANCE.setSelectedComponent(null);
				TemplateInstance ti = new TemplateInstance(GUI.INSTANCE.getLanguage(), this.template, e.getX(), e.getY());
				if (ti.getComponents().size()>0)
					SelectionManager.INSTANCE.setSelectedComponents(ti.getComponents().toArray(new Component[ti.getComponents().size()]));

			} finally {
				e.consume();
				this.setActive(false);
			}
		}
	}
	
	protected void consumeIfActive(MouseEvent e) {
		if(this.isActive())
			e.consume();
	}
	
	public void mouseDragged(MouseEvent e) {
		this.consumeIfActive(e);
	}
	public void mouseEntered(MouseEvent e) {
		this.consumeIfActive(e);
	}
	public void mouseExited(MouseEvent e) {
		this.consumeIfActive(e);
	}
	public void mouseMoved(MouseEvent e) {
		this.consumeIfActive(e);
	}
	public void mousePressed(MouseEvent e) {
		this.consumeIfActive(e);
	}
	public void mouseReleased(MouseEvent e) {
		this.consumeIfActive(e);
	}
}
