/*
 * Created on 11 mai 2005
 *
 * TODO To change the template for this generated file go to
 *  * Copyright 2004-2008 Frdric FONDEMENT
 */
package test.languageloading;

import interpretor.InterpretorFactory;
import interpretor.Variable;

import java.io.BufferedInputStream;
import java.io.File;
import java.io.FileFilter;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FilenameFilter;
import java.io.IOException;
import java.net.MalformedURLException;
import java.net.URL;
import java.util.ArrayList;
import java.util.List;

import listeners.initial.ListenerInitiator;

import org.apache.batik.script.InterpreterFactory;

import dopidom.svg.SVGScene;

import test.GUI.GUI;
import test.templates.SVGFileTemplate;
import utils.ClassPathHacker;
import utils.Directories;

/**
 * @author fondemen
 *
 * TODO To change the template for this generated type comment go to
 *  * Copyright 2004-2008 Frdric FONDEMENT
 */
public class LanguageLoader {
	public static final LanguageLoader INSTANCE = new LanguageLoader();
	public static final String SVGSceneFileName = "empty.svg";
	public static final String SVGTemplateFilter = ".svg".toLowerCase();
	public static final String SVGIconTemplateFilter = "_icon.svg".toLowerCase();
	public static final FileFilter SvgFileFilter = new FileFilter() {
		public boolean accept(File pathname) {
			return (!pathname.getName().equals(SVGSceneFileName)) && pathname.isFile() && pathname.getName().toLowerCase().endsWith(SVGTemplateFilter) && ! pathname.getName().toLowerCase().endsWith(SVGIconTemplateFilter);
		}
	};
	public static FilenameFilter JarFilter = new FilenameFilter() {

		public boolean accept(File arg0, String arg1) {
			return arg1.endsWith(".jar");
		}
		
	};
	public static final String languageDirVar = "languageDir";
	
	private LanguageLoader() {}
	
	/**
	 * Loads a language from the <code>directory</code> directory.<br>
	 * Each template must be represented by a file XXX.svg, where XXX is the name of the temlpate.
	 * If exists a file XXX_icon.svg, it will be interpreted as the icon for the template.
	 * If exists some jar files, adds them to the classpath
	 * If exists some files init.XXX, run those files using the XXX interpreter (if exists).
	 * @param directory the directory where templates are stored
	 * @return an array of SVG file templates
	 */
	public Language loadLanguage(final File directory) throws IOException {
		File [] files = directory.listFiles(SvgFileFilter);
		ArrayList ret = new ArrayList(files.length);
		for (int i = 0; i < files.length; ++i) {
			String name = files[i].getName();
			if (name.length() > SVGTemplateFilter.length()) {
				name = name.substring(0, name.length() - SVGTemplateFilter.length());
				File icon = new File(directory, name + "_icon.svg");
				if (!icon.exists())
					icon = null;
				ret.add(new SVGFileTemplate(name, files[i], icon));
			}
		}

		files = directory.listFiles(JarFilter);
		for (int i = 0; i < files.length; i++) {
			ClassPathHacker.addFile(files[i]);
		}
		
		InterpretorFactory.resetInterpreters();
		List<Variable> vars = new ArrayList<Variable>(1);
		vars.add(new Variable() {

			public String getName() {
				return languageDirVar;
			}

			public Object getValue() {
				return directory.getAbsolutePath();
			}});
		InitFileFilterClass.INSTANCE.run(directory, null, vars);
		
		URL url = null;
		File emptyFile = new File(directory, SVGSceneFileName);
		if (emptyFile.isFile() && emptyFile.canRead())
			try {
				url = emptyFile.toURL();
			} catch (MalformedURLException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		if (url == null) {
			url= Directories.getResource("/resources/"+SVGSceneFileName, new Class[] {GUI.class});
			System.out.println(" Empty scene not found in language directory ("+SVGSceneFileName+"); using " + url.getFile());
		}
		
		return new Language((SVGFileTemplate[])ret.toArray(new SVGFileTemplate[ret.size()]), url);
	}
}
