package test.languageloading;

import java.util.Iterator;
import java.util.List;

import javax.jmi.reflect.RefObject;
import javax.jmi.reflect.RefPackage;

import interpretor.InterpretorFactory;
import interpretor.Variable;
import interpretor.interpretorFacade;

import org.apache.batik.dom.AbstractDocument;
import org.apache.batik.extension.ExtensionElement;
import org.netbeans.api.mdr.events.AttributeEvent;
import org.netbeans.api.mdr.events.MDRChangeEvent;
import org.netbeans.api.mdr.events.MDRChangeListener;
import org.netbeans.api.mdr.events.MDRChangeSource;
import org.w3c.dom.Attr;
import org.w3c.dom.DOMException;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.NamedNodeMap;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;
import org.w3c.dom.events.Event;
import org.w3c.dom.events.EventListener;
import org.w3c.dom.events.EventTarget;
import org.w3c.dom.events.MutationEvent;

import utils.DomFinding;

public class VariableElement extends ExtensionElement implements Element {
	private static final long serialVersionUID = 980380486615363519L;
	
	public static final String Variable_Local_Name = "variable";
	public static final String Variable_Name_Att = "name";
	public static final String Value_Name_Att = "value";
	
	public VariableElement(AbstractDocument owner) {
		super(Variable_Local_Name, owner);
	}

	@Override
	protected Node newNode() {
		return new VariableElement(this.getCurrentDocument());
	}

	@Override
	public String getNodeName() {
		return Variable_Local_Name;
	}

}
