/*
 * Created on 25 nov. 2004
 *
 *  * Copyright 2004-2008 Frdric FONDEMENT
 */
package test.templates;

import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.util.Arrays;
import java.util.HashSet;
import java.util.Hashtable;
import java.util.Map;
import java.util.Set;

/**
 * @author fondemen
 *
 *  * Copyright 2004-2008 Frdric FONDEMENT
 */
public class DefaultSVGTemplateProperties implements SVGTemplateProperties {
	private final Map properties;
	private final Set optionalProperties;

	public DefaultSVGTemplateProperties() {
		super();
		this.properties = new Hashtable/*<String, Object>*/();
		this.optionalProperties = new HashSet/*<String>*/();
	}
	
	public DefaultSVGTemplateProperties (String[] props) {
		this();
		for (int i = 0; i < props.length; i++) {
			int eqIndex = props[i].indexOf('=');
			String name = props[i].substring(0, eqIndex);
			String val = props[i].substring(eqIndex + 1);
			try {
				ObjectInputStream ois = new ObjectInputStream(new ByteArrayInputStream(val.getBytes()));
				this.set(name, ois.readObject());
			} catch (IOException e) {
				e.printStackTrace();
			} catch (ClassNotFoundException e) {
				e.printStackTrace();
			}
		}
	}

	/**
	 * Null if the property does not exist.
	 */
	public Object get(String name) {
		return this.getProperties().get(name);
	}

	public void set(String name, Object value) {
		this.set(name, value, false);
	}

	public void set(String name, Object value, boolean optional) {
		this.getProperties().put(name, value);
		if (optional)
			this.optionalProperties.add(name);
	}

	public String[] getPropertiesNames() {
		Set keys = this.getProperties().keySet();
		return (String[])keys.toArray(new String [keys.size()]);
	}
	
	public boolean isOptional(String property) {
		return this.optionalProperties.contains(property);
	}

	protected Map getProperties() {
		return properties;
	}

	public String[] toStrings() {
		String [] ret = this.getPropertiesNames();
		if (ret == null || ret.length == 0)
			ret = new String[0];
		else {
			try {
				ByteArrayOutputStream objectWriter = new ByteArrayOutputStream();
				ObjectOutputStream oos = new ObjectOutputStream(objectWriter);
				Arrays.sort(ret);
				for (int i = 0; i < ret.length; i++) {
					objectWriter.reset();
					oos.writeObject(this.get(ret[i]));
					ret[i] += "=" + objectWriter.toString();
				}
			} catch (IOException e) {
				e.printStackTrace();
				ret = new String[0];
			}
		}
		return ret;
	}
}
