/*
 * Created on 25 nov. 2004
 *
 *  * Copyright 2004-2008 Frdric FONDEMENT
 */
package test.templates;

/**
 * @author fondemen
 *
 *  * Copyright 2004-2008 Frdric FONDEMENT
 */
public class DefaultSVGTemplatePropertyClass implements
		SVGTemplatePropertyClass {
	private SVGTemplateProperties classes;

	public DefaultSVGTemplatePropertyClass(SVGTemplateProperties classes) {
		super();
		this.classes = classes;
	}

	public String[] getKeys() {
		return this.getClasses().getPropertiesNames();
	}

	public Class getClass(String name) {
		return (Class)this.getClasses().get(name);
	}

	public boolean isOptional(String name) {
		return this.getClasses().isOptional(name);
	}

	public SVGTemplateProperties create() {
		return new DefaultSVGTemplateProperties();
	}

	public boolean isValid(SVGTemplateProperties properties) {
		try {
			this.validate(properties);
			return true;
		} catch (SVGTemplatePropertyException x) {
			return false;
		}
	}

	public void validate(SVGTemplateProperties properties)
			throws SVGTemplatePropertyException {
		String [] keys = this.getKeys();
		String [] clientKeys = properties.getPropertiesNames();
		if (keys != null && keys.length > 0) {
			for(int i = 0; i < keys.length; ++i) {
				Object v = properties.get(keys[i]);
				if (v == null) {
					if (! this.isOptional(keys[i]))
						throw new MissingSVGTemplatePropertyException(keys[i], this);
				} else if (!this.getClass(keys[i]).isInstance(v))
					throw new InvalidValueForSVGTemplatePropertyException(keys[i], v, this);
			}
			if (clientKeys.length != keys.length) {
				for (int i = 0 ; i < clientKeys.length; ++i) {
					if (this.getClass(clientKeys[i]) == null)
						throw new UnknownSVGTemplatePropertyException(clientKeys[i], this);
				}
			}
		} else {
			if (clientKeys != null && clientKeys.length != 0)
				throw new UnknownSVGTemplatePropertyException(clientKeys[0], this);
		}
	}

	public SVGTemplateProperties getClasses() {
		return classes;
	}
}
