/*
 * Created on 25 nov. 2004
 *
 *  * Copyright 2004-2008 Frdric FONDEMENT
 */
package test.templates;

/**
 * @author fondemen
 *
 *  * Copyright 2004-2008 Frdric FONDEMENT
 */
public class InvalidValueForSVGTemplatePropertyException extends SVGTemplatePropertyException {
	protected static String getMessage(String invalidShapeProperty, Object invalidValue, SVGTemplatePropertyClass validProperties, SVGTemplate shape) {
		return "Invalid value " + invalidValue + " of class " + invalidValue.getClass().getName() + " for property " + invalidShapeProperty + " ; should be " + validProperties.getClass(invalidShapeProperty).getName();
	}
	
	protected final String invalidProperty;
	protected final Object invalidValue;
	protected final SVGTemplatePropertyClass validProperties;
	protected final SVGTemplate shape;
	
	protected InvalidValueForSVGTemplatePropertyException(String invalidShapeProperty, Object invalidValue, SVGTemplatePropertyClass validProperties, SVGTemplate shape) {
		super(getMessage(invalidShapeProperty, invalidValue, validProperties, shape));
		this.invalidProperty = invalidShapeProperty;
		this.validProperties = validProperties;
		this.shape = shape;
		this.invalidValue = invalidValue;
	}
	
	protected InvalidValueForSVGTemplatePropertyException(String invalidShapeProperty, Object invalidValue, SVGTemplatePropertyClass validProperties, SVGTemplate shape, Throwable cause) {
		super(getMessage(invalidShapeProperty, invalidValue, validProperties, shape), cause);
		this.invalidProperty = invalidShapeProperty;
		this.validProperties = validProperties;
		this.shape = shape;
		this.invalidValue = invalidValue;
	}
	
	public InvalidValueForSVGTemplatePropertyException(String invalidShapeProperty, Object invalidValue, SVGTemplatePropertyClass validProperties) {
		this(invalidShapeProperty, invalidValue, validProperties, (SVGTemplate)null);
	}

	public InvalidValueForSVGTemplatePropertyException(String invalidShapeProperty, Object invalidValue, SVGTemplate shape) {
		this(invalidShapeProperty, invalidValue, shape.getPropertyClass(), shape);
	}
	
	public InvalidValueForSVGTemplatePropertyException(String invalidShapeProperty, Object invalidValue, SVGTemplatePropertyClass validProperties, Throwable cause) {
		this(invalidShapeProperty, invalidValue, validProperties, null, cause);
	}

	public InvalidValueForSVGTemplatePropertyException(String invalidShapeProperty, Object invalidValue, SVGTemplate shape, Throwable cause) {
		this(invalidShapeProperty, invalidValue, shape.getPropertyClass(), shape, cause);
	}

	public String getInvalidProperty() {
		return invalidProperty;
	}
	public Object getInvalidValue() {
		return invalidValue;
	}
	public SVGTemplate getShape() {
		return shape;
	}
	public SVGTemplatePropertyClass getValidProperties() {
		return validProperties;
	}
}
