/*
 * Created on 25 nov. 2004
 *
 *  * Copyright 2004-2008 Frdric FONDEMENT
 */
package test.templates;

/**
 * @author fondemen
 *
 *  * Copyright 2004-2008 Frdric FONDEMENT
 */
public class MissingSVGTemplatePropertyException extends SVGTemplatePropertyException {
	protected static String getMessage(String missingShapeProperty, SVGTemplatePropertyClass validProperties, SVGTemplate shape) {
		return "Missing " + missingShapeProperty + " value.";
	}
	
	protected final String missingProperty;
	protected final SVGTemplatePropertyClass validProperties;
	protected final SVGTemplate shape;
	
	protected MissingSVGTemplatePropertyException(String missingShapeProperty, SVGTemplatePropertyClass validProperties, SVGTemplate shape) {
		super(getMessage(missingShapeProperty, validProperties, shape));
		this.missingProperty = missingShapeProperty;
		this.validProperties = validProperties;
		this.shape = shape;
	}
	
	protected MissingSVGTemplatePropertyException(String missingShapeProperty, SVGTemplatePropertyClass validProperties, SVGTemplate shape, Throwable cause) {
		super(getMessage(missingShapeProperty, validProperties, shape), cause);
		this.missingProperty = missingShapeProperty;
		this.validProperties = validProperties;
		this.shape = shape;
	}
	
	public MissingSVGTemplatePropertyException(String missingShapeProperty, SVGTemplatePropertyClass validProperties) {
		this(missingShapeProperty, validProperties, (SVGTemplate)null);
	}

	public MissingSVGTemplatePropertyException(String missingShapeProperty, SVGTemplate shape) {
		this(missingShapeProperty, shape.getPropertyClass(), shape);
	}
	
	public MissingSVGTemplatePropertyException(String missingShapeProperty, SVGTemplatePropertyClass validProperties, Throwable cause) {
		this(missingShapeProperty, validProperties, null, cause);
	}

	public MissingSVGTemplatePropertyException(String missingShapeProperty, SVGTemplate shape, Throwable cause) {
		this(missingShapeProperty, shape.getPropertyClass(), shape, cause);
	}

	public String getMissingProperty() {
		return missingProperty;
	}
	public SVGTemplate getShape() {
		return shape;
	}
	public SVGTemplatePropertyClass getValidProperties() {
		return validProperties;
	}
}
