/*
 * Created on 11 mai 2005
 *
 * TODO To change the template for this generated file go to
 *  * Copyright 2004-2008 Frdric FONDEMENT
 */
package test.templates;

import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.Set;

import javax.swing.Icon;
import javax.swing.ImageIcon;

import listeners.DefaultListenable;
import listeners.Event;
import listeners.EventKind;
import listeners.Listenable;
import listeners.Listener;
import listeners.UncheckedEventException;

import org.apache.batik.anim.ConstraintAnimation;
import org.apache.batik.bridge.DocumentLoader;
import org.apache.batik.bridge.UserAgentAdapter;
import org.apache.batik.constraint.Constraint;
import org.apache.batik.constraint.ConstraintElement;
import org.apache.batik.constraint.TValElement;
import org.apache.batik.constraint.Variable;
import org.apache.batik.constraint.VariableElement;
import org.apache.batik.dom.AbstractDocument;
import org.apache.batik.dom.ExtendedNode;
import org.apache.batik.dom.svg.SVGOMDocument;
import org.apache.batik.dom.svg.SVGOMSVGElement;
import org.apache.batik.transcoder.TranscoderException;
import org.apache.batik.transcoder.TranscoderInput;
import org.apache.batik.transcoder.TranscoderOutput;
import org.apache.batik.transcoder.image.PNGTranscoder;
import org.w3c.dom.Attr;
import org.w3c.dom.CharacterData;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.NamedNodeMap;
import org.w3c.dom.Node;
import org.w3c.dom.events.DocumentEvent;
import org.w3c.dom.svg.SVGDocument;
import org.w3c.dom.svg.SVGSVGElement;

import test.languageloading.MDRUpdaterElement;
import utils.AWK;
import utils.UniqIdCreator;
import dopidom.Component;
import dopidom.dom.DOMComponent;
import dopidom.svg.SVGEventPoint;
import event.ComponentCreatedEvent;
import event.CreationEvent;

/**
 * @author fondemen
 *
 * TODO To change the template for this generated type comment go to
 *  * Copyright 2004-2008 Frdric FONDEMENT
 */
public class SVGFileTemplate implements SVGTemplate, Listenable {
	protected static final DocumentLoader documentLoader;
	
	/***********************************
	 * For Listener
	 ***********************************/
	public static final DefaultListenable ComponentCreatedListener = new DefaultListenable();
	private DefaultListenable listenableDelegate = new DefaultListenable();
	
	static {
		documentLoader = new DocumentLoader(new UserAgentAdapter());
	}

	protected final String name;
	protected final File templateFile;
	protected final File iconFile;

	protected transient SVGSVGElement tree = null;
	protected transient SVGSVGElement iconTree = null;
	protected transient Icon icon = null;
	protected transient SVGTemplatePropertyClass propertyClass = null;

	public SVGFileTemplate(final String name, final File template, final File icon) {
		super();
		//assert template != null;
		this.name = name;
		this.templateFile = template;
		this.iconFile = icon;
	}
	
	public String getName() {
		return name;
	}
	
	public File getIconFile() {
		return iconFile;
	}
	
	public File getTemplateFile() {
		return templateFile;
	}
	
	public SVGSVGElement getTree() {
		if (this.tree == null) {
			synchronized (documentLoader) {
				try {
					Document doc = documentLoader.loadDocument(this.getTemplateFile().toURI().toString());
					if (! (doc instanceof SVGDocument))
						throw new RuntimeException("Not an SVG: " + this.getTemplateFile().getAbsolutePath());
					this.tree = ((SVGDocument)doc).getRootElement(); 
				} catch (IOException e) {
					throw new RuntimeException("Problem while reading SVG template file " + this.getTemplateFile().getAbsolutePath(), e);
				}
			}
		}
		return this.tree;
	}
	
	protected SVGSVGElement getIconTree() {
		if (this.getIconFile() != null && this.iconTree == null) {
			synchronized (documentLoader) {
				try {
					Document doc = documentLoader.loadDocument(this.getIconFile().toURI().toString());
					if (! (doc instanceof SVGDocument))
						throw new RuntimeException("Not an SVG: " + this.getIconFile().getAbsolutePath());
					this.iconTree = ((SVGDocument)doc).getRootElement(); 
				} catch (IOException e) {
					throw new RuntimeException("Problem while reading SVG icon file " + this.getIconFile().getAbsolutePath(), e);
				}
			}
		}
		return this.iconTree;
	}
	
	private Component[] cloneFromDocument (SVGSVGElement container, SVGSVGElement template) {
		try {
		SVGOMSVGElement clone = (SVGOMSVGElement)template.cloneNode(true);
		deepSetUid(clone, UniqIdCreator.uniqid());
		deepSetDocument(clone, container.getOwnerDocument());

		Node e = (Node)clone.getFirstChild();		
		
		ArrayList dom = new ArrayList();
		Component c;
		while (e != null) {
			dom.add(e);
			container.appendChild(e);
			e = clone.getFirstChild();
		}
		ArrayList ret = new ArrayList();
		for (Iterator it = dom.iterator(); it.hasNext();) {
			e = (Node) it.next();
			if (e instanceof Element) {
				DOMComponent.getFactory().newComponent((Element)e);
				SVGEventPoint.getFactory().newEventPoint((Element)e);
				c = (Component)DOMComponent.getFactory().newComponent((Element)e);
				if (c != null)
					ret.add(c);
			}
		}
		return (Component[])ret.toArray(new Component[ret.size()]);
		} catch (Throwable x) {return null;}
	}
	
	protected static void deepSetDocument (Node n, Document doc) {
		if (n instanceof ExtendedNode)
			((ExtendedNode)n).setOwnerDocument(doc);
		Node ns = n.getNextSibling(), fs = n.getFirstChild();
		if (ns != null)
			deepSetDocument(ns, doc);
		if (fs != null)
			deepSetDocument(n.getFirstChild(), doc);
		NamedNodeMap attrs = n.getAttributes();
		if (attrs != null) {
			Node at; int length = attrs.getLength();
			for (int i = 0; i< length ; ++i){
				at = attrs.item(i);
				deepSetDocument(at, doc);
			}
		}
		
	}
	
	protected static void deepSetUid(Node n, String uid) {
		String s;
		if (n instanceof Attr) {
			s = ((Attr)n).getValue();
			if (s.indexOf("$$") != -1)
				try {
					((Attr)n).setValue(AWK.replace(s, "$$", uid));
				} catch (Exception e) {
					e.printStackTrace();
				}
		}
		if (n instanceof CharacterData) {
			s = ((CharacterData)n).getNodeValue();
			if (s.indexOf("$$") != -1)
				try {
					((CharacterData)n).setNodeValue(AWK.replace(s, "$$", uid));
				} catch (Exception e) {
					e.printStackTrace();
				}
		}
		
		NamedNodeMap atts = n.getAttributes();
		if (atts != null)
			for (int i = 0; i < atts.getLength(); ++i) {
				deepSetUid(atts.item(i), uid);
			}
		
		Node ns = n.getNextSibling(), fs = n.getFirstChild();
		if (ns != null)
			deepSetUid(ns, uid);
		if (fs != null)
			deepSetUid(n.getFirstChild(), uid);
	}
	
	/**
	 * Returns the Component for the last element found in the template.
	 */
	public Component[] createElement(SVGSVGElement container,
			SVGTemplateProperties properties)
			throws SVGTemplatePropertyException {
		this.getPropertyClass().validate(properties);
		
		return this.cloneFromDocument(container, this.getTree());
	}
	
	/**
	 * May return null if no icon has been defined.
	 * @param container
	 * @return
	 */
	public void createIcon(SVGSVGElement container) {
		SVGSVGElement it = this.getIconTree();
		if (it != null) {
			this.cloneFromDocument(container, it);
		}
	}
	
	public Icon getIcon() {
		if (this.getIconTree() != null && this.icon == null) {	
			try {
				PNGTranscoder t = new PNGTranscoder();
				ByteArrayOutputStream img = new ByteArrayOutputStream();
				t.transcode(new TranscoderInput(new FileInputStream(this.getIconFile())), new TranscoderOutput(img));
				this.icon = new ImageIcon(img.toByteArray());
			} catch (FileNotFoundException e) {
				System.err.println("Problem while rendering the icon for " + this.getName() + ":");
				e.printStackTrace();
			} catch (TranscoderException e) {
				System.err.println("Problem while rendering the icon for " + this.getName() + ":");
				e.printStackTrace();
			}
			
		}
		return this.icon;
	}

	/* (non-Javadoc)
	 * @see test.templates.SVGTemplate#getPropertyClass()
	 */
	public SVGTemplatePropertyClass getPropertyClass() {
		// TODO Auto-generated method stub
		if (this.propertyClass == null) {
			this.propertyClass = new DefaultSVGTemplatePropertyClass(new DefaultSVGTemplateProperties(new String [0]));
		}
		return this.propertyClass;
	}
	
	/***********************************
	 * For Listener
	 ***********************************/
	
	public void addListener(Listener l) {
		this.listenableDelegate.addListener(l);
	}

	public void removeListener(Listener l) {
		this.listenableDelegate.removeListener(l);
	}

	public void fireEvent(Event e) throws UncheckedEventException {
		this.listenableDelegate.fireEvent(e);
	}

	public void checkEvent(Event e) {
		this.listenableDelegate.checkEvent(e);
	}

	public boolean testAndFireEvent(Event e) {
		return this.listenableDelegate.testAndFireEvent(e);
	}

}
