/*
 * Created on 25 nov. 2004
 *
 *  * Copyright 2004-2008 Frdric FONDEMENT
 */
package test.templates;

/**
 * @author fondemen
 *
 *  * Copyright 2004-2008 Frdric FONDEMENT
 */
public class UnknownSVGTemplatePropertyException extends SVGTemplatePropertyException {
	protected static String getMessage(String unknownShapeProperty, SVGTemplatePropertyClass validProperties, SVGTemplate shape) {
		return unknownShapeProperty + " unknown shape property.";
	}
	
	protected final String unknownProperty;
	protected final SVGTemplatePropertyClass validProperties;
	protected final SVGTemplate shape;
	
	protected UnknownSVGTemplatePropertyException(String unknownShapeProperty, SVGTemplatePropertyClass validProperties, SVGTemplate shape) {
		super(getMessage(unknownShapeProperty, validProperties, shape));
		this.unknownProperty = unknownShapeProperty;
		this.validProperties = validProperties;
		this.shape = shape;
	}
	
	protected UnknownSVGTemplatePropertyException(String unknownShapeProperty, SVGTemplatePropertyClass validProperties, SVGTemplate shape, Throwable cause) {
		super(getMessage(unknownShapeProperty, validProperties, shape), cause);
		this.unknownProperty = unknownShapeProperty;
		this.validProperties = validProperties;
		this.shape = shape;
	}
	
	public UnknownSVGTemplatePropertyException(String unknownShapeProperty, SVGTemplatePropertyClass validProperties) {
		this(unknownShapeProperty, validProperties, (SVGTemplate)null);
	}

	public UnknownSVGTemplatePropertyException(String unknownShapeProperty, SVGTemplate shape) {
		this(unknownShapeProperty, shape.getPropertyClass(), shape);
	}
	
	public UnknownSVGTemplatePropertyException(String unknownShapeProperty, SVGTemplatePropertyClass validProperties, Throwable cause) {
		this(unknownShapeProperty, validProperties, null, cause);
	}

	public UnknownSVGTemplatePropertyException(String unknownShapeProperty, SVGTemplate shape, Throwable cause) {
		this(unknownShapeProperty, shape.getPropertyClass(), shape, cause);
	}

	public String getUnknownProperty() {
		return unknownProperty;
	}
	public SVGTemplate getShape() {
		return shape;
	}
	public SVGTemplatePropertyClass getValidProperties() {
		return validProperties;
	}
}
