/*
 * Created on Apr 4, 2005
 *
 *  * Copyright 2004-2008 Frdric FONDEMENT
 */
package testFab;

import java.awt.geom.Point2D;
import java.util.LinkedList;
import java.util.StringTokenizer;
import java.util.Vector;

import PBXSComponents.LineHandle;

import utils.AWK;



class SubLine {
	private Point2D point = null;

	private Point2D handle = null;

	private LineHandle lineHandle = null;

	/**
	 * @return Returns the lineHandle.
	 */
	public LineHandle getLineHandle() {
		return lineHandle;
	}

	/**
	 * @param lineHandle
	 *            The lineHandle to set.
	 */
	public void setLineHandle(LineHandle lineHandle) {
		this.lineHandle = lineHandle;
	}

	/**
	 * @param point
	 * @param handle
	 */
	public SubLine(Point2D point, Point2D handle,
			LineHandle lineHandle) {
		this.point = point;
		this.handle = handle;
		this.lineHandle = lineHandle;
	}

	/**
	 * @return Returns the handle.
	 */
	public Point2D getHandle() {
		return handle;
	}

	/**
	 * @param handle
	 *            The handle to set.
	 */
	public void setHandle(Point2D handle) {
		this.handle = handle;
	}

	/**
	 * @return Returns the point.
	 */
	public Point2D getPoint() {
		return point;
	}

	/**
	 * @param point
	 *            The point to set.
	 */
	public void setPoint(Point2D point) {
		this.point = point;
	}
}

class PathStringParser {
	StringTokenizer tokenizer = null;
	String currentToken = null;
	public PathStringParser (StringTokenizer tokenizer) {
		this.tokenizer = tokenizer;
		if (this.tokenizer.hasMoreTokens())
			currentToken = this.tokenizer.nextToken();
		else
			throw new RuntimeException("You must not initialise PathStringParser with an empty stringTokenizer");
	}
	
	public char currentBeginWith () {
		return this.currentToken.charAt(0);
	}
	
	public Vector getSeveralNumbers (int n) {
		Vector numbers = new Vector();
		double pos;

		try {
			pos = Integer.parseInt(this.currentToken);
		} catch (NumberFormatException e) {
			try {
				pos = Integer.parseInt(this.currentToken.substring(1));
			} catch (NumberFormatException e2) {
				throw new RuntimeException ("error in format given to points in path element (d attribute)");
			}
		}
		numbers.add(new Double(pos));
		for (int i = 1; i < n; i++) {
			if (!this.tokenizer.hasMoreTokens())
				throw new RuntimeException("Trying to get more number than the tokenizer have (" + new Integer(n).toString() + " numbers and there is only " + new Integer(i).toString());
			this.currentToken = this.tokenizer.nextToken();
			try {
				pos = Double.parseDouble(this.currentToken);
			} catch (NumberFormatException e) {
				System.err.println("warning : you try to get " + new Integer(i).toString() + " points, but one of them (not the first) begin with a letter");
				try {
					pos = Double.parseDouble(this.currentToken.substring(1));
				} catch (NumberFormatException e2) {
					throw new RuntimeException ("error in format given to points in path element (d attribute)");
				}
			}
			numbers.add(new Double(pos));
		}
		if (this.tokenizer.hasMoreTokens())
			this.currentToken = this.tokenizer.nextToken();
		return numbers;
	}
	
	public boolean hasMoreTokens () {
		return this.tokenizer.hasMoreTokens();
	}
	
}

public class ClassTester {


	public void setPathString (String d) {
		LinkedList newList = new LinkedList();
		Vector list;
		d = AWK.replace(d, ",", " ");
		PathStringParser parser = new PathStringParser(new StringTokenizer (d, " "));
		char prefix = parser.currentBeginWith();
		while (parser.hasMoreTokens()) {
			if (!Character.isDigit(parser.currentBeginWith()))
				prefix = parser.currentBeginWith();
			switch (prefix) {
			case 'm':
			case 'M':
				list = parser.getSeveralNumbers(2);
				newList.add(new SubLine(new Point2D.Double(((Double)list.get(0)).doubleValue(), ((Double)list.get(1)).doubleValue()), null, null));
				break;
			case 's':
			case 'S':
				list = parser.getSeveralNumbers(4);
				newList.add(new SubLine(new Point2D.Double(((Double)list.get(2)).doubleValue(), ((Double)list.get(3)).doubleValue()), new Point2D.Double(((Double)list.get(0)).doubleValue(), ((Double)list.get(1)).doubleValue()), null));
				break;
			default :
				throw new RuntimeException ("error in format given to points in path element (d attribute)");
			}
		}
	}
	public void test() {
		setPathString ("M337, 499 S449, 359 415, 242 ");
	}
	
	public static void main(String[] args) {

		new ClassTester().test();
		
	}
}
