/*
 * Created on 25 nov. 2004
 *
 *  * Copyright 2004-2008 Frdric FONDEMENT
 */
package testFab;

import interactions.Attacher;
import interactions.CaretManager;
import interactions.Deleter;
import interactions.Executer;
import interactions.Loader;
import interactions.Printer;
import interactions.Saver;
import interactions.Selector;
import interactions.Slider;
import interactions.Tester;
import interactions.Translater;

import java.awt.Color;
import java.awt.Point;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseEvent;
import java.lang.reflect.Constructor;
import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;
import java.util.Arrays;
import java.util.Date;
import java.util.List;
import java.util.Random;

import javax.swing.JMenuItem;
import javax.swing.JOptionPane;
import javax.swing.JPopupMenu;

import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.events.Event;
import org.w3c.dom.events.EventListener;
import org.w3c.dom.svg.SVGSVGElement;

import test.selection.SelectionManager;
import test.templates.DefaultSVGTemplateProperties;
import test.templates.SVGTemplateProperties;
import test.templates.SVGTemplatePropertyException;
import test.templates.test.RectTemplate;
import utils.AWK;
import dopidom.Action;
import dopidom.ActionInterface;
import dopidom.Component;
import dopidom.Query;
import dopidom.QueryInterface;
import dopidom.svg.SVGCleanToolInteractor;
import dopidom.svg.SVGScene;

/**
 * @author fondemen
 *
 *  * Copyright 2004-2008 Frdric FONDEMENT
 */
public class Pointer extends  SVGCleanToolInteractor {
	
	public Pointer(Element wrappedElement) {
		super(wrappedElement);
		new Tester(this);
		new Slider(this);
		new Executer(this);
		new CaretManager(this);
		new Selector(this);
		new Translater(this);
		new Attacher(this);
		new Saver(this);
		new Loader(this);
		new Printer(this);
		new Deleter(this);
		
		// FIXME:Enlever l'initialisation des listener ici !!
		SVGSVGElement root = SVGScene.getInstance().getCanvas().getSVGDocument().getRootElement();
		root.addEventListener("DOMNodeInserted", new EventListener () {
			protected volatile boolean appending = false; 

			public void handleEvent(Event evt) {
					if (appending)
						return;
					appending = true;
					if (evt.getCurrentTarget() == getWrappedElement().getParentNode())
						((Node)evt.getCurrentTarget()).appendChild(getWrappedElement());
					appending = false;
			}}, false);
	}
	
	public void mousePressed(MouseEvent event) {
		super.mousePressed(event);
		/*SVGPicking picking = SVGScene.getInstance().getPickedElementsUnder(event.getX(), event.getY(), this.getWrappedElement());
		System.out.println(picking.getComponent().getWrappedElement().getAttribute("id"));*/
		if (event.getClickCount() > 1) {
			switch (event.getButton()) {
			//case MouseEvent.BUTTON1 : this.addBasicShape(event.getX(), event.getY()); break;
			}
		} else {
			switch (event.getButton()) {
			case MouseEvent.BUTTON3 : hidePopup(); showPopup(event.getX(), event.getY()); break;
			default: hidePopup();
			}
		}		
	}

	private final JPopupMenu popup = new JPopupMenu("Popup");
	
	private void showPopup(int x, int y) {
		final Component p = SelectionManager.INSTANCE.getSelectedComponent();
		popup.removeAll();
		
		if (p != null) {
			System.out.println("show popup:");
			ActionInterface [] ais = p.getActionInterfaces();
			if (ais != null && ais.length > 0)
			for (int i = 0; i < ais.length; i++) {
				final ActionInterface itf = ais[i];
				String actionName = AWK.lastFieldOf(itf.getAction().getName(), ".");
				System.out.println("    " + actionName);
				try {
					final Constructor defaultConstructor = itf.getAction().getConstructor(new Class[0]);
					JMenuItem item = new JMenuItem(actionName); 
					popup.add(item);
					item.addActionListener(new ActionListener() {
						public void actionPerformed(ActionEvent e) {
							try {
								Action a = (Action)itf.getAction().newInstance();
								itf.beginInteraction();
								itf.doAction(a);
								itf.endInteraction();
							} catch (InstantiationException e1) {
								e1.printStackTrace();
							} catch (IllegalAccessException e1) {
								e1.printStackTrace();
							} finally {
								hidePopup();
							}
						}
					});
				} catch (NoSuchMethodException ex) {
				}
			}
			QueryInterface [] qis = p.getQueryInterfaces();
			if (qis != null && ais.length > 0)
				for (int i = 0; i < qis.length; i++) {
					final QueryInterface itf = qis[i];
					final String queryName = AWK.lastFieldOf(itf.getQuery().getName(), ".");
					System.out.println("    " + queryName);
					try {
						final Constructor defaultConstructor = itf.getQuery().getConstructor(new Class[0]);
						JMenuItem item = new JMenuItem(queryName); 
						popup.add(item);
						item.addActionListener(new ActionListener() {
							public void actionPerformed(ActionEvent e) {
								try {
									Query q = (Query)itf.getQuery().newInstance();
									itf.doQuery(q);
									StringBuffer sb = new StringBuffer();
									Method [] ms = itf.getQuery().getMethods();
									boolean gotProperty = false;
									for (int i = 0; i < ms.length; ++i) {
										String msName = ms[i].getName();
										List unacceptedNames = Arrays.asList(new String [] {"getScope", "getClass", "getQuery"});
										if (ms[i].getParameterTypes().length == 0 && msName.startsWith("get") && !unacceptedNames.contains(msName)) {
											try {
												Object res = ms[i].invoke(q, new Object [0]);
												sb.append(msName.substring(3));
												sb.append(" = "); 
												sb.append(String.valueOf(res));
												sb.append(System.getProperty("line.separator"));
												gotProperty = true;
											} catch (IllegalArgumentException e2) {
												e2.printStackTrace();
											} catch (InvocationTargetException e2) {
												e2.printStackTrace();
											}
										}
											
									}
									if (gotProperty)
										JOptionPane.showMessageDialog(SVGScene.getInstance().getCanvas(), sb.toString(), queryName, JOptionPane.INFORMATION_MESSAGE);
								} catch (InstantiationException e1) {
									e1.printStackTrace();
								} catch (IllegalAccessException e1) {
									e1.printStackTrace();
								} finally {
									hidePopup();
								}
							}
						});
					} catch (NoSuchMethodException ex) {
					}
				}
		}
		if (popup.getComponentCount() > 0) {
			SVGScene.getInstance().getCanvas().add(popup);
			Point cl = SVGScene.getInstance().getCanvas().getLocationOnScreen();
			popup.setLocation(x + cl.x, y + cl.y);
			popup.setVisible(true);
		}
	}

	private void hidePopup() {
		System.out.println("hide popup");
		popup.setVisible(false);
		SVGScene.getInstance().getCanvas().remove(popup);
	}

	private transient Random rg = new Random(new Date().getTime());
	private void addBasicShape(int x, int y) {
		System.out.println("element addition attempt");
		
		SVGTemplateProperties p = new DefaultSVGTemplateProperties();
		p.set("x", new Integer(x));
		p.set("y", new Integer(y));
		p.set("width", new Integer(rg.nextInt(500)));
		p.set("height", new Integer(rg.nextInt(500)));
		p.set("color", new Color[] {new Color(rg.nextInt(256), rg.nextInt(256), rg.nextInt(256), rg.nextInt(256))});
		
		SVGSVGElement root = SVGScene.getInstance().getCanvas().getSVGDocument().getRootElement();
		try {
			new RectTemplate().createElement(root, p);
		} catch (SVGTemplatePropertyException e) {
			e.printStackTrace();
		}
	}
}
