/*
 * Created on May 18, 2005
 *
 * TODO To change the template for this generated file go to
 *  * Copyright 2004-2008 Frdric FONDEMENT
 */
package utils;

import org.w3c.dom.Element;

import dopidom.Component;
import dopidom.dom.DOMComponent;
import dopidom.svg.SVGScene;

/**
 * @author hong
 *
 *  * Copyright 2004-2008 Frdric FONDEMENT
 */
public class ComponentVarPersistant extends VarPersistant {

	Component value;
	/**
	 * @param relatedNode
	 * @param interfaceStr
	 * @param propertyName
	 */
	public ComponentVarPersistant(Element relatedElement, String interfaceStr,
			String propertyName) {
		super(relatedElement, interfaceStr, propertyName);
		
	}

	/* (non-Javadoc)
	 * @see utils.VarPersistant#getValueString()
	 */
	public String getValueString() {
		if (this.filling)
			throw new RuntimeException ("You are trying to get a value that will be changed with InvokeLater (ComponentVarPersistant.getValueString)"); 
		
		if (this.value == null)
			return "";
		
		if (this.value.isDeleted())
			return "";
		
		if (this.value.getWrappedElement().getAttributeNode("id")==null)
			throw new RuntimeException("The element managed by ComponentVarPersistant must have an ID attribute to be reached during loading");			
		return this.value.getWrappedElement().getAttribute("id");
	}

	public void setValueString (String str) {
		/*
		 * Ce qu'on veut faire :
		 * Au chargement, on doit assigner la valeur Component a un Component deja charg en scene. Pour cela on ne dispose
		 * que d'un ID de noeud SVG (y'a t'il une autre mthode pour designer le Component sous forme de string ?)
		 * Probleme : on a l'ID du noeud, et on veut pointer sur le Component dans la scene qui correspond a cet ID, donc
		 * deuc problmes :
		 * 		- (1) comment trouver le pointeur du Component a partir d'un ID SVG
		 * 		- (2) peut etre que le Component n'est pas charg a ce moment la
		 * 
		 * (1) solutions
		 * 		maintenir une table hash : id -> Component dans static InstanceManager
		 * 			a chaque instanciation (pas que par instance Manager), faire l'ajout dans la table de hash
		 * 		trouver un endroit ou tout les composants en scene sont repertoris
		 * (2) solutions
		 * 		faire un wait(), loop, etc..
		 * 		ne designer que le ID, et au moment du get, pcho le Component correspondant au ID (-> prob car on veut deja faire un get avant la fin du chargement dans le meme composant (ex : Link))
		 * 		faire l'association par une mthode qui est lance aprs le chargement de la scne
		 */
		//if (this.filling)
		//	throw new RuntimeException ("You are trying to initialize a value that will be changed with InvokeLater (ComponentVarPersistant.setValueString)"); 
		
		if (str.equalsIgnoreCase("")) {
			this.value = null;
			this.filling = false;
		} else {
			//get the Component after loading
			InstanceManager im = new InstanceManager();
			final String idStr = str;
			final Element eToLoad = (Element)im.getNodeById(str);
			/*this.value = DOMComponent.getFactory().getOwnerComponent(eToLoad);
			if (this.value==null)*/
				//System.err.println("err1");
				SVGScene.getInstance().invokeLater(new Runnable() {
	
					public void run() {
						ComponentVarPersistant.this.value = DOMComponent.getFactory().getOwnerComponent(eToLoad);
						ComponentVarPersistant.this.filling = false;
						if (ComponentVarPersistant.this.value==null)
							throw new RuntimeException ("Error when loading a Component (invokeLater) supposed to be in the scene from an ID : " + idStr);
						else
							ComponentVarPersistant.this.firePropertyChangeEvent(true, null, ComponentVarPersistant.this.value);
					}
					});
			/*else
				ComponentVarPersistant.this.filling = false;*/

		}
		// TODO : faire un update node ? normalement pas besoin car on utilise setValueString kan on viens de lire les params du node...
		// et si on detecte aucun parametre, il fait un setValueString(""), c'est qui ne devrais pas crer de update value (et par consequent d'attributs parametres)
	}

	public void set (Component c) {
		if (c != null && c.isDeleted())
			c= null;
		if (this.filling)
			throw new RuntimeException ("You are trying to modify a value that will be changed with InvokeLater (ComponentVarPersistant.Set)");
		if (c != null) {
			Element elem = c.getWrappedElement();
			if (elem.getAttributeNode("id")==null) {
				System.err.println("you  are setting a Component whose Element doesn't have an ID : " + c.toString());
				String newId = IdManager.generateNewId(c);
				System.err.println("new Id assigned : " + newId);			
				elem.setAttribute("id", newId);
			}
		}
		Component oldC = this.value;
		this.value = c;
		super.updateNode();
		this.firePropertyChangeEvent(false, oldC, this.value);
	}
	
	public Component get() {
		if (this.filling)
			throw new RuntimeException ("You are trying to get a value that will be changed with InvokeLater (ComponentVarPersistant.Get)");
		if (this.value != null && this.value.isDeleted())
			this.set(null);
		return this.value;
	}
	
	/* (non-Javadoc)
	 * @see utils.VarPersistant#isSet()
	 */
	public boolean isSet() {
		return get() != null;
	}

}
