/*
 * Created on 13 dc. 2004
 *
 * To change the template for this generated file go to
 * Window - Preferences - Java - Code Generation - Code and Comments
 */
package utils;

import java.io.File;
import java.io.IOException;
import java.net.MalformedURLException;
import java.net.URL;

/**
 * @author fondemen
 *
 * To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Generation - Code and Comments
 */
public final class Directories {
    private Directories() {}


    /**
     * Returns the jar file which contains that class 
	 * @param fromClass
	 * @return File
	 */
	public static File getJar (Class fromClass) {
        String thisClassName = ClassLoader.getSystemResource(fromClass.getName().replace('.', '/') + ".class").getFile();
        if (thisClassName.startsWith("file:")) {
            int index = thisClassName.indexOf("!");
            if (index < 0)      // Should not happen, we are in a jar
                thisClassName = thisClassName.substring(5);                     // Eliminate file:
            else
                thisClassName = thisClassName.substring(5, index);              // Eliminate file: and the class part
            try {
                thisClassName = java.net.URLDecoder.decode(thisClassName,"ISO-8859-1");
            } catch (Exception ex) {
            }
            return new File(thisClassName);
        }
        else {
            return null;
        }
    }


    /**Get the folder where the program is installed, class or jar
     */
    public static File getInstallPath (Class forClass) {
    	String ret = System.getProperty("Directories.RootPath");
    	if (ret != null && ret.length() > 0)
    		return new File(ret);
    	java.net.URL theURL = ClassLoader.getSystemResource(forClass.getName().replace('.', '/') + ".class");
    	
    	if (theURL == null) 
    	{ 	// unable to retreve the class in this context, 
    		// may be trying the getRootPath that get a ClasLoader in its parameters ?
    		System.err.println("Unable to retrieve RootPath form either the system property \"Directories.RootPath\" or from this resource: " + forClass.getName());
    		
    		return null;	
    	}
        String thisClassName = theURL.getFile();
        if (thisClassName.startsWith("file:")) {
            int index = thisClassName.indexOf("!");
            if (index < 0)      // Should not happen, we are in a jar
                thisClassName = thisClassName.substring(5);                     // Eliminate file:
            else
                thisClassName = thisClassName.substring(5, index);              // Eliminate file: and the class part
            try {
                thisClassName = java.net.URLDecoder.decode(thisClassName,"ISO-8859-1");
            } catch (Exception ex) {
            }
        }
        else {
            String path = new File(thisClassName).getAbsolutePath();
            int length = AWK.numberOfFieldOf(forClass.getName(), ".");
            for (int i = 1; i < length; ++i)
                path = AWK.eliminateLastFieldOf(path, File.separator);
            thisClassName = path;
        }
        File thisFile = new File(thisClassName);
        
        return thisFile.getParentFile();
    }

	/**
	 * Finds the user directory (from the system property/environment)
	 * @return File
	 */
	public static File getUserPath () {
		File ret = new File(System.getProperty("user.home"));
		if (! ret.exists())
			ret.mkdirs();
		return ret;
	}

    /**
     * Returns the jar file which contains that class 
	 * @param fromClass
	 * @return File
	 */
	public static File getJar (String fromClass) {
        String thisClassName = ClassLoader.getSystemResource(AWK.replace(fromClass,
                ".", "/") + ".class").getFile();
        if (thisClassName.startsWith("file:")) {
            int index = thisClassName.indexOf("!");
            if (index < 0)      // Should not happen, we are in a jar
                thisClassName = thisClassName.substring(5);                     // Eliminate file:
            else
                thisClassName = thisClassName.substring(5, index);              // Eliminate file: and the class part
            try {
                thisClassName = java.net.URLDecoder.decode(thisClassName,"ISO-8859-1");
            } catch (Exception ex) {
            }
            return new File(thisClassName);
        }
        else {
            return null;
        }
    }

    /**Get the path where the program is installed, class or jar
     * By fixing the system property Directories.RootPath to the value you want, you can force this method to respond it.
     */
    public static String getRootPath (String fromClass) {
    	String ret = System.getProperty("Directories.RootPath");
    	if (ret != null && ret.length() > 0)
    		return new File(ret).getAbsolutePath();
    	java.net.URL theURL = ClassLoader.getSystemResource(AWK.replace(fromClass,
                ".", "/") + ".class");
    	
    	if (theURL == null) 
    	{ 	// unable to retreve the class in this context, 
    		// may be trying the getRootPath that get a ClasLoader in its parameters ?
    		System.err.println("Unable to retrieve RootPath form either the system property \"Directories.RootPath\" or from this resource: " + fromClass);
    		System.err.println("Please set the system property \"Directories.RootPath\" or from this resource: " + fromClass);
    		
    		return null;	
    	}
        String thisClassName = theURL.getFile();
        if (thisClassName.startsWith("file:")) {
            int index = thisClassName.indexOf("!");
            if (index < 0)      // Should not happen, we are in a jar
                thisClassName = thisClassName.substring(5);                     // Eliminate file:
            else
                thisClassName = thisClassName.substring(5, index);              // Eliminate file: and the class part
            try {
                thisClassName = java.net.URLDecoder.decode(thisClassName,"ISO-8859-1");
            } catch (Exception ex) {
            }
        }
        else {
            thisClassName = AWK.replace(thisClassName, "%20", " ");
            String path = new File(thisClassName).getAbsolutePath();
            int length = AWK.numberOfFieldOf(fromClass,
                    ".");
            for (int i = 1; i < length; ++i)
                path = AWK.eliminateLastFieldOf(path, File.separator);
            thisClassName = path;
        }
        File thisFile = new File(thisClassName);
        return thisFile.getParent();
    }
    

	/** This method returns the list of filenames in the provided path name. This is done recursivly.
	 * The returned strings are relative to the initial dir
	 */
	static public String[] getFilesFromDirectory (String dir)
	{
		String dirPath = new java.io.File (dir).getAbsolutePath();

		java.util.Vector vec = getFilesAsVectorFromDirectory (dir);
		String[] result = new String[vec.size()];
		for (int i=0; i<result.length; i++)
		{
			result[i] = ((File)vec.get(i)).getAbsolutePath().substring (dirPath.length()+1);
		}
		return result;
	}

	/** This method returns the list of filenames in the provided path name. This is done recursivly.
	 */
	static public java.util.Vector getFilesAsVectorFromDirectory (String dir)
	{
		java.util.Vector result = new java.util.Vector ();
		
		// we get the list of resouces in the provided directory
		java.io.File file = new java.io.File (dir);
		if (file.isDirectory())
		{
			java.io.File filesList[] = file.listFiles();
			for (int i=0; i<filesList.length; i++)
			{
				result.addAll (getFilesAsVectorFromDirectory(filesList[i].getAbsolutePath() ));			
			}
		}
		else if (file.isFile())
		{
			result.add (file);
		}
		return result;
	}
	
	/**
	 * Try to find a resource.<br>
	 * First checks from the root of the surrounding jar archive.<br>
	 * Then checks from the root of the program installation.<br>
	 * And finally checks from the parent from the root installation.<br>
	 * @param location the location of the resource from the searched roots (eg. "/Resources/foo.xml")
	 * @param referenceClasses the classes to be used in order to locate the jar or classes of the application ; if empty, the JMIRepositoryProvider class
	 * @return a file corresponding to the resource, ie. a file that can be readen
	 */
	public static URL getResource (String location, Class [] referenceClasses) {
		URL res = null;
		File f,r;
		f = new File(location);
		if (f.exists())
			try {
				return f.toURL();
			} catch (MalformedURLException _) {
			}
		if ((referenceClasses == null) || (referenceClasses.length == 0))
			referenceClasses = new Class [] {Directories.class};
		for (int i = 0; (res == null) && (i < referenceClasses.length); ++i) {
			try {
				File jar = Directories.getJar(referenceClasses[i].getName());
				res = jar == null ? null : jar.toURL();
			} catch (MalformedURLException e1) {
				e1.printStackTrace();
			} catch (NullPointerException x) {
			}
			if (res != null) { //we found a jar file
				try {
					res = new URL("jar:"+res.toString()+'!'+'/'+location);
					res.openConnection().connect();
				} catch (IOException x) {
					res = null;
				}
			}
			if (res == null) { //have to check outside of the jar
				r = new File(getRootPath(referenceClasses[i].getName()));
				/*if (res == null)*/ { //implicit
					f = new File(r, location);
					if (f.canRead()/* && f.isFile()*/)
						try {
							res = f.toURL();
						} catch (MalformedURLException e) {
							e.printStackTrace();
						}
				}
				if (res == null) {
					f = new File(r.getParent(), location);
					if (f.canRead()/* && f.isFile()*/)
						try {
							res = f.toURL();
						} catch (MalformedURLException e) {
							e.printStackTrace();
						}
				}
			}
		}
		return res;
	}
}
