/*
 * Created on 21 avr. 2005
 *
 * TODO To change the template for this generated file go to
 *  * Copyright 2004-2008 Frdric FONDEMENT
 */
package utils;

import java.awt.geom.Point2D;

import org.w3c.dom.svg.SVGSVGElement;

import templates.CircleTemplate;
import test.templates.DefaultSVGTemplateProperties;
import test.templates.SVGTemplateProperties;
import test.templates.SVGTemplatePropertyException;
import dopidom.Component;
import dopidom.svg.SVGScene;

/**
 * @author Fabrice H
 *
 *  * Copyright 2004-2008 Frdric FONDEMENT
 */
public class HandleDescription {
	protected Point2D center = null;
	protected double radius = 1;
	protected double strokeWidth;
	protected String fill;
	protected String strokeColor;
	protected String strokeDashArray = null;
	
	/**
	 * @param path
	 * @param color
	 * @param width
	 */

	protected double width = -1;

	/**
	 * @param center
	 * @param circleRadius
	 * @param strokeWidth
	 * @param fill
	 * @param strokeColor
	 * @param width
	 */
	public HandleDescription(Point2D center, double radius, double strokeWidth,
			String fill, String strokeColor) {
		super();
		this.center = center;
		this.radius = radius;
		this.strokeWidth = strokeWidth;
		this.fill = fill;
		this.strokeColor = strokeColor;
	}
	
	public HandleDescription(Point2D center, double radius, double strokeWidth,
			String fill, String strokeColor, String strokeDashArray) {
		super();
		this.center = center;
		this.radius = radius;
		this.strokeWidth = strokeWidth;
		this.fill = fill;
		this.strokeColor = strokeColor;
		this.strokeDashArray = strokeDashArray;
	}
	
	public Component createCircle() {
		SVGTemplateProperties p = new DefaultSVGTemplateProperties();
		p.set("cx", new Double(this.center.getX()));
		p.set("cy", new Double(this.center.getY()));
		p.set("r", new Double(this.radius));
		p.set("fill", this.fill);
		p.set("stroke-width", new Double(this.strokeWidth));
		p.set("stroke", this.strokeColor);
		if (this.strokeDashArray==null)
			p.set("stroke-dasharray", "");
		else
			p.set("stroke-dasharray", this.strokeDashArray);
		SVGSVGElement root = SVGScene.getInstance().getCanvas().getSVGDocument().getRootElement();
		Component s = null;
		try {
			CircleTemplate t = new CircleTemplate();
			t.setClasse("PBXSComponents.LineHandle");
			s = t.createElement(root, p)[0];
		} catch (SVGTemplatePropertyException e) {
			e.printStackTrace();
		}
		root.appendChild(s.getWrappedElement());
		System.out.println("New element created  " + s);
		return s;
	}

}	

