/*
 * Created on May 18, 2005
 *
 * TODO To change the template for this generated file go to
 *  * Copyright 2004-2008 Frdric FONDEMENT
 */
package utils;

import org.w3c.dom.Element;

/**
 * @author hong
 *
 *  * Copyright 2004-2008 Frdric FONDEMENT
 */
public class IntVarPersistant extends VarPersistant {

	Integer value;
	/**
	 * @param relatedNode
	 * @param interfaceStr
	 * @param propertyName
	 */
	public IntVarPersistant(Element relatedElement, String interfaceStr,
			String propertyName) {
		super(relatedElement, interfaceStr, propertyName);
		
	}

	/* (non-Javadoc)
	 * @see utils.VarPersistant#getValueString()
	 */
	public String getValueString() {
		if (this.filling)
			throw new RuntimeException ("You are trying to get a value that will be changed with InvokeLater (IntVarPersistant.getValueString)"); 
		if (this.value != null)
			return this.value.toString();
		else
			return "";
	}

	public void setValueString (String str) {
		//if (this.filling)
		//	throw new RuntimeException ("You are trying to set a value that will be changed with InvokeLater (IntVarPersistant.setValueString)"); 
		if (str.equalsIgnoreCase(""))
			this.value = null;
		else {
			Integer newInt = new Integer(Integer.parseInt(str));
			if (newInt == null)
				throw new RuntimeException ("In IntVarPersistant, trying to parse a string value in the parameters, that doesn't represent a Integer !");
			this.value = newInt;
			this.filling = false;
			this.firePropertyChangeEvent(true, null, newInt);
		}
	}

	public void set (int i) {
		if (this.filling)
			throw new RuntimeException ("You are trying to set a value that will be changed with InvokeLater (IntVarPersistant.set)");
		Integer oldI = this.value;
		this.value = new Integer(i);
		super.updateNode();
		this.firePropertyChangeEvent(false, oldI, this.value);
	}

	public int get() {
		if (this.filling)
			throw new RuntimeException ("You are trying to get a value that will be changed with InvokeLater (IntVarPersistant.get)"); 
		return this.value.intValue();
	}

	/* (non-Javadoc)
	 * @see utils.VarPersistant#isSet()
	 */
	public boolean isSet() {
		return value != null;
	}

}
