/*
 * Created on 21 avr. 2005
 *
 * TODO To change the template for this generated file go to
 *  * Copyright 2004-2008 Frdric FONDEMENT
 */
package utils;

import java.awt.geom.Point2D;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.Random;
import java.util.StringTokenizer;
import java.util.Vector;

import org.w3c.dom.svg.SVGSVGElement;

import PBXSComponents.LineHandle;

import templates.PathTemplate;
import test.templates.DefaultSVGTemplateProperties;
import test.templates.SVGTemplateProperties;
import test.templates.SVGTemplatePropertyException;
import dopidom.Component;
import dopidom.svg.SVGScene;

/**
 * @author Fabrice H
 * 
 * TODO To change the template for this generated type comment go to Window -
 * Preferences - Java - Code Style - Code Templates
 */

class SubLine {
	private Point2D point = null;

	private Point2D handle = null;

	private LineHandle lineHandle = null;

	/**
	 * @return Returns the lineHandle.
	 */
	public LineHandle getLineHandle() {
		return lineHandle;
	}

	/**
	 * @param lineHandle
	 *            The lineHandle to set.
	 */
	public void setLineHandle(LineHandle lineHandle) {
		this.lineHandle = lineHandle;
	}

	/**
	 * @param point
	 * @param handle
	 */
	public SubLine(Point2D point, Point2D handle,
			LineHandle lineHandle) {
		this.point = point;
		this.handle = handle;
		this.lineHandle = lineHandle;
	}

	/**
	 * @return Returns the handle.
	 */
	public Point2D getHandle() {
		return handle;
	}

	/**
	 * @param handle
	 *            The handle to set.
	 */
	public void setHandle(Point2D handle) {
		this.handle = handle;
	}

	/**
	 * @return Returns the point.
	 */
	public Point2D getPoint() {
		return point;
	}

	/**
	 * @param point
	 *            The point to set.
	 */
	public void setPoint(Point2D point) {
		this.point = point;
	}
}

class PathStringParser {
	StringTokenizer tokenizer = null;
	String currentToken = null;
	public PathStringParser (StringTokenizer tokenizer) {
		this.tokenizer = tokenizer;
		if (this.tokenizer.hasMoreTokens())
			this.currentToken = this.tokenizer.nextToken();
		else
			this.currentToken = "";
	}
	
	public char currentBeginWith () {
		if (this.currentToken.length()>0)
			return this.currentToken.charAt(0);
		else
			return ' ';
	}
	
	public Vector getSeveralNumbers (int n) {
		Vector numbers = new Vector();
		double pos;

		try {
			pos = Integer.parseInt(this.currentToken);
		} catch (NumberFormatException e) {
			try {
				pos = Integer.parseInt(this.currentToken.substring(1));
			} catch (NumberFormatException e2) {
				throw new RuntimeException ("error in format given to points in path element (d attribute)");
			}
		}
		numbers.add(new Double(pos));
		for (int i = 1; i < n; i++) {
			if (!this.tokenizer.hasMoreTokens())
				throw new RuntimeException("Trying to get more number than the tokenizer have (" + new Integer(n).toString() + " numbers and there is only " + new Integer(i).toString());
			this.currentToken = this.tokenizer.nextToken();
			try {
				pos = Double.parseDouble(this.currentToken);
			} catch (NumberFormatException e) {
				System.err.println("warning : you try to get " + new Integer(i).toString() + " points, but one of them (not the first) begin with a letter");
				try {
					pos = Double.parseDouble(this.currentToken.substring(1));
				} catch (NumberFormatException e2) {
					throw new RuntimeException ("error in format given to points in path element (d attribute)");
				}
			}
			numbers.add(new Double(pos));
		}
		if (this.tokenizer.hasMoreTokens())
			this.currentToken = this.tokenizer.nextToken(); 
		return numbers;
	}
	
	public boolean hasMoreTokens () {
		return this.tokenizer.hasMoreTokens();
	}
	
}

public class LineDescription {
	//	protected PointsDescription path = null;
	protected LinkedList path = new LinkedList();

	protected String color = null;


	protected double width = -1;

	/**
	 * @param path
	 * @param color
	 * @param width
	 */
	public LineDescription () {
	}
	public LineDescription(String color, double width) {
		this.color = color;
		this.width = width;
	}

	public boolean isValid() {
		if (this.path == null) {
			System.err.println("You have to set the PointsDescription (path)");
			return false;
		}
		if (this.color == null) {
			System.err.println("You must set the color of the link !");
			return false;
		}
		if (this.width == -1) {
			System.err.println("You must set the width of the link !");
			return false;
		}
		return true;
	}

	public int addPoint(Point2D pt, Point2D hn,
			LineHandle lineHandle) {
		int index;
		SubLine newSub = new SubLine(pt, hn, lineHandle);
		this.path.add(newSub);
		index = this.path.indexOf(newSub);
		if (lineHandle != null)
			lineHandle.setHIndex(index);
		return index;
	}

	public String getPathString() {
		String result = new String();
		if (this.path.isEmpty())
			return result;
		Iterator it = this.path.iterator();
		Point2D handle = null;
		Point2D point = ((SubLine) it.next()).getPoint();
		result = result.concat("M"
				+ new Integer(((int) point.getX())).toString() + ", "
				+ new Integer(((int) point.getY())).toString() + " ");
		while (it.hasNext()) {
			SubLine currentSubLine = (SubLine) it.next();
			handle = currentSubLine.getHandle();
			point = currentSubLine.getPoint();
			if (handle == null) //straight line
				result = result.concat("L"
						+ new Integer((int) point.getX()).toString() + ", "
						+ new Integer((int) point.getY()).toString() + " ");
			else
				result = result.concat("S"
						+ new Integer((int) handle.getX()).toString() + ", "
						+ new Integer((int) handle.getY()).toString() + " "
						+ new Integer((int) point.getX()).toString() + ", "
						+ new Integer((int) point.getY()).toString() + " ");
		}
		return result;
	}
	
	private boolean isNumber (String dStr) {
		try {
			double r = Double.parseDouble(dStr);
		} catch (NumberFormatException e) {
			return false;
		}
		return true;
		
	}
	
	private boolean getM (LinkedList list, int i) {
		if (!((String)list.get(i)).equalsIgnoreCase("M")) {
			System.err.println("setPathString (lineDescription) : M command axpected in the path");
			return false;
		}

		if (!((String)list.get(i)).equalsIgnoreCase("d")) {
			System.err.println("setPathString (lineDescription) : M command axpected in the path");
			return false;
		}
		
		return true;
	}
	public void setPathString (String d) {
		LinkedList newList = new LinkedList();
		Vector list;
		d = AWK.replace(d, ",", " ");
		PathStringParser parser = new PathStringParser(new StringTokenizer (d, " "));
		char prefix = parser.currentBeginWith();
		while (parser.hasMoreTokens()) {
			if (!Character.isDigit(parser.currentBeginWith()))
				prefix = parser.currentBeginWith();
			switch (prefix) {
			case 'm':
			case 'M':
				list = parser.getSeveralNumbers(2);
				newList.add(new SubLine(new Point2D.Double(((Double)list.get(0)).doubleValue(), ((Double)list.get(1)).doubleValue()), null, null));
				break;
			case 's':
			case 'S':
				list = parser.getSeveralNumbers(4);
				newList.add(new SubLine(new Point2D.Double(((Double)list.get(2)).doubleValue(), ((Double)list.get(3)).doubleValue()), new Point2D.Double(((Double)list.get(0)).doubleValue(), ((Double)list.get(1)).doubleValue()), null));
				break;
			default :
				throw new RuntimeException ("error in format given to points in path element (d attribute)");
			}
		}
		this.path = newList;
	}

	public void setPoint(int index, Point2D pt) {
		if (index >= this.path.size()) {
			System.err
					.println("You want to modify a point whose index is out of range !");
			return;
		}
		SubLine sl = (SubLine) path.get(index);
		sl.setPoint(pt);
	}

	public Component createLine() {
		if (!isValid())
			return null;

		Random rg = new Random();
		SVGTemplateProperties p = new DefaultSVGTemplateProperties();
		p.set("d", getPathString());
		p.set("fill", "none");
		p.set("stroke-width", new Double(this.width));
		p.set("stroke", this.color);

		SVGSVGElement root = SVGScene.getInstance().getCanvas().getSVGDocument()
				.getRootElement();
		Component s = null;
		try {
			PathTemplate t = new PathTemplate();
			t.setClasse("PBXSComponents.CurvedLine");
			s = t.createElement(root, p)[0];
		} catch (SVGTemplatePropertyException e) {
			e.printStackTrace();
		}
		root.appendChild(s.getWrappedElement());
		System.out.println("New element created  " + s);
		//((CurvedLine) s).setLineDescription(this);
		return s;
	}

	public void setHandle(int index, Point2D hn) {
		if (index >= this.path.size()) {
			System.err
					.println("You want to modify a point whose index is out of range !");
			return;
		}
		SubLine sl = (SubLine) path.get(index);
		sl.setHandle(hn);
	}

	public Point2D getPoint(int index) {
		if (index >= this.path.size()) {
			System.err
					.println("You want to modify a point whose index is out of range !");
			return null;
		}
		SubLine sl = (SubLine) path.get(index);
		return sl.getPoint();
	}

	public Point2D getHandle(int index) {
		if (index >= this.path.size()) {
			System.err
					.println("You want to modify a point whose index is out of range !");
			return null;
		}
		SubLine sl = (SubLine) path.get(index);
		return sl.getHandle();
	}


	public LineHandle getLineHandle(int index) {
		if (index >= this.path.size()) {
			System.err
					.println("You want to modify a point whose index is out of range !");
			return null;
		}
		SubLine sl = (SubLine) path.get(index);
		return sl.getLineHandle();
	}

	public void setLineHandle(int index, LineHandle lh) {
		// you're supposed to set a lineHandle where there is already a Handle defined
		if (index >= this.path.size()) {
			System.err
					.println("You want to modify a point whose index is out of range !");
			return;
		}
		lh.setHIndex(index);
		if (getHandle(index)==null)
			System.err.println ("warning, you are defining an LineHandle at index '"+new Integer(index).toString()+"', but there is no curve defined here (no handle)!");
		SubLine sl = (SubLine) path.get(index);
		sl.setLineHandle(lh);
	}

	/**
	 * @return Returns the color.
	 */
	public String getColor() {
		return color;
	}

	/**
	 * @param color
	 *            The color to set.
	 */
	public void setColor(String color) {
		this.color = color;
	}

	/**
	 * @return Returns the path.
	 */
	public LinkedList getPath() {
		return path;
	}

	/**
	 * @param path
	 *            The path to set.
	 */
	public void setPath(LinkedList path) {
		this.path = path;
	}

	/**
	 * @return Returns the width.
	 */
	public double getWidth() {
		return width;
	}

	/**
	 * @param width
	 *            The width to set.
	 */
	public void setWidth(double width) {
		this.width = width;
	}
}

