/*
 * Created on May 18, 2005
 *
 * TODO To change the template for this generated file go to
 *  * Copyright 2004-2008 Frdric FONDEMENT
 */
package utils;

import java.util.Vector;

import org.w3c.dom.Element;

import dopidom.Component;
import dopidom.dom.DOMComponent;
import dopidom.svg.SVGScene;

/**
 * @author hong
 *
 *  * Copyright 2004-2008 Frdric FONDEMENT
 */
public class ListCVarPersistant extends VarPersistant {

	Vector value;
	/**
	 * @param relatedNode
	 * @param interfaceStr
	 * @param propertyName
	 */
	public ListCVarPersistant(Element relatedElement, String interfaceStr,
			String propertyName) {
		super(relatedElement, interfaceStr, propertyName);
		if (this.value == null)
			this.value = new Vector();
	}

	/* (non-Javadoc)
	 * @see utils.VarPersistant#getValueString()
	 */
	public String getValueString() {
		if (this.filling)
			throw new RuntimeException ("You are trying to get a value that will be changed with InvokeLater (ListCVarPersistant.getValueString)"); 
		String stringVal = "";
		for (int i = 0; i < value.size(); i++) {
			Element e = ((Component)this.value.get(i)).getWrappedElement();
			if (e.getAttributeNode("id")==null) {
				String newId = IdManager.generateNewId((Component)this.value.get(i)); //TODO: maybe something here to do with the new generated Id
				e.setAttribute("id", newId);
			}
			stringVal = stringVal + e.getAttribute("id");
			if (i!=value.size()-1)
				stringVal = stringVal + ",";
		}
		return stringVal;
	}

	/* (non-Javadoc)
	 * @see utils.VarPersistant#setValueString(java.lang.String)
	 */
	
	public void setValueString(String str) {
		//if (this.filling)
		//	throw new RuntimeException ("You are trying to initialize a value that will be changed with InvokeLater (ListCVarPersistant.setValueString)");
		this.value = new Vector(); 
		if (str.equalsIgnoreCase("")) {
			return;
		}
		String toParse = AWK.replace(str, " ", "");
		final String strArray[] = toParse.split(",");
		
			//get the Component after loading
		SVGScene.getInstance().invokeLater(new Runnable() {

			public void run() {
				for (int i = 0; i<strArray.length; i++) {
					
					//System.err.println ("WARNING : TESTING ListCVarPersistant line 110\ndoes the final value always the same ?");
					InstanceManager im = new InstanceManager();
					Element el = (Element)im.getNodeById(strArray[i]);
					
					Component c = DOMComponent.getFactory().getOwnerComponent(el);						
					if (c!=null)
						ListCVarPersistant.this.addWhileFilling(c);
					else
						throw new RuntimeException ("Error when loading a Component (invokeLater) supposed to be in the scene from an ID : " + strArray[i]);
				}
				ListCVarPersistant.this.filling = false;
				ListCVarPersistant.this.firePropertyChangeEvent(true, null, ListCVarPersistant.this.value);
			}});		
		}		
	
	
	public void set (Vector v) {
		if (this.filling)
			throw new RuntimeException ("You are trying to set a value that will be changed with InvokeLater (ListCVarPersistant.set)");
		Vector oldL = this.value;
		this.value = v;
		super.updateNode();
		this.firePropertyChangeEvent(false, oldL, this.value);
	}

	protected void cleanDeletedComponents() {
		Vector<Component> removed = new Vector(this.value.size());
		for (Object c : this.value) {
			if (c instanceof Component)
				if (((Component)c).isDeleted())
					removed.add((Component)c);
		}
		for (Component c : removed) {
			this.remove(c);
		}
	}

	/* (non-Javadoc)
	 * @see utils.VarPersistant#setValueString(java.lang.String)
	 */
	
	public int size () {
		this.cleanDeletedComponents();
		return this.value.size();
	}
	
	public Object get(int i) {
		this.cleanDeletedComponents();
		if (this.filling)
			throw new RuntimeException ("You are trying to get a value that will be changed with InvokeLater (ListCVarPersistant.get)"); 
		return this.value.get(i);
	}
	
	public void remove (Object obj) {
		if (this.filling)
			throw new RuntimeException ("You are trying to modify a value that will be changed with InvokeLater (ListCVarPersistant.remove)"); 
		if (this.value.contains(obj)) {
			this.value.remove(obj);
			this.cleanDeletedComponents();
			super.updateNode();
		}
	}
	public boolean contains (Object obj) {
		if (this.filling)
			throw new RuntimeException ("You are trying to get an information on a value that will be changed with InvokeLater (ListCVarPersistant.contains)");
		this.cleanDeletedComponents(); 
		return this.value.contains(obj);
	}
	
	protected boolean addWhileFilling(Component obj) {
		if(!this.value.contains(obj))
			return this.value.add(obj);
		else
			return false;
	}
	
	public boolean add(Object obj) {
		if (this.filling)
			throw new RuntimeException ("You are trying to modify a value that will be changed with InvokeLater (ListCVarPersistant.add)");
		if ((obj instanceof Component) && ((Component)obj).isDeleted())
			return false;
		Vector oldV = new Vector(this.value);
		boolean ret = this.value.add(obj);
		if (ret) {
			super.updateNode();
			this.firePropertyChangeEvent(false, oldV, this.value);
		}
		return ret;
	}
	
	public Vector getVector () {
		if (this.filling)
			throw new RuntimeException ("You are trying to get a value that will be changed with InvokeLater (ListCVarPersistant.getVector)");
		this.cleanDeletedComponents();
		return this.value;
	}

	/* (non-Javadoc)
	 * @see utils.VarPersistant#isSet()
	 */
	public boolean isSet() {
		return value != null;
	}
	
}
