package utils;

import java.util.ArrayList;
import java.util.Comparator;
import java.util.List;
import java.util.Set;
import java.util.TreeMap;
import java.util.TreeSet;

import org.netbeans.api.xmi.XMIReferenceResolver;

public class SelfContainer {

	private TreeMap<String,Object> selfTable;
	private TreeMap<Object, String> invertedTable;
	private static SelfContainer sc;
	
	public static SelfContainer getInstance() {
		if (sc == null) {
			sc = new SelfContainer();
		}
		return sc;
	}
	
	private SelfContainer() {
		this.selfTable = new TreeMap<String,Object>();
		this.invertedTable = new TreeMap<Object,String>(new Comparator<Object> () {

			public int compare(Object o1, Object o2) {
				return o2.hashCode() - o1.hashCode();
			}});
	}

	public Object getSelfByID(String id) {
		return selfTable.get(id);
	}
	
	public void insertSelf(String id, Object ob){
		selfTable.put(id, ob);
		invertedTable.put(ob, id);
	}
	
	public void remove(String id){
		Object o = this.getSelfByID(id);
		if (o != null) {
			selfTable.remove(id);
			invertedTable.remove(o);
		}
	}
	
	public void clear(){
		selfTable.clear();
		invertedTable.clear();
	}
	
	public int size(){
		return selfTable.size();
	}
	
	public boolean containsId(String id){
		return selfTable.containsKey(id);
	}
	
	public boolean containsObject(Object ob){
		return invertedTable.containsKey(ob);
	}
	
	public String getKey(Object o) {
		return invertedTable.get(o);
	}
	
	public TreeMap<String,Object> getTable() {
		return this.selfTable;
	}
}
